
#include "term_types.h"

#include <stdio.h>

void print_term_eker(TERM *t);

void print_tlist(l)
TERM_LIST *l;
{
  while(l){
    print_term_eker(l->arg);
    l = l->next_arg;
    if(l != NULL)
      printf(", ");
  }
}

void print_aclist(l)
AC_LIST *l;
{
  while(l){
    printf("%d*", l->mult);
    print_term_eker(l->arg);
    l = l->next_ac;
    if(l != NULL)
      printf(", ");
  }
}

void print_term_eker(t)
TERM *t;
{
  if(t == NULL){
    printf("(null ptr)");
    return;
  }
  switch(t->type){
  case VARIABLE:
    printf("x%d", t->sym);
    break;
  case CONSTANT:
    printf("a%d", t->sym);
    break;
  case FUNCTION:
    printf("f%d(", t->sym);
    print_tlist(t->rest.f.arg_list);
    printf(")");
    break;
  case COMMUTATIVE:
    printf("c%d(", t->sym);
    print_tlist(t->rest.f.arg_list);
    printf(")");
    break;
  case AC_NORMAL:
    printf("+%d([%d]", t->sym,t->rest.f.list_len);
    print_tlist(t->rest.f.arg_list);
    printf(")");
    break;
  case AC_COMPRESSED:
    printf("*%d(", t->sym);
    print_aclist(t->rest.a.ac_list);
    printf(")");
    break;
  case COM_COMPRESSED:
    printf("d%d(", t->sym);
    print_aclist(t->rest.a.ac_list);
    printf(")");
    break;
  }
}


