(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: specif.ml,v 1.2 2001/04/20 13:42:09 marche Exp $

***************************************************************************)

(***************************************************************************
  
  Ce module permet de manipuler des specifications ordo-sortees dans cime et 
  de les lier aux automates d'arbres.
  
  CiME Project - Dmons research team - LRI - Universit Paris XI
  
  $Id: specif.ml,v 1.2 2001/04/20 13:42:09 marche Exp $

***************************************************************************)
  
open Types
open Tree_automata
open Terms
open Symbols
open Equations
open Matching
open Messages
open Args
   
(*
type kind = Kind of string
  
type atomic_state =  
    FS of  symbol_id *(atomic_state list)
  | VS of sorte_de_base
      
type state = State of (atomic_state list)
*)
  
let print_delta_automata (aaa,delta) =
  
  let print_state_list stl =
    let rec basestate2string = function
	VS x -> base_sorte2string x
      | FS (f,q) -> 
	  (string_of_symbol_id f) ^ "(" ^ 
	  (List.fold_right (fun x y -> x^","^y) (List.map basestate2string  q) "" ) ^ ")"
    in 
    let rec state2string = function
 	State([]) -> ""
      | State(q1::[]) -> (basestate2string q1) ^ " " 
      | State(q1::rst) -> 
	  (basestate2string q1) ^ "/\\" ^ (state2string (State(rst)))  
    in List.iter (fun x -> print_string ((state2string x ) ^ " ")) stl
	 
  in
  let rec print_rule_list = function
      [] -> ()
    | r1::reste -> 
	begin
	  print_state_list ((r1.etats_initiateurs));
	  print_string "--";
	  print_string ((string_of_symbol_id r1.tete));
	  print_string "-->";
	  print_state_list (([r1.etat_final]));
	  print_newline ();
	  print_rule_list reste
	end
  and print_epsilon_list = function
      [] -> ()
    | r1::reste -> 
	begin
	  print_state_list ([r1.initial_state]);
	  print_string "---->";
	  print_state_list ([r1.final_state]);
	  print_newline ();
	  print_epsilon_list reste
	end
  in
    begin
      print_string "\n ***********\n L'automate obtenu a comme etats :\n";
      print_state_list aaa.etats;
      print_string "et comme etats finaux \n";
      print_state_list aaa.etats_finaux ;
      print_string "Les transitions sont \n";
      print_rule_list aaa.regles;
      print_string "et les epsilon-transitions :\n";
      print_epsilon_list aaa.epsilon;
      print_string "Les delta-transitions :\n";
      print_epsilon_list delta;message "\n ***********\n" 
    end 

    
let print_clean_automata (aaa,_) =
  let rec basestate2string = function
      VS x -> base_sorte2string x
    | FS (f,[]) -> string_of_symbol_id f
    | FS (f,[h]) -> (string_of_symbol_id f)^"("^(basestate2string h)^")"
    | FS (f,h::t) -> 
	(string_of_symbol_id f)^"("^
	(basestate2string h)^
	(List.fold_left (fun x y -> x^","^(basestate2string y)) "" t)^")"
  in
  let rec state2string = function
      State([]) -> ""
    | State([q1]) -> (basestate2string q1) ^ " " 
    | State(q1::rst) -> 
	(basestate2string q1) ^ "/\\" ^ (state2string (State(rst)))  
  in   
  let print_state_list stl =
    List.iter 
      (fun x -> 
	 print_string (state2string x);
	 print_string " ") 
      stl
  and print_state_list_with_newline stl = 
    List.iter 
      (fun x -> 
	 print_string (state2string x);
	 print_newline()) 
      stl
  in
  let rec print_rule_list = function
      [] -> ()
    | r1::reste -> 
	begin
	  print_state_list ((r1.etats_initiateurs));
	  print_string "--";
	  print_string ((string_of_symbol_id r1.tete));
	  print_string "-->";
	  print_string (state2string r1.etat_final);
	  print_newline ();
	  print_rule_list reste
	end
  in
    begin
      print_string "\n ***********\n L'automate obtenu a comme etats :\n";
      print_state_list_with_newline aaa.etats;
      print_string "et comme etats finaux \n";
      print_state_list_with_newline aaa.etats_finaux ;
      print_string "Les transitions sont \n";
      print_rule_list aaa.regles;
      message "\n ***********\n" 
    end 
  


let rec basestate2string = function
    VS x -> base_sorte2string x
  | FS(f,q) -> 
      (string_of_symbol_id f) ^ "(" ^ 
      (List.fold_right (fun x y -> x^y) (List.map basestate2string  q) "" ) ^ ")";;

let print_state (State x) =
  let rec print_the_list = function
    | [x] -> print_string x
    | x::y -> 
	print_string (x^"/\\");
	print_the_list y
    | [] -> print_string " "
  in
    print_the_list (List.map basestate2string x);;
      

(* 
   Plus on est vrai plus on affiche des infos 
*)

let verb = options_courantes.niveau_de_verbosite >= 2 ;;
let verbo = options_courantes.niveau_de_verbosite >= 3 ;;

(* 
   prend un symbole et une liste de profiles et construit une liste de regles
   pour l'automate de la signature 
*)  

let rec sy_sortlist_2_rule f = function
    [] -> []
  | s::rst -> 
      (Tree_automata.make_rule 
	 f (List.map (fun x->State[VS(x)]) (sort_body s)) [] 
	 (State[VS(sort_head s)]))::(sy_sortlist_2_rule f rst);;

(* teste si a est dans l *)

let present_dans_liste = List.mem;;

(*  
    Prend un automate et un terme puis renvoie 
    * la liste des etats dans lesquels il est reconnu et 
    * un booleen qui indique si l'un d'eux est un etat final 
*)

let nd_test_final_state auto = function 
    TERM _ as t -> 
      let fnal = Listutils.filter 
		   (function q -> List.mem q auto.etats_finaux) 
		   (nd_run_automata auto t) in
	(fnal,fnal<>[])
  | VAR v -> 
      List.map (fun x -> State [VS (sort_head x)]) (get_sorts_of_variable v),
      false;;
 

(* Used to be L'environnement courant d'un terme pour le cas non ordo-sorte *)
(*let current_Env = ref ([]);;*)

(* 
   Create an environement for a given term in case of a multi-sorted 
   signature.
*)

let create_current_env = 
  let rec reccur_env env = function
      (sorte,(TERM(f,argu))) -> 
      	if (sort_head (List.hd (get_sorts_of_symbol f))) = sorte
      	then
 	  List.fold_left
	    reccur_env
	    env
	    ((let (lll) =( 
		(if (is_ac f) (* In this case take care of flattening*)
		 then
	    	   let thesort=
		     try List.hd(sort_body (List.hd (get_sorts_of_symbol f)))
		     with _ -> failwith "Fatal: bug in specif__reccur_env error"
	    	   in List.map (fun x -> thesort) argu 
		 else 
	    	   (sort_body (List.hd (get_sorts_of_symbol f))))
	   	,argu) 
	      in List.combine (fst lll) (snd lll) ))
      	else
	  failwith "Specif.Create_Current_Env : Bad Sort.list  of symbol" 
    | (sorte,(VAR(x))) -> 
	Listutils.union [(x,sorte)] env
  in  
    function 
	TERM(f,arg) -> 
	  reccur_env [] ((sort_head (List.hd (get_sorts_of_symbol f))),(TERM(f,arg)))
      | VAR _ -> 
	  failwith "Specif.Create_Current_Env error : Variable as term ???"
;;
	
	

(* 
   Construit l'automate associe a la signature courante de CiME
*) 

let make_signature_automata () = 
  make_automata 
    (listof_all_non_top_functions ())
    get_sorts_of_symbol
    (function 
	TERM(f,_)-> f 
      | VAR(x) -> raise (VARIABLE(x)))(* tete_de_terme*)
    (function TERM(_,s)->s | VAR(_) -> []) 
    (List.map (function x-> State([VS(x)])) (list_of_base_sorts()) ) (*states*)
    []   (*finaux*)
    (State([VS(List.hd (make_new_sort "TRASH"))])) 
    (List.map (fun (x,y) -> {initial_state=(State([VS(x)]));final_state=(State([VS(y)]))}) (get_subsort_table()))
    (List.flatten (try (List.map2 sy_sortlist_2_rule (listof_all_non_top_functions ()) (List.map (fun x->get_sorts_of_symbol x) (listof_all_non_top_functions ()) )) with _ -> failwith "Fatal : BUG in make_signature_automata ")) ;;

(* un compteur pour les variables (initialise) *)

let the_var = ref(fresh_new_var ());;


(* Donne des variables inutilisees avec la bonne sorte*)
(*let give_a_true_fresh_var = fun Sort.list -> the_var:=next_new_var_s (!the_var) Sort.list;!the_var;;
*)
let give_a_true_fresh_var () = 
  the_var:=next_new_var (!the_var) ;
  !the_var;;

(* Fait un terme dont les variables sont neuves avec un etat *)
let rec make_term_with_state = function
  FS(f,l) ->  if verbo then message "term2state T";(TERM(f,List.map make_term_with_state l))
| VS(s) -> if verbo then message "term2state V";(VAR(give_a_true_fresh_var () ));;


(* Fait un etat avec un terme si les variables sont sortees dans la table ... 
Currently not implemented
let rec make_state_with_term = fun
  (TERM(f,l))-> (FS(f,List.map make_state_with_term l))
| (VAR(x)) -> (VS(sort_head (List.hd (get_sorts_of_variable x))));;
*)

let make_state_with_term = 
  let rec rec_make sorte = function 
      VAR(x) -> VS(sorte)
    | TERM(f,q) -> 
 	let the_sorts = (sort_body (List.hd (get_sorts_of_symbol f)))
	in (FS(f,try ( List.map2 
		    (rec_make) 
		   
		    (if (is_ac f) (* In this case take care of flattening*)
		    then
		      let thesort=
			try List.hd(the_sorts)
			with _ -> failwith "Fatal: bug in specif__make_state_with_term error"
		      in (List.map (fun x -> thesort) q) 
		    else 
		      the_sorts )
		    q)
	with _ -> failwith "BUG in specif__make_state_with_term")) 
(****Bug corrige pour les symboles ac non binaires*******)
  in 
  function
      VAR(_) -> failwith "Specif.make_state_with_term cannot apply to VAR"
    | TERM(f,q) -> 
	rec_make (sort_head (List.hd (get_sorts_of_symbol f))) (TERM(f,q));;

(* donne un element minimal de la liste de sortes donnee *)
let rec true_min x = function
    a::rst -> if (sub_sort x a) then true_min x rst else true_min a rst
  | [] -> x;;

      
(*Trouve la sorte minimale si elle existe d'un etat simple *)
let rec get_min_sort_of_state = function
    VS(s) -> s
  | FS(f,l) -> 
      let prof=
	if (is_ac f) 
	then
	  let thesort= List.hd (get_sorts_of_symbol f)
	  in let (sb,sh) = (List.hd (sort_body thesort),(sort_head thesort))
	  in 
	  [make_profile((List.map (fun x -> sb) l),sh)]
      	else 
	  (get_sorts_of_symbol f) 
      and argu=(List.map get_min_sort_of_state l)
      in 
      let is_sub a b = 
     	List.for_all (fun x->x) (try (List.map2 (fun x y -> (sub_sort x y) or (x=y)) a b) with _ -> failwith "BUG in get_min_sort_of_state")
      in 
      let rec get_ze_min = function
	  a::rst -> 
	    if (is_sub argu (sort_body a)) 
	    then ((sort_head a)::(get_ze_min rst)) 
	    else (get_ze_min rst)
	| [] -> []
      in 
      let tmp =(get_ze_min prof)
      in 
      if ( tmp=[]) 
      then failwith "No min_sort in Specif.ml !!"
      else true_min (List.hd tmp) tmp ;;


(* Donne la plus petite des sortes d'un etat intersection *)
let get_min_sort_of_interstate (State(l)) =
  let lessortes=List.map get_min_sort_of_state l
  in true_min (List.hd lessortes) lessortes;;


(* Extrait la liste des membres gauches d'un liste de regle*)
let rec reglelist_2_left_handlist = function
    []-> []
  | r::l -> (r.l)::(reglelist_2_left_handlist l);;


(* Teste si t est une instance AC de p *)
let is_an_ac_instance t p = try 
  if verb then message "ISACINST?";(((filtrage_ac t p)) ) ;true
with No_match -> false ;;

(* teste si un terme est instance d'un membre gauche de regle*)
let is_a_left_hand_instance regles t = 
  List.exists 
    (fun x->x=true ) 
    (List.map (is_an_ac_instance t) (reglelist_2_left_handlist regles)) ;;
  

(* construit les etat f(x1:s1,...,xn:sn) avec (s1,...sn) dans l'automate initial*)
let make_prepare_to_add = 
fun aaa ->  List.split (List.map 
(fun rl ->(( FS(rl.tete,rl.etats_initiateurs))
    ,(if (rl.etats_initiateurs=[]) then [FS(rl.tete,rl.etats_initiateurs)]
    else [])) )
    aaa.regles);;

let usedelta = fun aaa delta -> { alphabet = aaa.alphabet;
	 typage = aaa.typage  ;
	 tete_de_terme = aaa.tete_de_terme ;
	 liste_des_sous_termes = aaa.liste_des_sous_termes ; 
	 etats = aaa.etats ;
	 etats_finaux = aaa.etats_finaux  ;
	 etat_poubelle = aaa.etat_poubelle ;
	 epsilon = Listutils.union aaa.epsilon delta ;
	 regles = aaa.regles; internal_names = [] ; internal_formula = []};;




(*--------------------------------------------------------------------------*)
(* Les regles d'inference *)
(*--------------------------------------------------------------------------*)

let sorting = 
  fun (aaa,delta) f sorts_arg sort_but 
    -> if verb then print_string "SORTING.";let newstate = (State([FS(f,List.map (fun x -> VS(x)) sorts_arg)])) in 
    let newepsilon = {initial_state = newstate; final_state=(State([VS(sort_but)]))} in
    ({ alphabet = aaa.alphabet;
      typage = aaa.typage  ;
      tete_de_terme = aaa.tete_de_terme ;
      liste_des_sous_termes = aaa.liste_des_sous_termes ; 
      etats = Listutils.union [newstate] aaa.etats  ;
      etats_finaux = Listutils.union [newstate] aaa.etats_finaux ;
      etat_poubelle = aaa.etat_poubelle ;
      epsilon = Listutils.union [newepsilon] aaa.epsilon ;
      regles = aaa.regles ; 
      internal_names = [] ; internal_formula = []},delta);;



let state_2_atomicstate = fun (State(l)) -> try List.hd l with _ -> failwith "Specif.state2atomicstate" ;;




let subleft =
  fun (aaa,delta) f args ty -> 
let newstate = State([make_state_with_term (TERM(f,args))]) 

(*State([FS(f,List.map make_state_with_term args)])*) 

in
let qqq= if verb then print_string " New State ! " 
in
let newepsilon = {initial_state = newstate; final_state = (State([VS(ty)]))}
in
  (({ alphabet = aaa.alphabet;
      typage = aaa.typage  ;
      tete_de_terme = aaa.tete_de_terme ;
      liste_des_sous_termes = aaa.liste_des_sous_termes ; 
      etats = Listutils.union [newstate] aaa.etats  ;
      etats_finaux = Listutils.union [newstate] aaa.etats_finaux ;
      etat_poubelle = aaa.etat_poubelle ;
      epsilon = Listutils.union [newepsilon] aaa.epsilon ;
      regles = aaa.regles ; 
      internal_names = [] ; internal_formula = []},delta));;



let delta x y z t u = match (x,y,z,t,u) with 
  (aaa,delt),State([FS(f,l1)]),State([VS(s1)]),State([FS(g,l2)]),State([VS(s2)]) -> 
    if verb then print_string "DELTA.";
    if (f<>g) 
    then (aaa,delt) 
    else 
      if ((s1=s2) or (triv_leads_to aaa (State([VS(s1)])) (State([VS(s2)])))) 
      then 
(*	if (List.for_all (fun (x,y) -> triv_leads_to (usedelta aaa delt) x y) (try (List.map2 (fun x y -> (State[x],State[y])  ) l1 l2) with _ -> failwith "BUG in delta" )) 
      	then (aaa,if (l1<>l2) then Listutils.union [{initial_state =(State([FS(f,l1)]));final_state = (State([FS(g,l2)]))}] delt else delt)  
	else (aaa,delt)*)
 	try filtrage_ac 
	    (make_term_with_state (FS(f,l1)) ) 
	    (make_term_with_state (FS(g,l2)) );
	  (aaa,if (l1<>l2) then Listutils.union [{initial_state =(State([FS(f,l1)]));final_state = (State([FS(g,l2)]))}] delt else delt)
	with No_match -> (aaa,delt)
	| _ -> failwith "BUG IN DELTA"
      else (aaa,delt) 
| a,_,_,_,_ -> a;;




(* munch permet de d'extraire de toutes les facons possibles  dans une liste de liste un element dans chaque liste*)
let rec munch = function 
    [] -> (*message "eoMunch";*)[[]]
  | l::s -> 
      if verb then message "munching";
      let munch_s = munch s in 
      Listutils.flat_map (fun y -> (List.map (fun l-> (y::l)) munch_s)) l;;


(* teste si q1 emne a q2 avec une epsilon transition de aaa *)
let triv_leads_to_one_step aaa q1 q2 =
  List.exists (fun x-> x={initial_state=q1;final_state=q2}) aaa.epsilon;;


(*-- *)
let is_a_multiset_instance f qlist leftrules =
  List.exists (is_a_left_hand_instance  leftrules) 
    (List.map (fun x-> make_term_with_state (FS(f,x))) 
       (munch (List.map (fun (State(x))->x) qlist))) ;;


(*-- *) 


let  coinstance aaa  f qlist tau =
  let termes = 
    List.map (fun x-> make_term_with_state (FS(f,x))) 
      (munch (List.map (fun (State(x)) -> x) qlist )) 
  in 
  let rec lowcoinstance = function 
      s1::reste -> 
	if verb then message "lowcoinst";
 	let orig =  (fun (State(x)) -> List.map make_term_with_state x) s1 
	in 
	if ((List.exists (fun x-> List.for_all (is_an_ac_instance x) orig ) termes) &
	    (triv_leads_to_one_step aaa s1 (State[(VS(tau))]) ) )
	then (s1::(lowcoinstance reste)) 
	else (lowcoinstance reste)
    | [] -> if verb then message "eolowcoinst";[]
  in 
  if verb then message "Computing coinstance";
  lowcoinstance aaa.etats_finaux ;
  if verb then message "EO LOWCOINST";
  lowcoinstance aaa.etats_finaux;;
      


(*Calcule l'etat intersection d'une liste d'etats dans l'automate aaa*)
let interstate (aaa,delt) coinst =

  let withdelta = usedelta aaa delt 
  in
  let is_min x l =
    List.for_all (fun z ->not ((triv_leads_to withdelta z x)&(z<>x))) l
  in
  let rec recinter = function
      x::reste -> 
      	if is_min x coinst
      	then
      	  x::(recinter (reste))
      	else 
      	  recinter reste
    | [] -> []
  in 
  State(Listutils.flat_map (fun (State(x))->x) (recinter (coinst))) ;;

 
(* Comme List.exists mais dit faux si la liste est vide *)
(*
let exists_or_empty f = function
    [] -> false
  | l -> List.exists f l;;
*)
(* c'est idiot ! *)
let exists_or_empty = List.exists;;

(* 

   Premiere version de laregle NLI LI: ne permet pas de detecter la
   creation de nouveaux etats. Cette regle n'est plus utilisee mais
   montre la technique utilisee est la meme (en plus lisible ) dans la
   regle finale



let lIandNLI (aaa,delt) = fun rules f qlist slist tau ->

  if verbo 
  then 
    begin 
      print_string "\b$";
      flush stdout 
    end ;
  if verb 
  then 
    begin 
      print_string 
	("\n LINLI for: "^(string_of_symbol_id f)^" sur les etats : "); 
      List.iter (fun x-> print_state x;print_string " ; ") qlist 
    end;
  if (exists_or_empty 
      	(fun x-> not x) 
      	(List.map2 (triv_leads_to aaa ) 
	   qlist 
	   (List.map (fun x -> State([VS(x)])) slist))) 
  then 
    begin
      if verbo then begin print_string "\b0";flush stdout end;
      if verb then message " :Bad type ";
      (aaa,delt)
    end
  else 
    if (is_a_multiset_instance f qlist rules)  
    then  
      begin
      	if verbo then begin print_string "\b!";flush stdout end;
      	if verb then message " :Is a LI ";
      	({ alphabet = aaa.alphabet;
	   typage = aaa.typage  ;
	   tete_de_terme = aaa.tete_de_terme ;
	   liste_des_sous_termes = aaa.liste_des_sous_termes ; 
	   etats = aaa.etats ;
	   etats_finaux = aaa.etats_finaux ;
	   etat_poubelle = aaa.etat_poubelle ;
	   epsilon = aaa.epsilon  ;
	   regles = Listutils.union 
	     [{tete = f ; 
	      	etats_initiateurs = qlist ; 
	      	conditions =[] ; 
	      	etat_final = (State([VS(tau)]))}] 
	     aaa.regles; 
	   internal_names = [] ; 
	   internal_formula = []}
	   ,delt)
      end
    else 
      let cof = 
	if verbo 
	then 
	  begin 
	    print_string "\b%";
	    flush stdout 
	  end;
	if verb 
	then message " :Not a LI";
	coinstance aaa  f qlist tau 
      in  
      let qQ=
	begin 
	  if verb then message "Computing interstate";
	  interstate (aaa,delt) cof 
	end
      in 
      ({ alphabet = aaa.alphabet;
	 typage = aaa.typage  ;
	 tete_de_terme = aaa.tete_de_terme ;
	 liste_des_sous_termes = aaa.liste_des_sous_termes ; 
	 etats = Listutils.union aaa.etats [qQ];
	 etats_finaux = Listutils.union aaa.etats_finaux [qQ] ;
	 etat_poubelle = aaa.etat_poubelle ;
	 epsilon = aaa.epsilon  ;
	 regles = 
	 begin
	   let rec exists_bis p = function
	       [] -> raise (Failure "Pas La")
	     | a::rst -> if p a then a else exists_bis p rst
	   in
	   try 
	     let older=(exists_bis 
			  (fun r-> r.tete=f & r.etats_initiateurs=qlist) 
			  aaa.regles)
	     in 
	     if (triv_leads_to (usedelta aaa delt) older.etat_final qQ) 
	     then begin if verb then message "keep old";aaa.regles end
	     else 
	       (if (triv_leads_to (usedelta aaa delt) qQ older.etat_final) 
	       then 
		 begin 
		   if verb 
		   then message "replace older";
		   (Listutils.union [{tete = f ; 
			     etats_initiateurs = qlist ;
			     conditions =[] ;
			     etat_final = qQ}] 
		      (if 
			(List.mem older.etat_final aaa.etats_finaux)
		      then  Listutils.except older aaa.regles
		      else aaa.regles )) 
		 end 
	       else failwith "Non comparable final states in Specif.LiandNLI  ????")    
	   with (Failure _) -> 
	     (Listutils.union ([{tete = f ; 
			etats_initiateurs = qlist ;
			conditions =[] ;
			etat_final = qQ}]) aaa.regles) 
	 end ; 
	 internal_names = [] ; 
	 internal_formula = []}
	 ,(Listutils.union delt (List.map (fun x -> {initial_state=qQ;final_state=x}) cof)) );;
      

*)
(****************************************************************************)


(* La regle LI NLI utilisee *)
let lIandNLI_bis = fun (aaa,delt) rules f qlist slist tau -> if verbo then begin print_string "\b$";flush stdout end ;if verb then begin print_string ("\n LINLI for: "^(string_of_symbol_id f)^" sur les etats : ");List.iter (fun x-> print_state x;print_string " ; ") qlist end;
if (exists_or_empty 
      (fun x-> not x) 
      (List.map2 (triv_leads_to aaa ) 
	 qlist 
	 (List.map (fun x -> State([VS(x)])) slist))) 

then 
  begin
    if verbo then begin print_string "\b0";flush stdout end;
    if verb then message " :Bad type ";
    ((aaa,delt),[])
  end
else 
  if (is_a_multiset_instance f qlist rules)  
  then  
    begin
      if verbo then begin print_string "\b!";flush stdout end;
      if verb then message " :Is a LI ";
      (({ alphabet = aaa.alphabet;
	 typage = aaa.typage  ;
	 tete_de_terme = aaa.tete_de_terme ;
	 liste_des_sous_termes = aaa.liste_des_sous_termes ; 
	 etats = aaa.etats ;
	 etats_finaux = aaa.etats_finaux ;
	 etat_poubelle = aaa.etat_poubelle ;
	 epsilon = aaa.epsilon  ;
	 regles = Listutils.union 
	   [{tete = f ; 
	      etats_initiateurs = qlist ; 
	      conditions =[] ; 
	      etat_final = (State([VS(tau)]))}] 
	   aaa.regles; 
	 internal_names = [] ; 
	 internal_formula = []}
	 ,delt),[])
    end
  else let cof = if verbo then begin print_string "\b%";flush stdout end;if verb then message " :Not a LI";coinstance aaa  f qlist tau 
  in  let qQ=interstate (aaa,delt) cof 
  in if verb then begin print_string "\n Voila qQ : ";print_state qQ;flush stdout end ; 
if List.mem qQ aaa.etats then 
begin 
if verb then message "\n qQ Deja la !";
(({ alphabet = aaa.alphabet;
	typage = aaa.typage  ;
	tete_de_terme = aaa.tete_de_terme ;
	liste_des_sous_termes = aaa.liste_des_sous_termes ; 
	etats =  aaa.etats ;
	etats_finaux = aaa.etats_finaux ;
	etat_poubelle = aaa.etat_poubelle ;
	epsilon = aaa.epsilon  ;
	regles = 
   begin
let rec exists_bis p = function 
    [] -> raise (Failure "Pas La")
  | a::rst -> if p a then a else exists_bis p rst
in
try 
let older=(exists_bis 
	     (fun r-> r.tete=f & r.etats_initiateurs=qlist) 
	     aaa.regles)
in 
if (triv_leads_to (usedelta aaa delt) older.etat_final qQ) 
then begin if verb then message "keep old";aaa.regles end
else 
  (if (triv_leads_to (usedelta aaa delt) qQ older.etat_final) 
  then 
    begin 
      if verb 
      then message "replace older";(Listutils.union [{tete = f ; 
					     etats_initiateurs = qlist ;
					     conditions =[] ;
					     etat_final = qQ}] 
				      (if 
					(List.mem older.etat_final aaa.etats_finaux)
				      then  Listutils.except older aaa.regles
				      else aaa.regles )) 
    end 
  else failwith "Non comparable final states in  Specif.LiandNLI  ????")    
with (Failure _) -> 
  (Listutils.union ([{tete = f ; 
	     etats_initiateurs = qlist ;
	     conditions =[] ;
	     etat_final = qQ}]) aaa.regles) 
   end ; 
   internal_names = [] ; 
   internal_formula = []}
   ,(Listutils.union delt (List.map (fun x -> {initial_state=qQ;final_state=x}) cof)) ),[])
end

else
(({ alphabet = aaa.alphabet;
	typage = aaa.typage  ;
	tete_de_terme = aaa.tete_de_terme ;
	liste_des_sous_termes = aaa.liste_des_sous_termes ; 
	etats =  (Listutils.union [qQ] aaa.etats) ;
	etats_finaux = (Listutils.union [qQ] aaa.etats_finaux) ;
	etat_poubelle = aaa.etat_poubelle ;
	epsilon = Listutils.union [{initial_state=qQ;final_state=State([(VS(get_min_sort_of_interstate qQ))])}] aaa.epsilon  ;
	regles = 
   begin
     let rec exists_bis p =  function 
	 [] -> raise (Failure "Pas La")
       | a::rst -> if p a then a else exists_bis p rst
in
try 
let older=(exists_bis 
	     (fun r-> r.tete=f & r.etats_initiateurs=qlist) 
	     aaa.regles)
in 
if (triv_leads_to (usedelta aaa delt) older.etat_final qQ) 
then begin if verb then message "keep old";aaa.regles end
else 
  (if (triv_leads_to (usedelta aaa delt) qQ older.etat_final) 
  then 
    begin 
      if verb 
      then message "replace older";(Listutils.union [{tete = f ; 
					     etats_initiateurs = qlist ;
					     conditions =[] ;
					     etat_final = qQ}] 
				      (if 
					(List.mem older.etat_final aaa.etats_finaux)
				      then  Listutils.except older aaa.regles
				      else aaa.regles )) 
    end 
  else failwith "Non comparable final states in Specif.LiandNLI  ????")    
with (Failure _) -> 
  (Listutils.union ([{tete = f ; 
	     etats_initiateurs = qlist ;
	     conditions =[] ;
	     etat_final = qQ}]) aaa.regles) 
   end ; 
   internal_names = [] ; 
   internal_formula = []}
   ,(Listutils.union delt (List.map (fun x -> {initial_state=qQ;final_state=x}) cof)) ),begin if verb then message "\n Just adding qQ";[qQ] end) 
;;
  

    
(****************************************************************************)
(* Les fonctions  d'application des regles precedentes *) 
(***************************************************************************)

let rec apply_sorting auto =
  if verb then (print_clean_automata (auto));
  if verbo then message "Applying Sorting"; 
  let symbol_list=listof_all_non_top_functions() 
  in
  let sortes_list = List.map (fun f->get_sorts_of_symbol f) symbol_list  
  in 
  let rec recapplysorting auto x y = match (x,y) with  
    (f::restsy),((s1::rstst)::restsortes) -> 
      recapplysorting 
	(sorting auto  f (sort_body s1) (sort_head s1)) 
	(f::restsy) ((rstst)::restsortes)
  | (f::restsy),(([])::restsortes) ->
      recapplysorting auto  restsy restsortes
  | [],[] -> auto
  | _,_ -> failwith ("Error in Specif.applysorting")
  in recapplysorting auto symbol_list sortes_list ;;


(* Donne les sous-termes stricts non variables d'un terme *)
let get_ss_term_strict_non_var = 

  let rec get_ss_term_non_var = function
      VAR(x) -> []
    | TERM(f,q) -> (TERM(f,q))::(Listutils.flat_map get_ss_term_non_var q)
  
  in function 
      VAR(x) -> []
    | TERM(f,q) -> 
      	Listutils.flat_map get_ss_term_non_var q
;;




(* Fonction de comparaison des sortes qui utilise l'automate seulement *)
let subsort = fun aaa s1 s2 -> triv_leads_to aaa ((State([VS(s1)]))) ((State([VS(s2)])));;


(* Donne la liste des sortes d'un terme type dont les variables sont typees
dans la table des variables ....
let rec get_sorts_of_term aaa = fun (VAR(x)) -> List.map sort_head (if verb then List.map print_sorte (get_sorts_of_variable x) else [()];(get_sorts_of_variable x) )
    |  (TERM(f,q)) -> let prof= get_sorts_of_symbol f in 
      let arguments_types = List.map (get_sorts_of_term aaa) q 
      in 
let one_sorte = fun prof slist -> if List.for_all (fun x->x) (List.map2 (fun x y -> subsort aaa y x) (sort_body prof) slist) then [sort_head prof] else []
in 
(Listutils.flat_map (fun x-> Listutils.flat_map (one_sorte x) (munch  arguments_types)) prof) ;;
*)

let  get_sorts_of_term aaa = function
    VAR(x) -> failwith "NO ABSOLUTE SORT in Specif yet"
  | TERM(f,_) -> [sort_head (List.hd (get_sorts_of_symbol f))];;



(**************************************************************************)
let rec apply_subleft (auto,delt) = function rules -> 
  if verbo then message "Applying SubLeft";
  let ssleftmb =Listutils.flat_map get_ss_term_strict_non_var (rules)
 (*  in let qqq= print_string "les ss lft mb:";List.iter print_term ssleftmb;print_newline *)
    in let rec recapplysubleft ad = function 
      	t::reste -> 
      	  let sortes = get_sorts_of_term (fst ad) t
(*	in let qqq = print_string "on regarde :";print_term t;List.iter print_base_sorte sortes*) 
	      
     	  in if sortes=[] 
	  then begin (*print_string "No Sort.list";*)recapplysubleft ad reste end
	  else recapplysubleft 
	      (subleft 
		 ad (*auto,delt*) 
		 (top_symbol_id t) 
		 ((function TERM(f,q) -> q | _ -> failwith ("Error in Specif.apply_subleft")) t) 
		 (List.hd sortes)) 
	      reste 
      | [] -> ad
    in recapplysubleft (auto,delt) ssleftmb;;
    
    
    

(****************************************************************************)
let apply_delta = fun (auto,delt) -> if verbo then message "Aplying DELTA";
let states = auto.etats_finaux 
in let rec one_epsilon_away x y = match (x,y) with 
  (epsi::reste),q -> if (epsi.initial_state=q) then (epsi.final_state::one_epsilon_away reste q) else (one_epsilon_away reste q)
    | [],q -> []
in let the_types= List.map (one_epsilon_away auto.epsilon) states
in let rec recapply_delta aaa x y z t = match (x,y,z,t) with  
  (a::arst),((t1::trst1)::srst1),(b::brst),((t2::trst2)::srst2) ->
    recapply_delta (delta aaa a t1 b t2) (a::arst) ((t1::trst1)::srst1) (b::brst) ((trst2)::srst2)
| (a::arst),((t1::trst1)::srst1),(b::brst),(([])::srst2) ->
    recapply_delta aaa (a::arst) (trst1::srst1) (b::brst) ((one_epsilon_away auto.epsilon b)::srst2)
| (a::arst),(([])::srst1),(b::brst),((_)::srst2) ->
    recapply_delta aaa (a::arst) ((one_epsilon_away auto.epsilon a)::srst1) brst srst2
| (a::arst),((t1::trst1)::srst1),[],[] ->
    recapply_delta aaa  (arst) (srst1) (states) (the_types)
| [],[],_,_ -> aaa
| _,_,_,_ -> failwith ("Unexpected case in Specif.apply_delta") 

in recapply_delta (auto,delt) states the_types states the_types;;




(* Donne tous les n-uplets dpossibles dans la liste entree. Utilisee uniquement dans apply_LIandNLI*)
let rec n_uplet x y = match (x,y) with 
  (0,_) -> [[]]
| n,l -> 
    let rec add_in_front x y = match (x,y) with 
      (l1::rst),lst -> (List.map (fun x -> (l1::x)) lst)@(add_in_front rst lst)   
    | [],lst -> []
    in add_in_front l (n_uplet (n-1) l);;


(* Non utilisee : ne permet pas d'appliquer plus d'une fois les regle. La technique de la fonction definitive reste la meme.
let apply_LIandNLI auto left_rules =
       if verbo then message "Applying LI and NLI\nComputing steps :";
let symbol_list=listof_all_non_top_functions() 
in 
let sortes_list = List.map (fun f->get_sorts_of_symbol f) symbol_list
in let rec recapplyNLILI auto x y = match (x,y) with  
  (f::restsy),((s1::rstst)::restsortes) -> 
    if verb then begin message ("On traite "^(string_of_symbol_id f)^":");
      print_sorte s1 end ;
    List.fold_right 
      (fun uple auto -> recapplyNLILI (lIandNLI auto left_rules f  (uple) (sort_body s1) (sort_head s1)) (f::restsy) ((rstst)::restsortes)) 
      ((n_uplet (arity f) (fst auto).etats_finaux)) auto 
| (f::restsy),(([])::restsortes) ->
 (*message "No more sorts ";*) recapplyNLILI auto  restsy restsortes
| [],[] -> (*message "No more symbols ";*)auto
| _,_ -> failwith ("Error in Specif.apply_LIandNLI")
in recapplyNLILI auto symbol_list sortes_list ;;

*)

(* Donne tous les n-uplets qui contiennent au moins un elements de compuls *)
let rec n_uplet_bis x y z = match (x,y,z) with
  0,_,_ -> [[]]
| n,l,compuls -> 
    let rec add_in_front x y = match (x,y) with 
      (l1::rst),lst -> (List.map (fun x -> (l1::x)) lst)@(add_in_front rst lst)   
    | [],lst -> []
    in 
    let all_uplets = (add_in_front l (n_uplet (n-1) l ))
    in 
    let rec filter l = function
	(a::rstl) -> 
	  if (List.exists (fun x-> List.exists (fun y -> x=y) l ) a) 
	  then (a::(filter l rstl)) 
	  else (filter l rstl)
      | [] -> []
in filter compuls all_uplets;;


(*Fonction definitive : permet d'ateindre la saturation*)
let apply_LIandNLI_bis = 
     fun auto left_rules compul -> 
       if verb then message "Applying LI and NLI_bis\nComputing steps :";
let symbol_list=listof_all_non_top_functions() 
in 
let sortes_list = List.map (fun f->get_sorts_of_symbol f) symbol_list
in 
let rec recapplyNLILI x y z t u = match (x,y,z,t,u) with 
  [],auto,_,_,l -> 
    
    message "Nothing compulsary !  ??????????????!!!";
    (auto,l)
| compuls,auto,(f::restsy),((s1::rstst)::restsortes),l -> 
    if verb 
    then 
      begin 
	message ("On traite "^(string_of_symbol_id f)^":");
      	print_sorte s1 
      end ;
    let rec foruples x y = match (x,y) with
      [],(aut,crea) -> (aut,crea)
    | (tuple::uples),(aut,crea) -> 
 	let (ruled,created) 
	    = lIandNLI_bis aut left_rules f  tuple (sort_body s1) (sort_head s1)
	in foruples uples (ruled,crea@created)


in 
let (autoafteruples,createdafteruples) = 
  foruples (n_uplet_bis (arity f) (fst auto).etats_finaux compuls) (auto,l)
in 
recapplyNLILI compuls autoafteruples (f::restsy) ((rstst)::restsortes) createdafteruples 

| compuls,auto,(f::restsy),(([])::restsortes),l ->(*message "No more sorts ";*) recapplyNLILI compuls auto  restsy restsortes l
| compuls,auto,[],[],l -> (*message "No more symbols ";*) (auto,l)
| compuls,auto,_,_,_ -> failwith ("Error in Specif.apply_LIandNLI")
in recapplyNLILI compul auto symbol_list sortes_list [];;




(* Pas utilisee 

let determine = fun aaa ->
let rec get_trans_from = 
  fun qlist (tr::rest) 
    -> if qlist=tr.etats_initiateurs then (tr::(get_trans_from qlist rest)) else (get_trans_from qlist rest)
      	  | qlist [] -> []
in 
let rec get_trans_same_sy = 
  fun f (tr::rest) -> if f=tr.tete then (tr::(get_trans_same_sy f rest)) else get_trans_same_sy f rest
	  | f [] -> []
in ();;

*)


(*version qui ne sature pas avec la regle NLI-LI
let build_nf_automata_one = 
  fun rules -> 
    (apply_LIandNLI
       (let delt = (apply_delta
	  (let subl = apply_subleft 
	     (let sorted = (apply_sorting 
	     	( (make_signature_automata ()),[] )
	     	) in if verb then print_clean_automata (sorted);sorted)
	     (reglelist_2_left_handlist rules)
	     in if verb then print_clean_automata subl ;subl)
	  ) in if verb then print_clean_automata delt;delt)
       rules)
      ;;
*)

(* 
   Version saturante 
*)

let build_nf_automata rules = 
let partone = (let delt = (apply_delta
	  (let subl = apply_subleft 
	     (let sorted = (apply_sorting 
	     	( (make_signature_automata () ),[] )
	     	) in if verb then print_clean_automata (sorted);sorted)
	     (reglelist_2_left_handlist rules)
	     in if verb then print_clean_automata subl ;subl)
	  ) in if verb then print_clean_automata delt;delt)
in 
let result=(apply_LIandNLI_bis partone rules ((fst partone).etats_finaux))
in 
let rec sat = function 
    (r,[]) -> if verb then message "\nSaturation reached !";r
  | (r,ll) -> if verb then message "One more step !" else print_string " ";sat (apply_LIandNLI_bis r rules ll)
in if verbo then message "Applying NLI LI";sat result
      ;;
