(***************************************************************************

  Ce module permet de manipuler des specifications ordo-sortes et de les 
  lier aux automates d'arbres.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: specif.mli,v 1.1 1999/07/16 16:29:01 monate Exp $

***************************************************************************)

open Tree_automata 
open Symbols
open Terms
open Equations
open Types


val make_signature_automata : 
  unit -> (symbol_id, term, sorte list, state) automata 

val create_current_env : 
  term -> (Symbols.var_id * Symbols.sorte_de_base) list 

val build_nf_automata : 
  regle list -> (symbol_id, term, sorte list, state) automata * state epsilon_rule list 



val print_delta_automata : 
  (symbol_id, term, sorte list, state) automata * state epsilon_rule list -> unit 

val print_clean_automata : 
  (symbol_id, term, sorte list, state) automata * state epsilon_rule list -> unit 

val print_state : state -> unit









