(***************************************************************************

Classical maps : no module, no functor, the comparison function is
store in each map.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: classical_maps.ml,v 1.2 2000/05/17 12:57:07 marche Exp $

***************************************************************************)


open Balanced_trees2;;

type ('a,'b) t = 
    {
      tree : ('a,'b) Balanced_trees2.t;
      order : 'a -> 'a -> int;
    }
;;


let empty order = { tree = Empty ; order = order }
;;

let add x data m =
 
  let rec add x data = function
        Empty ->
          Node
	    {
	      key = x;
	      data = data;
	      height = 1;
	      left = Empty;
	      right = Empty
	    } 
      | Node(i) ->
          let c = m.order x i.key in
          if c = 0 
	  then
            Node { i with key = x; data = data }
          else 
	    if c < 0 
	    then
              bal (add x data i.left) i.key i.data i.right
            else
              bal i.left i.key i.data (add x data i.right)

  in
  { m with tree = add x data m.tree }
;;


let find x m = 

  let rec find x = function
        Empty ->
          raise Not_found
      | Node(i) ->
          let c = m.order x i.key in
          if c = 0 then i.data
          else find x (if c < 0 then i.left else i.right)

  in
   find x m.tree
;;


let remove x m = 

  let rec remove x = function
        Empty ->
          Empty
      | Node(i) ->
          let c = m.order x i.key in
          if c = 0 then
            merge i.left i.right
          else if c < 0 then
            bal (remove x i.left) i.key i.data i.right
          else
            bal i.left i.key i.data (remove x i.right)

  in
  { m with tree = remove x m.tree}
;;

let iter f m = Balanced_trees2.iter f m.tree;;
		   
let map f m = { m with tree = Balanced_trees2.map f m.tree} ;;

let fold f m a = Balanced_trees2.fold f m.tree a;;


