(***************************************************************************

Classical maps : no module, no functor, the comparison function is
store in each map.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: classical_maps.mli,v 1.1 2000/05/17 12:57:07 marche Exp $

***************************************************************************)


(*
  
  abstract data type of maps over some keys

*)

type ('key, 'data) t ;;

(*

  [empty comp] returns an empty map, [comp] is a comparison function
  that is used for comparing keys.

*)

val empty : ('key -> 'key -> int) -> ('key, 'data) t

val add : 'key -> 'data -> ('key, 'data) t -> ('key, 'data) t

val find : 'key -> ('key, 'data) t -> 'data

val remove : 'key -> ('key, 'data) t -> ('key, 'data) t

val iter : ('key -> 'data -> 'a) -> ('key, 'data) t -> unit

val map : ('data -> 'data) -> ('key, 'data) t -> ('key, 'data) t

val fold : ('key -> 'data -> 'a -> 'a) -> ('key, 'data) t -> 'a -> 'a

