(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: main.ml,v 1.6 2002/07/01 09:27:52 monate Exp $

***************************************************************************)


open Format;;


open Labelled_graphs;;

(*

  inttagset tests

*)


type tag_string =
    { tag : int ; value : string }

let make_string =
  let n = ref 0 in
  function s ->
    incr n;
    { tag = !n ; value = s }
 
module TagStringSet = 
  Inttagset.Make
    (struct 
       type t = tag_string
       let tag e = e.tag
     end)
;;

let bonjour = make_string "Bonjour";;
let monde = make_string "Monde";;
let univers = make_string "Univers";;

let test_inttagsets () =
  let e1 = TagStringSet.singleton bonjour in
  let e2 = TagStringSet.add monde e1 in
  let e3 = TagStringSet.singleton bonjour in
  let e4 = TagStringSet.add univers e3 in
  let e5 = TagStringSet.inter e2 e4 in
  TagStringSet.iter (fun s -> print_string s.value; print_newline()) e5
;;




(*

  graph tests 

*)

let print_graph g = print g print_string;;

let test_remove g v =
    print_string "test de remove and link sur le graphe :\n";
    print_graph g ;
    print_newline();
    print_string ("apres remove "^(get_vertex_label g v)^" :\n");
    print_graph (remove_vertex_and_its_arcs g v);
    print_newline();
    print_string ("apres remove "^(get_vertex_label g v)^" avec link :\n");
    print_graph (remove_vertex_and_link_its_arcs g v);
    print_newline()
;;

let v1,graphe1 =
  let g = empty_graph in
  let (v1,g) = add_vertex g "a" in
  let (v2,g) = add_vertex g "b" in
  let g = add_arc g v1 v2 in
  let g = add_arc g v2 v1 in
  let g = add_arc g v1 v1 in
    v1,g
;;

let v2,graphe2 =
  let g = empty_graph in
  let (v1,g) = add_vertex g "a" in
  let (v2,g) = add_vertex g "b" in
  let (v3,g) = add_vertex g "c" in
  let g = add_arc g v1 v2 in
  let g = add_arc g v2 v1 in
  let g = add_arc g v3 v1 in
  let g = add_arc g v1 v3 in
    v1,g
 ;;


let graphe3 = 
  let g = empty_graph in
  let (v1,g) = add_vertex g "a" in
  let (v2,g) = add_vertex g "b" in
  let (v3,g) = add_vertex g "c" in
  let (v4,g) = add_vertex g "d" in
  let (v5,g) = add_vertex g "e" in
  let (v6,g) = add_vertex g "f" in
  let g = add_arc g v1 v2 in
  let g = add_arc g v2 v3 in
  let g = add_arc g v3 v4 in
  let g = add_arc g v4 v5 in
  let g = add_arc g v5 v2 in
  let g = add_arc g v3 v6 in
  let g = add_arc g v6 v2 in
    g
;;

let graphe4,graphe5 = 
  let gr = empty_graph in
  let (a,gr) = add_vertex gr "a" in
  let (b,gr) = add_vertex gr "b" in
  let (c,gr) = add_vertex gr "c" in
  let (d,gr) = add_vertex gr "d" in
  let (e,gr) = add_vertex gr "e" in
  let (f,gr) = add_vertex gr "f" in
  let (g,gr) = add_vertex gr "g" in
  let gr = add_arc gr a b in
  let gr = add_arc gr b c in
  let gr = add_arc gr c d in
  let gr = add_arc gr c e in
  let gr = add_arc gr e b in
  let gr = add_arc gr a f in
  let gr = add_arc gr f g in
    gr,add_arc gr f a
;;

let graphe6 =
  let g = empty_graph in
  let (a,g) = add_vertex g "a" in
  let (b,g) = add_vertex g "b" in
  let (c,g) = add_vertex g "c" in
  let g = add_arc g a a in
  let g = add_arc g a b in
  let g = add_arc g b c in
  let g = add_arc g c c in
    g
 ;;


let print_vertexset g c =
  print_string "[";
  VertexSet.iter (fun v -> print_string (get_vertex_label g v)) c;
  print_string "]"
;;


let test_strong_components even_if_no_cycles g =
  print_string "test des composantes fortement connexes du graphe :\n";
  print_graph g ;
  print_newline();
  print_string ("composantes (no_cycles = "^
		(string_of_bool even_if_no_cycles)^") :\n");
  let comps = compute_strongly_connected_components even_if_no_cycles g in
    List.iter
      (fun c ->
	 print_vertexset g c;
	 print_string ", soit le graphe :";
	 print_newline();
	 print_graph (get_subgraph g c);
	 print_newline();
         )
      comps ;
    print_newline()
;;

let test_cycles g =
  print_string "test des cycles du graphe :\n";
  print_graph g ;
  print_newline();
  let on,off  = split_cycles g in
    print_string "sont sur un cycle :\n";
    print_vertexset g on;
    print_string "\nne sont pas sur un cycle :\n";
    print_vertexset g off;
    print_newline()
;;

let main () =
(*i
  test_remove graphe1 v1;
  test_remove graphe2 v2;
  test_strong_components true graphe1;
  test_strong_components false graphe1;
  test_strong_components true graphe2;
  test_strong_components false graphe2;
  test_strong_components true graphe3;
  test_strong_components false graphe3;
  test_strong_components true graphe4;
  test_strong_components false graphe4;
  test_strong_components true graphe5;
  test_strong_components false graphe5;
  test_cycles graphe1;
  test_cycles graphe2;
  test_cycles graphe3;
  test_cycles graphe4;
  test_cycles graphe5;
  test_cycles graphe6;
i*)
  test_inttagsets ()
;;

Printexc.catch main ();;


