(***************************************************************************

Moduke for time profiling functions

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: time_profiler.mli,v 1.2 1998/09/04 14:30:07 marche Exp $

***************************************************************************)

(*

  [(profile_n name f)] returns a function which calls [f] and records
  the time of computation. [name] is name that will appear in the
  profiling report. The right profiling function has to be used
  w.r.t. the number of arguments of [f].

*)

val profile1 : string -> ('a -> 'b) -> 'a -> 'b
val profile2 : string -> ('a -> 'b -> 'c) -> 'a -> 'b -> 'c
val profile3 : string -> ('a -> 'b -> 'c -> 'd) -> 'a -> 'b -> 'c -> 'd
val profile4 :
  string -> ('a -> 'b -> 'c -> 'd -> 'e) -> 'a -> 'b -> 'c -> 'd -> 'e
val profile5 :
  string ->
  ('a -> 'b -> 'c -> 'd -> 'e -> 'f) -> 'a -> 'b -> 'c -> 'd -> 'e -> 'f
val profile6 :
  string ->
  ('a -> 'b -> 'c -> 'd -> 'e -> 'f -> 'g) ->
  'a -> 'b -> 'c -> 'd -> 'e -> 'f -> 'g
val profile7 :
  string ->
  ('a -> 'b -> 'c -> 'd -> 'e -> 'f -> 'g -> 'h) ->
  'a -> 'b -> 'c -> 'd -> 'e -> 'f -> 'g -> 'h

(*

  [(print_profile ())] prints to standard output the current results
  of time profiling

*)

val print_profile : unit -> unit

val reset_profile : unit -> unit
