(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: data1.ml,v 1.14 2002/07/16 09:29:36 contejea Exp $

***************************************************************************)

open Signatures;;
open Variables;;
open User_terms;;
open Gen_terms;;
open Format;;

let my_sig =  User_signatures.from_string "
  c,b,a : constant;
  r : 2;
  cp : 2;
"

let my_vars = Variables.from_string "X Y W A B C D E F G H I J K L V Z"


let my_prec = User_terms.prec_of_string my_sig 
		"cp > r > a > b > c"

let my_rpo = 
  Acrpo.acrpo my_sig User_terms.user_hct my_prec 
    (function f -> 
       if my_sig#is_free f
       then Rpo.Lr_lexico 
       else Rpo.Multiset);;


let my_trs = 
  User_terms.equation_set_of_string 
    my_sig User_terms.user_hct my_vars 
  "r(cp(X,Y),W) = r(X,r(Y,W));
  r(a,b) = c;
  r(a,c) = b;"

(*
let my_p1 = User_terms.term_of_string my_sig Confluence.user_hct my_vars "*(y,x)"
let my_p2 = User_terms.term_of_string my_sig Confluence.user_hct my_vars "*(x,y)"
let my_t1 = User_terms.term_of_string my_sig Confluence.user_hct my_vars "*(x,*(z,y))"
let my_t2 = User_terms.term_of_string my_sig Confluence.user_hct my_vars "*(x,*(y,z))"
*)

let my_conjecture = 
  User_terms.equation_of_string 
    my_sig User_terms.user_hct my_vars "
  r(W,V) = V
";;

(*
let my_poly_o = User_poly_ordering.of_string my_sig "
[b] = 1;
[difference](x,y) = x+y+1;
[*](x,y) = x.y + 4.x + 4.y + 4;
[a] = 1;
[c] = 1;
[e] = 0;
";;
*)
  
let my_print_term t =
  Gen_terms.print_term my_sig my_vars t;;

let my_print_var x =
  open_box 0;
  print_string (my_vars#string_of_var x);
  close_box();
  print_flush ();;

let my_print_symbol f =
  open_box 0;
  print_string (my_sig#string_of_symbol f);
  close_box();
  print_flush ();;

let my_print_subst =
  Substitution.print my_sig my_vars;; 
