(* This lexer is done to match the interface with Coq that was previously done for the ELAN system *)

{
  open Coq_parser
  exception Invalid_char of string
}

let letter = ['A'-'Z''a'-'z''+''&''\\''<''-''>''^''?']
let digit10 = ['0'-'9']
let identifier = letter('_'|letter|digit10)*

rule token = parse
  | ['\n']              { NEWLINE }
  | ','                 { COMMA }
  | ':'            	{ COLON }
  | "->"            	{ RIGHTARROW }
  | '('            	{ LEFT_PAR }
  | ')'            	{ RIGHT_PAR }
  | '='                 { EQUAL }
  | "SEARCH"            { SEARCH }
  | "THEORY"            { THEORY }
  | "SORT"              { SORT }
  | "FSYM"              { FUNCTION }
  | "RULE"              { RULE }
  | "END"               { END }
  | "TERM"              { TERM }
  | "QUIT"              { QUIT }
  | identifier          { IDENT (Lexing.lexeme lexbuf) }
  | _                   { token lexbuf }
