open Rewrite_rules
open Positions
open Format

class ['symbol] t = object
  val mutable l : ('symbol Rewrite_rules.t * Positions.position) list = []
  method get =
    let rec aux h = function
      | [] -> h
      | (r, p)::t -> aux ((r.nb, list_of_position p)::h) t in
      aux [] l
  method add r pos = l <- (r, pos)::l
  method to_string names =
    let rec aux = function
      | [] -> ""
      | (r, p)::t -> (aux t)^" "^names.(r.nb)^" @ "^(string_of_position p)^"\n" in
      aux l
  val trace_output = stderr (* open_out "my_trace"*)
  method print (sigma : 'symbol Signatures.signature) vars =
    let rec aux = function
      | [] -> printf "forme normale.@.";
      | (r, p)::t ->
	  printf "@[On applique la rgle ";
	  print_rewrite_rule sigma vars r;
	  printf "  la position %s@]@." (string_of_position p);
	  aux t in
      set_formatter_out_channel trace_output;
      aux (List.rev l);
      set_formatter_out_channel stdout
end

(*
type 'symbol t = ('symbol rewrite_rule * position) list

let empty_trace = []

let add_to_trace trace h = h::trace

let print_trace sigma vars trace =
  let trace_output = (*stderr*) open_out "my_trace" in
  let rec aux = function
    | [] -> printf "forme normale.@.";
    | (r, p)::t ->
	printf "@[On applique la rgle ";
	print_rewrite_rule sigma vars r;
	printf "  la position %s@]@." (string_of_position p);
	aux t;
  in
    set_formatter_out_channel trace_output;
    aux (List.rev trace);
    close_out trace_output;
    set_formatter_out_channel stdout

let rec string_of_trace = function
  | [] -> ""
  | (s, p)::t -> (aux t)^s^" @ "^(string_of_position p)^"\n"
*)
