(*
type 'symbol t;;

val empty_trace :  'symbol t

val add_to_trace : 'symbol t -> string * Positions.position -> 'symbol t

val string_of_trace : unit -> string
*)

(* This module defines the trace used when normalizing a term: it basically consists in remembering which and where rules are applied to reduce the term. *)

class ['symbol] t : object
  method get : (int * int list) list
  method add : 'symbol Rewrite_rules.t -> Positions.position -> unit
  method to_string : string array -> string
  method print : 'symbol Signatures.signature -> Variables.user_variables -> unit
end
