open Rewrite_rules
open Substitution
open Standard_matching

let rec new_rewrite_at_top ruleset t = 
  match ruleset with
      [] -> raise Not_found
    | r::s ->
	try
	  let sigma = Standard_matching.matching r.lhs t
	  in (r, sigma)
	with No_match -> new_rewrite_at_top s t

let new_compiled_rewrite_at_top dnet t =
  let ruleset = Naive_dnet.discriminate dnet t in
    new_rewrite_at_top ruleset t

open Gen_terms
open Variables
open Positions

let rec traced_substitute_and_innermost_normalize hct tr red sigma pos t =
  let rec normalize_at_top f t = (* symbol -> term -> term *)
    let (r, sigma') = red t in
      tr#add r pos;
      traced_substitute_and_innermost_normalize hct tr red sigma' pos r.rhs in
    match t.Hcons.node with
      | (Var x) ->
	  begin try 
	    VarMap.find x sigma
      	  with Not_found -> t
	  end
      | Term (f, l) ->
	  let t' = make_term hct f (Listutils.mapi (fun i -> traced_substitute_and_innermost_normalize hct tr red sigma (Pos(i, pos))) l) in
	    try
	      normalize_at_top f t'
	    with Not_found -> t'

let traced_innermost_normalize hct red t =
  let tr = new Trace.t in
  let z = traced_substitute_and_innermost_normalize hct tr red VarMap.empty Top t in
    (z, tr)

(*
let traced_innermost_normalize red t =
  let rec traced_substitute_and_innermost_normalize trace sigma pos t =
    (* trace -> substitution -> position -> term -> term * trace *)
    let rec normalize_at_top f t trace = (* symbol -> term -> trace -> term * trace *)
      let (s, t', sigma') = red t in
        let trace' = add_to_trace trace (s, pos) in
	traced_substitute_and_innermost_normalize trace' sigma' pos t' in
      match t with
	| (Var x) as v -> 
	    (begin try 
	       VarMap.find x sigma
      	     with Not_found -> v
	     end
	       , trace)
	| Term (f, l) ->
	    let rec parcourt i trace parcourus = function
	      | [] ->
		  let t' = Term (f, List.rev parcourus) in
		    begin try
		      normalize_at_top f t' trace
		    with Not_found -> (t', trace)
		    end
	      | h::k ->
		  let (t', trace') = traced_substitute_and_innermost_normalize trace sigma (Pos(i, pos)) h in
		    parcourt (i+1) trace' (t'::parcourus) k in
	      parcourt 0 trace [] l in
    traced_substitute_and_innermost_normalize empty_trace VarMap.empty Top t
*)
