#load "nums.cma";;
#directory "../compat";;
#load "numbers.cmo";;
#load "inttagset.cmo";;
#load "inttagmap.cmo";;
#load "balanced_trees.cmo";;
#load "ordered_sets.cmo";;
#load "abstract_constraint.cmo";;
#load "poly_parser.cmo";;
#load "poly_lexer.cmo";;
#load "poly_syntax.cmo";;
#load "ptset.cmo";;
#load "hashcons.cmo";;

#use "linear_constraints.ml";;

let print_subst s =
  printf "{ ";
  VarMap.iter (fun x e -> 
		 printf "%s -> " x.var_name;
		 print_expr e;printf ", ") s;
  printf "}";
;;

let print_set s =
  printf "{ ";
  Ptset.iter (fun f -> print f;printf ", ") s;
  printf "}";
;;

#install_printer print_expr;;
#install_printer print;;
#install_printer print_subst;;
#install_printer print_set;;


let x = make_var "x";;
let y = make_var "y";;
let z = make_var "z";;

let f = add (var x) (var y);;
let f = add (var x) f;;
let f = add f (cte (Numbers.of_int 3));;

let f = sub f (var x);;
let f = sub f (var y);;

let f = minus f;;

let f = times (Numbers.of_int 3) f;;


positive (cte (Numbers.of_int 4))    (* True *);;
positive (cte (Numbers.of_int (-7))) (* False*);;
positive (cte (Numbers.of_int 0))    (* False*);;
positive (add (cte (Numbers.of_int 3)) (cte (Numbers.of_int 4)))    (* true*);;
positive (var (make_var "x"));;
positive (add (cte (Numbers.of_int 3)) (add (var (make_var "x")) (cte (Numbers.of_int 4))));;

positive_or_null (cte (Numbers.of_int 4))    (*  True *);;
positive_or_null (cte (Numbers.of_int (-7))) (*  False *);;
positive_or_null (cte (Numbers.of_int 0))    (*  True *);;
positive_or_null (var (make_var "x"));;

null (cte (Numbers.of_int 4))    (*  False *);;
null (cte (Numbers.of_int (-7))) (*  False *);;
null (cte (Numbers.of_int 0))    (*  True *);;
null (var (make_var "x"));;


divides (Numbers.of_int 2) (cte (Numbers.of_int 4))    (*  True *);;
divides (Numbers.of_int 2) (cte (Numbers.of_int (-7))) (* False *);;
divides (Numbers.of_int 2) (cte (Numbers.of_int 0))    (* True *);;
divides (Numbers.of_int 1) (var (make_var "x")) (* True *);;
divides (Numbers.of_int 2) (var (make_var "x"));;
divides (Numbers.of_int 2) (times (Numbers.of_int 3) (var (make_var "x")));;

let g = positive f;;
neg g;;
neg(implies g g);;

conj g g;;

disj g g;;

let vx = make_var "x";;
let x = var vx;;



let env1,abs1 = 
  from_abstract_formula [] 
    (Poly_syntax.constraint_of_string "x=1 and x+y=2");; 

let env2,abs2 = 
  from_abstract_formula [] 
    (Poly_syntax.constraint_of_string "x+y=2 and x=1");;

exists (List.assoc "x" env1) abs1;;

let e,f = from_abstract_formula [] (Poly_syntax.constraint_of_string "exists x, x+y=2 and x=1");;

inst1 (List.assoc "y" e) (Numbers.of_int 37) f;;
inst1 (List.assoc "x" e) (Numbers.of_int 37) f;;
inst1 (make_var "x") (Numbers.of_int 37) f;;

let e,f = from_abstract_formula [] (Poly_syntax.constraint_of_string "exists x, x=2 and x=y");;

inst1 (List.assoc "y" e) (Numbers.of_int 2) f;;





let c = Poly_syntax.constraint_of_string "
k = j and 1 + j = i and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and
   j <= n + - 2 and 1 <= j and j <= n + - 2 and 1 <= j and j <= n + - 2 and
   1 <= j and j <= n + - 2 and 1 + j + - j = 1 and 1 <= 1 + j and
   1 + j <= n + - 1 and 1 <= j and j <= n + - 1";;


let _,f = from_abstract_formula [] c;;

let e = cte (Numbers.div (Numbers.of_int 1) (Numbers.of_int 2));;

let f = linear_mult e (var vx);;

let c1 = Poly_syntax.constraint_of_string "k = j/3 ";;

let _,f = from_abstract_formula [] c1;;

let c = Poly_syntax.constraint_of_string "k = j/3 and 3 | j+1";;

let _,f = from_abstract_formula [] c;;


(*

  equality simplification

*)


let f = "x + 3 >= 0 and x = 4 and x+y >=0";;

let _,f = from_abstract_formula [] (Poly_syntax.constraint_of_string f);;

(*
equality_simplification f;;
*)

(*

  a big formula to simplify

*)

let f = "
((-i_39 + 2 = 0 and -j_40 + 4 = 0 and -j_38 + 3 = 0 and N - 15 >= 0 and i_39 >= 0 and i_39 - i_41 = 0 and N - j_42 >= 0 and i_41 >= 0 and (not i_43 - j_42 >= 0) and -i_43 + j_38 = 0 and i_43 >= 0 and  N - j_40 >= 0 and -j_42 + j_40 = 0 and (not i_39 - j_38 >= 0) and (not i_41 - j_40 >= 0) and N - j_38 >= 0))

implies

(exists j_44 i_45, (N - j_44 >= 0 and
                              -i_39 + 2 = 0 and
                             -j_40 + 4 = 0 and
                              (not i_45 - j_44 >=
0) and                     -j_38 + 3 = 0
and                          N - 15 >= 0 and
                              i_39 >= 0 and
                                    i_45 >= 0 and
                                 i_39 - i_41 = 0 and
                                   N - j_42 >= 0 and  
                                 i_41 >= 0 and
                                   i_41 - j_44 = 0 and
                                             (not i_43 - j_42 >=
0) and                                          -i_43 + j_38 =
0 and                                            i_43 >= 0 and
                                                     N - j_40 >= 0 and
                                                     -j_42 + j_40 = 0 and
                                                     (not i_39 - j_38 >=
0) and                                                     (not i_41 -
j_40 >= 0) and                                                     i_43 -
i_45 = 0 and                                                     N - j_38
>= 0))"
;;





let _,f = from_abstract_formula [] (Poly_syntax.constraint_of_string f);;

(*
equality_simplification f;;
*)




let f = "j = j and i = j and i = j and (not j >= 0) and
                       N - 9 >= 0";;

let _,f = from_abstract_formula [] (Poly_syntax.constraint_of_string f);;



(*

*)

let f = "i = 2 and j = 3 and i < j";;

let _,f = from_abstract_formula [] (Poly_syntax.constraint_of_string f);;

let f = "i = 2 and j = 3 and i > j";;

let _,f = from_abstract_formula [] (Poly_syntax.constraint_of_string f);;


let f = " (j_7 = j0 and i_8 = i0)
/\ (-j_7 + N >= 0 and (not -j_7 + i_8 >= 0) and i_8 >= 0)
/\ (j0 = 2 and i0 = 7 and N - 10 >= 0)";;

let _,f = from_abstract_formula [] (Poly_syntax.constraint_of_string f);;


let f1 = " (j_7 = j0 and i_8 = i0) ";;
let f2 = " (-j_7 + N >= 0 and (not -j_7 + i_8 >= 0) and i_8 >= 0)";;
let f3 = " (j0 = 2 and i0 = 7 and N - 10 >= 0)";;

let env = [];;
let env,f1 = from_abstract_formula env (Poly_syntax.constraint_of_string f1);;
let env,f2 = from_abstract_formula env (Poly_syntax.constraint_of_string f2);;
let env,f3 = from_abstract_formula env (Poly_syntax.constraint_of_string f3);;

f1,f2,f3;;

conj f1 f2;;

conj (conj f1 f2) f3;;

(*

 encore un bug a corriger

*)

let f1 = "p_203 = 0";;
let f2 = "N - 1 >= 0";;
let f3 = "(p_203 >= 0 and
       ((q_204 = N - 1 and (not -N - 1 >= 0)) or (N = 1 and q_204 = 0) or
       (N = 0 and q_204 = -1)) and N - 1 >= 0 and
       p_203 - N + q_204 + 1 = 0 and q_204 >= 0)";;

let env = [];;
let env,f1 =   from_abstract_formula env (Poly_syntax.constraint_of_string f1);;
let env,f2 = from_abstract_formula env (Poly_syntax.constraint_of_string f2);;
let env,f3 = from_abstract_formula env (Poly_syntax.constraint_of_string f3);;


conj f1 (conj f2 f3);;

(*

testing subst_in_subst

*)

let env = [];;

let env,e2 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "2");;
let env,et = from_abstract_expr env
	       (Poly_syntax.expr_of_string "t");;
let env,eyp1 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "y+1");;
let env,e3 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "3");;
let env,edummy = from_abstract_expr env 
	       (Poly_syntax.expr_of_string "x+y+z+t");;

let Some(sy2),_ = add_in_subst VarMap.empty (List.assoc "y" env) e2;;

let Some(sy2zt),_ = add_in_subst sy2 (List.assoc "z" env) et;;

let Some(sxyp1),_ = add_in_subst VarMap.empty (List.assoc "x" env) eyp1;;

let Some(sz3xyp1),_ = add_in_subst sxyp1 (List.assoc "z" env) e3;;



subst_in_subst  sy2zt sz3xyp1;;
(*  should return {x->3} {t=3} *)
    
(*

  testing add_in_subst

*)

let env,e1 = from_abstract_expr [] 
	       (Poly_syntax.expr_of_string "x+1");;

let env,e2 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "y+2");;

let env,e3 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "z+t+3");;

let s = VarMap.empty;;

let Some(s),f = add_in_subst s (List.assoc "t" env) e1;;

let Some(s),f = add_in_subst s (List.assoc "x" env) e2;;

let None,f = add_in_subst s (List.assoc "x" env) e3;;

let s = VarMap.empty;;

let Some(s),f = add_in_subst s (List.assoc "x" env) e3;;

let Some(s),f = add_in_subst s (List.assoc "x" env) e2;;

let Some(s),f = add_in_subst s (List.assoc "t" env) e1;;

(*

  testing examples given for add_in_subst

*)

let env,e1 = from_abstract_expr []
	       (Poly_syntax.expr_of_string "1");;
let env,e2 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "2");;
let env,eyp1 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "y+1");;
let env,eyp2 = from_abstract_expr env
	       (Poly_syntax.expr_of_string "y+2");;
let env,ex = from_abstract_expr env 
	       (Poly_syntax.expr_of_string "x");;

let Some(s1),_ = add_in_subst VarMap.empty (List.assoc "x" env) e1;;

let Some(syp1),_ = add_in_subst VarMap.empty (List.assoc "x" env) eyp1;;

(*

  add_in_subst {x->1} y 2   returns Some({x->1, y->2}),None

*)

add_in_subst s1 (List.assoc "y" env) e2;;

(*

  add_in_subst {x->y+1} y 2 returns Some({x->3, y->2}),None

*)

add_in_subst syp1 (List.assoc "y" env) e2;;

(*

  add_in_subst {x->1} x 1   returns None,None

*)

add_in_subst s1 (List.assoc "x" env) e1;;

(*

  add_in_subst {x->1} x 2   raises Degenerate

*)

add_in_subst s1 (List.assoc "x" env) e2;;

(*

  add_in_subst {x->y+1} x 2 returns Some({x->2}),Some(y+1=2) 

*)

add_in_subst syp1 (List.assoc "x" env) e2;;

(*

  add_in_subst {x->1} x y+2 returns None,Some(y+2=1) 

*)

add_in_subst s1 (List.assoc "x" env) eyp2;;



let env,f1 = from_abstract_formula [] 
	       (Poly_syntax.constraint_of_string "t > x+1");;

let env,f2 = from_abstract_formula env
	       (Poly_syntax.constraint_of_string "y = 1");;

let env,f3 = from_abstract_formula env
	       (Poly_syntax.constraint_of_string "x = 2");;

let s = VarMap.empty;;
let e = Ptset.empty;;

let s,e = add_in_conj s e f1;;

let s,e = add_in_conj s e f2;;

let s,e = add_in_conj s e f3;;


(*

  test hash

*)


let d = make_var "dummy";; 
let x = make_var "x_3";;
let d = make_var "dummy";;
let y = make_var "y_5";;
let n = make_var "N";;

let f1 = eq (sub (var n) (var x)) (cte Numbers.one);;
let f2 = eq (sub (var n) (var y)) (cte Numbers.one);;

f1.hkey;;
f2.hkey;;


#use "display.ml";;
display "f1.dot" f1.node;;
display "f2.dot" f2.node;;
