(***************************************************************************

Lexer pour polynomes

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: poly_lexer.mll,v 1.14 2002/04/12 15:33:58 marche Exp $

***************************************************************************)


{

  open Poly_parser;;

  exception Invalid_char of string

}

rule token = parse
  | [' ''\t''\n']       { token lexbuf }
  | "and" | "/\\"       { AND }
  | "or" | "\\/"        { OR }
  | "not" | "~"         { NOT }
  | "exists"            { EXISTS }
  | "forall"            { FORALL }
  | "true"              { TRUE }
  | "false"             { FALSE }
  | "implies" | "->"    { IMPLIES }
  | "equiv" | "<->"     { EQUIV }
  | ['a'-'z''A'-'Z']['a'-'z''A'-'Z''0'-'9''_''\'''@''~']*
                        { IDENT(Lexing.lexeme lexbuf) }
  | ';'                 { SEMICOLON }
  | ','                 { COMMA }
  | '+'                 { PLUS }
  | '/'                 { DIV }
  | '|'                 { VERTICALBAR }
  | '-'                 { MINUS }
  | '.'                 { MULT }
  | '^'                 { EXP }
  | "="|">"|">="|"<"|"<="|"<>"
                        { COMP(Lexing.lexeme lexbuf) }
  | ['0'-'9']+          { INT (Numbers.from_string (Lexing.lexeme lexbuf)) }
  | '('            	{ PARGAUCHE }
  | ')'            	{ PARDROITE }
  | _                   { raise (Invalid_char (Lexing.lexeme lexbuf)) }
  | eof			{ EOF }

