(***************************************************************************

Include file for interactive use of integer solvers

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: tests_finite_domains.ml,v 1.2 2002/04/12 16:01:52 marche Exp $

***************************************************************************)

#load "unix.cma";;
#load "nums.cma";;
#directory "../compat";;
#load "balanced_trees.cmo";;
#load "balanced_trees2.cmo";;
#load "ordered_maps.cmo";;
#load "ordered_sets.cmo";;
#load "time_profiler.cmo";;
#load "listutils.cmo";;
#load "labelled_graphs.cmo";;
#load "numbers.cmo";;
#load "finite_domains.cmo";;
#load "polynomials.cmo";;
#load "non_linear_solving.cmo";;
#load "abstract_constraint.cmo";;
#load "poly_parser.cmo";;
#load "poly_lexer.cmo";;
#load "poly_syntax.cmo";;
open Format;;
open Num;;
open Finite_domains;;
open Non_linear_solving;;
open Poly_parser;;
open Poly_lexer;;
open Poly_syntax;;

let print_num n = print_string (string_of_num n);;

let print_solution (l : (Finite_domains.fd_var_id, Num.num) Finite_domains.Fd_var_map.t) =
  Fd_var_map.iter
    (fun x n ->
       print_string (string_of_fd_var_id x);
       print_string " = ";
       print_string (Num.string_of_num n);
       print_newline())
    l
;;

#install_printer print_num;;
#install_printer print_fd_var_id;;
#install_printer print_fd_constraint;;
#install_printer print_constraint;;
#install_printer print_solution;;


let c = Poly_syntax.constraint_of_string  "x.y = 6 /\ x+y = 5";;

let c = Non_linear_solving.from_abstract_formula c;;

Non_linear_solving.verbose := 2;;

Non_linear_solving.abstraction_method :=0 ;;
non_linear_solve (Numbers.of_int 100) c;;

Non_linear_solving.abstraction_method :=1 ;;
non_linear_solve (Int 100) c;;

Non_linear_solving.abstraction_method :=2 ;;
non_linear_solve (Int 100) c;;

Non_linear_solving.abstraction_method :=3 ;;
non_linear_solve (Int 100) c;;

let c = non_linear_constraints_of_string 
	  "x^2+y^2 = z^2; x > 0; y > 0; z > 0";;


non_linear_solve (Int 100) c;;



