(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: bipartite_graph.mli,v 1.3 1998/04/30 16:52:45 marche Exp $

***************************************************************************)

(*

  Algorithme de couplage maximum dans un graphe bipartite par 
  la methode primale-duale dite "hongroise".
  D'apres Chvatal, Linear Programming, p. 390.

  Le probleme est donne par un graphe bipartite, 
  \begin{itemize}
  \item les noeuds source $U = \{u_i\}$ ont une capacite $\{c_i\}$
  \item les noeuds cible $V = \{v_j\}$ ont une demande $\{d_j\}$
  \item les arcs presents dans le graphe sont representes par une matrice 
  d'incidence $gr$ ($gr_{i,j} = k$ indique que l'arc $i,j$ a une capacite 
  $k$, si  $gr_{i,j} = 0$, l'arc $i,j$ n'est pas present dans le graphe).
  \end{itemize}

  Il s'agit de trouver $X = \{x_{i,j}\}$ tel que
  \begin{itemize}
  \item la capacite des noeuds source est completement utilisee:
  \[
    \sum_j x_{i,j} = c_i \forall i
  \]
  \item la demande des noeuds cible est satisfaite
  \[
  \sum_i x_{i,j} = d_j \forall j
  \]
  \item et bien sur, on n'utilise que les arcs permis.
 \end{itemize}

*)


val couplage_max : int array -> int array -> int array array -> int array array
