(***************************************************************************

  Discrimination nets for many-to-one matching: 
  how to create them, add or remove a rule, and use them.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: dnet.mli,v 1.6 2001/04/20 13:42:14 marche Exp $

***************************************************************************)

(*

Obsolete header:

  CiME Project - Dmons research team - LRI - Universit Paris XI

  $Id: dnet.mli,v 1.6 2001/04/20 13:42:14 marche Exp $

***************************************************************************)

open Symbols
open Positions
open Terms
open Equations

type 'a dnet

type oriente = LEFT | RIGHT

type regle_etendue = 
    {
      o : oriente;
      regle : regle;
      t : term;
      vp : (var_id * position list) list
    }


val fabrique_regle_etendue : 
  oriente -> regle -> term -> regle_etendue

val print_dnet : regle_etendue dnet -> unit

val liste_des_indices_du_dnet : 'a dnet -> 'a list

val empty_dnet : unit -> 'a dnet

val is_an_empty_dnet : 'a dnet -> bool

(* 
   [(create_dnet r t)] builds the discrimination net associated with
   the term [t]. [r] is the rule of which [t] is the left
   hand side.

  *)

val create_dnet : 
  oriente -> regle -> int * regle_etendue dnet;;

(*

  [(add_rule_to_dnet o r dnet)] builds a discrimination net by
  adding the pattern corresponding to the rule [r] (left-hand side
  if [o] is equal to LEFT, right-hand side if [o] is equal to RIGHT)
  to the discrimination net [dnet].

  *)

val add_rule_to_dnet :
  oriente -> regle -> int * regle_etendue dnet -> 
    int * regle_etendue dnet
;;

(*

  [(remove_pattern_from_dnet r dnet)] builds a create dicrimination net by
  removing the pattern coresponding to the rule [r] from the dicrimination 
  net [dnet].

  *)

val remove_rule_from_dnet : 
  int -> int * regle_etendue dnet -> int * regle_etendue dnet;;

(*

  [(find_pattern t dnet)] returns the list of patterns matching
  the term [t] in the discrimination net [dnet].
  If no pattern matches [t], the exception [Not_found] is raised.

*)

val find_rules : 
    term -> int * regle_etendue dnet -> regle_etendue list;;



