(***************************************************************************

  Finding and checking non linearity for the many-to-one matching.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: non_linearity.mli,v 1.5 2001/04/20 13:42:14 marche Exp $

***************************************************************************)

(*

Obsolete header:

  CiME Project - Dmons research team - LRI - Universit Paris XI

  $Id: non_linearity.mli,v 1.5 2001/04/20 13:42:14 marche Exp $

***************************************************************************)

open Positions
open Symbols
open Terms

type match_conditions =
    NO_COND
  | SUFFICIENT_COND of (var_id * position list) list
  | NECESSARY_COND of (var_id * position list) list


(*
  [(non-linearity t)] returns the list of couples [(x,pos_x)] such that
  [x] is a variable and [pos_x] is the list of all its positions in [t].
*)
 
val non_linearity : term -> (var_id * position list) list

(*
  [(check_for_non_linearity t list_of_non_linearities)] checks if for
  all couples (x,pos_x) of [list_of_non_linearities], the subterms of
  [t], [t|_p] are AC-equal when for all [p]s in the same [pos_x].
*)

val check_for_non_linearity : term -> (var_id * position list) list -> bool

(*
  [(extract_substitution t list_of_non_linearities)] checks if for
  all couples (x,pos_x) of [list_of_non_linearities], the subterms of
  [t], [t|_p] are AC-equal when for all [p]s in the same [pos_x], and
  when this is the case, returns the list of [(x,t|_p)] where [p]
  belongs to [pos_x]. Otherwise it fails with "extract_substitution".
*)

val extract_substitution : 
    term -> (var_id * position list) list -> (var_id * term) list
