(***************************************************************************

  AC critical pairs: specifications

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ac_critical_pairs.mli,v 1.2 2001/04/20 13:42:18 marche Exp $

***************************************************************************)

(*

Obsolete header:

  CiME Project - Dmons research team - LRI - Universit Paris XI

  $Id: ac_critical_pairs.mli,v 1.2 2001/04/20 13:42:18 marche Exp $

***************************************************************************)

open Terms
open Equations
open Substitution
open Positions

(*===========================================

  AC critical pair computation

[paires_critiques_ac_etendues (l1->r1) (l2->r2)]
(resp. [auto_paires_critiques_ac_etendues (l->r)]) calcule les paires
critiques ETENDUES (c'est-a-dire tenant compte des extensions
eventuelles) entre l1->r1 et l2->r2 (resp l->r sur elle-meme) et
retourne le resultat sous la forme d'un couple de listes, la premiere
formee de triplets (r1,r2,theta) representant la paire critique en
tete r1\theta=r2\theta, la deuxieme de quintuplets (r1,l2,p,r2,theta)
representant la paire critique r1\theta=l2[r2]_p\theta

===========================================*)

val paires_critiques_ac_etendues : 
  regle -> regle
    -> (term * term * substitution) list * 
      (term * term * position * term * substitution) list

val auto_paires_critiques_ac_etendues : 
  regle 
  -> (term * term * substitution) list * 
    (term * term * position * term * substitution) list

(*===========================================

[paires_critiques_ac_larges l1 r1 l2 r2] calcule les paires critiques
(non etendues) de l2->r2 dans l1->r1 (i.e a une position quelconque de
l1, y compris en tete) et retourne le resultat sous la forme d'un
couple de listes, la premiere formee de triplets (r1,r2,theta)
representant la paire critique en tete r1\theta=r2\theta, la deuxieme
de quintuplets (r1,l2,p,r2,theta) representant la paire critique
r1\theta=l2[r2]_p\theta

===========================================*)


val paires_critiques_ac_larges :
  term -> term -> term -> term 
    -> (term * term * substitution) list * 
      (term * term * position * term * substitution) list

(*===========================================

[paires_critiques_ac_strictes l1 r1 l2 r2] calcule les paires
critiques (non etendues) de l2->r2 strictement dans l1->r1 (i.e a une
position quelconque de l1, sauf en tete) et retourne le resultat sous
la forme d'une liste de quintuplets (r1,l2,p,r2,theta)
representant la paire critique r1\theta=l2[r2]_p\theta

===========================================*)



val paires_critiques_ac_strictes :
  term -> term -> term -> term 
    -> (term * term * position * term * substitution) list





