(***************************************************************************

  AC rewriting: body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ac_rewriting.ml,v 1.3 2001/04/20 13:42:18 marche Exp $

***************************************************************************)

(*

Obsolete header:

  CiME Project - Dmons research team - LRI - Universit Paris XI

  $Id: ac_rewriting.ml,v 1.3 2001/04/20 13:42:18 marche Exp $

***************************************************************************)

open Symbols;;
open Positions;;
open Terms;;
open Equations;;
open Matching;;
open Substitution;;
open Args;;
open Orderings_generalities;;
open Dnet;;
open Generic_normalization;;

(*
open Messages;;
open Errors;;
open Pretty_printing;;
open Format;;
*)

let reducible_by_a_rule ordre terme re = 
  match re.o with
      LEFT ->
      	begin
	  let r = re.regle in
      	  let g = r.l 
	  and d = r.r in
      	    try 
	      let theta = filtrage_ac terme g in
	  	if r.orientation
	  	then true
	  	else
		  begin
		    if ordre terme (substitute_assoc theta d) = Greater_than
		    then true
		    else raise No_match
		  end
      	    with No_match ->
	      let x = r.x in
	  	if is_a_var_id x 
	  	then 
		  begin
		    let f = top_symbol_id g 
    		    and lg = liste_des_sous_termes g in 
		      try 
	      		let theta = filtrage_ac terme (TERM(f,(VAR x)::lg)) in
	      		  if r.orientation
	      		  then true
	      		  else
			    begin
			      if ordre terme (substitute_assoc theta 
						(add_left_var f x d)) = 
				Greater_than
			      then true
			      else raise No_match
			    end
		      with No_match -> false
      		  end
	  	else false
      	end

    | RIGHT ->
      	begin
	  let r = re.regle in
	  let g = r.r 
	  and d = r.l in
      	    try 
	      let theta = filtrage_ac terme g in
	  	if ordre terme (substitute_assoc theta d) = Greater_than
          	then true
	  	else raise No_match
		  
      	    with No_match ->
	      let x = r.y in
		if is_a_var_id x 
		then 
		  begin
		    let f = top_symbol_id g 
    		    and lg = liste_des_sous_termes g in 
		      try 
			let theta = filtrage_ac terme (TERM(f,(VAR x)::lg)) in
			  begin
			    if ordre terme (substitute_assoc theta 
					      (add_left_var f x d)) = 
			      Greater_than
			    then true
			    else raise No_match
			  end
		      with No_match -> false
      		  end
		else false
      	end
;;

let reducible_by_a_set_of_rule ordre t rule_dnet =
  try 
    let rule_list = find_rules t rule_dnet in
      List.exists 
      	(function regle -> reducible_by_a_rule ordre t regle) 
      	rule_list
  with Not_found -> false
;;



let reecriture_ac_en_tete_par_un_couple_ordonne terme g d x =
  try 
    let theta = filtrage_ac terme g in
      substitute_assoc theta d
  with No_match ->  
    try 
      if is_a_var_id x
      then 
	begin
          let f = top_symbol_id g 
          and l = liste_des_sous_termes g in 
          let theta = filtrage_ac terme (TERM(f,(VAR x)::l)) in
            substitute_assoc theta (add_left_var f x d) 
        end
      else raise No_match
    with No_match -> raise Irreducible
;;

let reecriture_ac_en_tete_par_un_couple_ordonne_sans_subst terme g d x =
  try 
    let theta = filtrage_ac terme g in
      (d,build_subst theta)
  with No_match ->  
    try 
      if is_a_var_id x
      then 
	begin
          let f = top_symbol_id g 
          and l = liste_des_sous_termes g in 
          let theta=(filtrage_ac terme (TERM(f,(VAR x)::l))) in
            ((add_left_var f x d),build_subst theta)
        end
      else raise No_match
    with No_match -> raise Irreducible
;;

let reecriture_ac_en_tete_par_un_couple_non_ordonne ordre terme g d x =
  try 
    let theta = filtrage_ac terme g in
    let u = substitute_assoc theta d in
      if ordre terme u = Greater_than
      then u
      else raise No_match 
  with No_match ->  
    try 
      if is_a_var_id x
      then 
	begin
          let f = top_symbol_id g 
          and l = liste_des_sous_termes g in 
          let theta = filtrage_ac terme (TERM(f,(VAR x)::l)) in
          let u = substitute_assoc theta (add_left_var f x d) in
            if ordre terme u = Greater_than
            then u
            else raise No_match 
        end
      else raise No_match
    with No_match -> raise Irreducible
;;

let reecriture_ac_en_tete_par_un_couple_non_ordonne_sans_subst 
  ordre terme g d x =
  try 
    let theta = filtrage_ac terme g in
    let u = substitute_assoc theta d in
      if (ordre terme u) = Greater_than
      then (u,VarMap.empty)
      else raise No_match 
  with No_match ->  
    try 
      if is_a_var_id x
      then 
	begin
          let f = top_symbol_id g 
          and l = liste_des_sous_termes g in 
          let theta=(filtrage_ac terme (TERM(f,(VAR x)::l))) in
          let u = substitute_assoc theta (add_left_var f x d) in
            if (ordre terme u) = Greater_than
            then (u,VarMap.empty)
            else raise No_match 
        end
      else raise No_match
    with No_match -> raise Irreducible
;;

let reecriture_ac_en_tete_par_une_regle ordre t re = 
  match re.o with
      LEFT ->
      	let rule = re.regle in
	  if rule.orientation 
	  then reecriture_ac_en_tete_par_un_couple_ordonne 
	    t rule.l rule.r rule.x
	  else reecriture_ac_en_tete_par_un_couple_non_ordonne 
	    ordre t rule.l rule.r rule.x
    | RIGHT -> (* dans ce cas, la regle n'est pas orientee *)
      	let rule = re.regle in
	  reecriture_ac_en_tete_par_un_couple_non_ordonne 
	    ordre t rule.l rule.r rule.x
;;

let reecriture_ac_en_tete_par_une_regle_sans_subst ordre t re = 
  match re.o with
      LEFT ->
      	let rule = re.regle in
	  if rule.orientation 
	  then reecriture_ac_en_tete_par_un_couple_ordonne_sans_subst
	    t rule.l rule.r rule.x
	  else reecriture_ac_en_tete_par_un_couple_non_ordonne_sans_subst
	    ordre t rule.l rule.r rule.x
    | RIGHT -> (* dans ce cas, la regle n'est pas orientee *)
      	let rule = re.regle in
	  reecriture_ac_en_tete_par_un_couple_non_ordonne_sans_subst 
	    ordre t rule.l rule.r rule.x
;;

let reecriture_ac_en_tete_par_un_systeme_de_regles max ordre t rule_dnet = 
  try
    let liste_des_regles_possibles = find_rules t rule_dnet in
    let rec reecriture_ac_en_tete = function
      	[]  -> raise Irreducible
      | r::rule_set -> 
	  let num = r.regle.num in
    	    if max >= num 
      	    then reecriture_ac_en_tete rule_set
      	    else 
	      begin
      	      	try 
		  reecriture_ac_en_tete_par_une_regle ordre t r
              	with Irreducible -> 
            	  reecriture_ac_en_tete rule_set
	      end in
      reecriture_ac_en_tete liste_des_regles_possibles
  with Not_found -> raise Irreducible
;;


let reecriture_ac_en_tete_par_un_systeme_de_regles_sans_subst 
  max ordre t rule_dnet = 
  try
    let liste_des_regles_possibles = find_rules t rule_dnet in
    let rec reecriture_ac_en_tete = function
      	[]  -> raise Irreducible
      | r::rule_set -> 
	  let num = r.regle.num in
    	    if max >= num 
      	    then reecriture_ac_en_tete rule_set
      	    else 
	      begin
      	      	try 
		  reecriture_ac_en_tete_par_une_regle_sans_subst ordre t r
              	with Irreducible -> 
            	  reecriture_ac_en_tete rule_set
	      end in
      reecriture_ac_en_tete liste_des_regles_possibles
  with Not_found -> raise Irreducible
;;



let rec reecriture_ac_par_un_systeme_de_regles max ordre t rule_dnet =
  
  let rec reecriture_ac_liste = function 
      []     -> raise Irreducible
    | (s::l) -> 
      	try 
	  (reecriture_ac_par_un_systeme_de_regles max ordre s rule_dnet)::l
      	with Irreducible -> 
	  s::(reecriture_ac_liste l)

  and reecriture_ac_liste_ac f = function 
      []     -> raise Irreducible
    | (s::l) -> 
      	try 
 	  let t = 
	    (reecriture_ac_par_un_systeme_de_regles max ordre s rule_dnet) in
      	    try 
	      if (top_symbol_id t) = f
      	      then (liste_des_sous_termes t) @ l
      	      else t::l
            with Invalid_argument _ -> t::l
      	with Irreducible -> s::(reecriture_ac_liste_ac f l) in

    if options_courantes.outermost_reduction_strategy
    then
      try (reecriture_ac_en_tete_par_un_systeme_de_regles max ordre t rule_dnet)
      with Irreducible -> 
    	(match t with 
	     TERM(f,l) -> 
               if is_ac f
      	       then TERM(f,reecriture_ac_liste_ac f l)
      	       else TERM(f,reecriture_ac_liste l)
	   | _ -> raise Irreducible)
    else
      try 
    	(match t with 
	     TERM(f,l) -> 
               if is_ac f
      	       then TERM(f,reecriture_ac_liste_ac f l)
      	       else TERM(f,reecriture_ac_liste l)
	   | _ -> raise Irreducible)
      with Irreducible -> 
    	(reecriture_ac_en_tete_par_un_systeme_de_regles max ordre t rule_dnet)
;;

(*
  normalisation_ac_par_un_systeme_de_regles s rule_dnet retourne 
  la forme normale du terme s vis-a-vis de l'ensemble de regles 
  compilees rule_dnet, avec la strategie determinee par les options 
  courantes.
  
  Le test sur le nombre de pas de reecriture autorises est effectue 
  par la normalisation generique.
*)


let normalisation_ac_par_un_systeme_de_regles ordre t rule_dnet = 
  if is_an_empty_dnet (snd rule_dnet)
  then t
  else 
    if options_courantes.outermost_reduction_strategy
    then 
      let red t = 
        reecriture_ac_en_tete_par_un_systeme_de_regles (-1) ordre t rule_dnet 
      in
	outermost_normalize red t
    else 
      let red t =
	reecriture_ac_en_tete_par_un_systeme_de_regles_sans_subst
 	  (-1) ordre t rule_dnet
      in
      	efficient_innermost_normalize red t

;;


let normalisation_ac_par_un_systeme_de_regles_avec_test 
  bound ordre t rule_dnet = 
  if is_an_empty_dnet (snd rule_dnet)
  then t
  else
    if options_courantes.outermost_reduction_strategy
    then
      let red t = 
          reecriture_ac_en_tete_par_un_systeme_de_regles 
            (-1) ordre t rule_dnet 
      in
       	outermost_normalize_pos bound red t Top Top
    else
      let red t =
          reecriture_ac_en_tete_par_un_systeme_de_regles_sans_subst
            (-1) ordre t rule_dnet 
      in
      	efficient_innermost_normalize_avec_test bound red VarMap.empty t 
;;

let normalisation_ac_forcee_par_un_systeme_de_regles ordre s rule_dnet =
  let bound = ref 0 in
  let s' = 
    normalisation_ac_par_un_systeme_de_regles_avec_test bound ordre
      s rule_dnet in
    if !bound = 0
    then raise Irreducible
    else s'
;;

