(***************************************************************************

  AC rewriting: interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ac_rewriting.mli,v 1.4 2001/04/20 13:42:18 marche Exp $

***************************************************************************)

(*

Obsolete header:

  CiME Project - Dmons research team - LRI - Universit Paris XI

  $Id: ac_rewriting.mli,v 1.4 2001/04/20 13:42:18 marche Exp $

***************************************************************************)

open Symbols;;
open Positions;;
open Terms;;
open Equations;;
open Orderings_generalities;;
open Dnet;;

val reducible_by_a_set_of_rule :
  term ordering -> term -> int * regle_etendue dnet -> bool


(*=====================================

  reecriture_ac_en_tete_par_un_systeme_de_regles n t R retourne le terme
  obtenu par un pas de reecriture en tete sur le terme t avec la premiere
  regle possible de R dont le numero est strictement superieur a n.

=====================================*)

val reecriture_ac_en_tete_par_un_systeme_de_regles :
  int -> term ordering -> term -> int * regle_etendue dnet
    -> term;;

val reecriture_ac_en_tete_par_un_systeme_de_regles_sans_subst :
  int -> term ordering -> term -> int * regle_etendue dnet
      	-> term * term Substitution.substitution 
;;

(*=====================================

reecriture_ac_par_un_systeme_de_regles est la fonction qui generalise
encore la precedente, qui reecrit par une regle arbitraire d'un
systeme de regle R.

Exemple~:

reecriture_ac_par_un_systeme_de_regles <<g(a+b+f(a))>> 
  [REGLE(<<x+c>>,<<x>>);REGLE(<<f(x)+x>>,<<c>>)]

donne <<g(b+c)>>

======================================*)


(*
val reecriture_ac_par_un_systeme_de_regles_partagees : 
	int -> terme -> regle_partagee list 
	-> terme;;
*)

val reecriture_ac_par_un_systeme_de_regles : 
      int -> term ordering -> term -> int * regle_etendue dnet
	-> term;;


(*=====================================

normalisation_ac_par_un_systeme_de_regles it\`ere la fonction
pr\'ec\'edente tant que c'est possible.

(normalisation_ac_par_un_systeme_de_regles s R) renvoie un terme $t$
tel que $s$ se r\'e\'ecrit $t$ par $R$ modulo AC et $t$ est
$R$-irr\'eductible.

Exemple~:

normalisation_ac_par_un_systeme_de_regles <<g(a+b+f(a))>> 
  [REGLE(<<x+c>>,<<x>>);REGLE(<<f(x)+x>>,<<c>>)]

donne <<g(b)>>

======================================*)


(*
val normalisation_ac_par_un_systeme_de_regles_partagees :
	terme -> regle_partagee list 
	-> terme;;
*)

val normalisation_ac_par_un_systeme_de_regles :
      term ordering -> term -> int * regle_etendue dnet
	-> term;;

val normalisation_ac_par_un_systeme_de_regles_avec_test :
  (int ref) -> term ordering -> term -> int * regle_etendue dnet
    -> term
;;

val normalisation_ac_forcee_par_un_systeme_de_regles :
  	term ordering -> term -> int * regle_etendue dnet
	  -> term
;;
