(***************************************************************************

AC unification : specifications

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ac_unifiers.mli,v 1.1 2000/05/16 17:36:35 monate Exp $

***************************************************************************)

open Terms;;
open Substitution;;

(*================

[ac_unifiers s t] returns a list of substitutions 

[ac_unifiers_with_sharing f sl List.tl] do the same with terms [f(sl)]
[f(List.tl)] where [sl] and [List.tl] are linear combination of terms. It uses
sharing to reduce the complexity of the unification problem.

================*)


val ac_unifiers :
  term -> term -> substitution list
;;

(*

val ac_unifiers_in_C :
  symbol_id -> term -> term -> (var_id * term) list list
  = 3 "ac_unifiers"
;;
*)

(*
val ac_unifiers_with_sharing :
  symbol_id -> (term * int) list -> (term * int) list 
  -> substitution list
;;

val ac_unifiers_with_sharing_in_C :
  var_id -> symbol_id -> (term * int) list -> (term * int) list 
  -> (var_id * term) list list
  = 4 "ac_unifiers_with_sharing"
;;
*)

(*===============================

Statistics

statistiques_unification_ac() returns a pair (c,d) of ints where

c = number of calls to unification
d = number of solutions generated

================================*)

(*
val statistiques_unification_ac :
      unit -> int * int 
      = 1 "statistiques_unification_ac"
;;
*)
