(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: args.ml,v 1.1 2000/05/16 17:36:36 monate Exp $

***************************************************************************)

(***************************************************************************
  
Traitement de la ligne de commande : corps

$Id: args.ml,v 1.1 2000/05/16 17:36:36 monate Exp $

***************************************************************************)

open Arg
type type_options =
  {
    mutable nom_fichier : string;
    mutable afficher_etats : bool;
    mutable niveau_de_verbosite : int; 
    mutable orientation_seule : bool;
    mutable completion_close : bool;
    mutable strategy_number : int;
    mutable size_number : int;
    mutable print_to_parse : bool;
    mutable echo_input : bool;
    mutable orientation_prioritaire : bool;
    mutable normalization_steps_bound : int;
    mutable outermost_reduction_strategy : bool;
    mutable undo_possible : bool;
    mutable ordered_completion : bool;
    mutable automatic_ordering : int;
    mutable c_matching : bool;
    mutable print_dioph : int;
    mutable dioph_output : out_channel;
    mutable load_automaton : bool ;
    mutable save_automaton :bool ;
    mutable automaton_input : string ;
    mutable automaton_output : string ;
    mutable goal_oriented : int ; 
  }


  
let options_courantes =
  { nom_fichier = "";
    afficher_etats = false;
    niveau_de_verbosite = 0; 
    orientation_seule = false;
    completion_close = false;
    orientation_prioritaire = false;
    strategy_number = 1000;
    size_number = 1;
    normalization_steps_bound = 10000;
    outermost_reduction_strategy = false;
    print_to_parse = true;
    echo_input = false;
    undo_possible = false;
    ordered_completion = false;
    automatic_ordering = 0;
    c_matching = true;
    print_dioph = 0;
    dioph_output = stdout;
    load_automaton = false ;
    save_automaton = false ;
    automaton_input = "" ;
    automaton_output = "" ;
    goal_oriented = 0; 
  }
;;



let args_spec =
[
("-t", 
  Int(function  n -> options_courantes.size_number <- n),"");
("-ground",
  Unit(function () -> options_courantes.completion_close <- true),"");
("-confl",
  Unit(function () -> options_courantes.orientation_prioritaire <- true),"");
("-ground",
  Unit(function () -> options_courantes.completion_close <- true),"");
("-nocompl",
  Unit(function () -> options_courantes.orientation_seule <- true),"");
("-echo",
  Unit(function () -> options_courantes.echo_input <- true),"");
("-states",
  Unit(function () -> options_courantes.afficher_etats <- true),"");
("-pp",
  Unit(function () -> options_courantes.print_to_parse <- false),"");
("-undo",
  Unit(function () -> options_courantes.undo_possible <- true),"");
("-strat", 
  Int(function n -> options_courantes.strategy_number <- n),"");
("-rew-bound", 
  Int(function n -> options_courantes.normalization_steps_bound <- n),"");
("-v", 
  Unit(function () -> options_courantes.niveau_de_verbosite <- 1),"");
("-verbose", 
  Int(function n -> options_courantes.niveau_de_verbosite <- n),"");
("-inner",
  Unit(function () -> options_courantes.outermost_reduction_strategy <- false),"");
("-outer",
  Unit(function () -> options_courantes.outermost_reduction_strategy <- true),"");
("-ordered",
  Unit(function () -> options_courantes.ordered_completion <- true),"");
("-auto-ord",
  Int(function n -> options_courantes.automatic_ordering <- n),"");
("-c_matching",
  Unit(function () -> options_courantes.c_matching <- true),"");
("-caml_matching",
  Unit(function () -> options_courantes.c_matching <- false),"");
("-print_dioph",
  Int(function n -> options_courantes.print_dioph <- n),"");
("-dioph_output",
  String(function n -> options_courantes.dioph_output <- open_out n),"");
("-load_automaton",
  String(function n -> options_courantes.load_automaton <- true ; options_courantes.automaton_input <- n),"");
("-save_automaton",
  String(function n -> options_courantes.save_automaton <- true ; options_courantes.automaton_output <- n),"");
("-goal",
  Int(function n -> options_courantes.goal_oriented <- n),"")
]

let get_file_name s =
  if options_courantes.nom_fichier = ""
    then options_courantes.nom_fichier <- s
    else raise (Bad "too many arguments")

let lire_ligne_de_commande () =
  parse args_spec get_file_name ""
