/***************************************************************************

Le type list de CAML : corps

Project:                Cime
Author(s):             Claude Marche'

File name:        camllist.c
Created on:              27 jan 93
Last modified on: 05 fev 93

***************************************************************************/


#include "camllist.h"

#if defined (OCAML)
#include <caml/alloc.h> 
#include <caml/memory.h>
#else
#include <alloc.h> 
#include <memory.h>
#endif


/*=============

Constructeurs

=============*/

#define NIL_tag 0
#define CONS_tag 1

liste liste_vide(void)
{
#if defined(OCAML)
  return Val_int(0);
#else
  return Atom(NIL_tag);
#endif
}

liste construit_liste(value x,liste l)
{
  value m;
  Push_roots(r,2);

  r[0] = x;
  r[1] = l;
  m=alloc(2,CONS_tag);
  Field(m,0) = r[0];
  Field(m,1) = r[1];
  Pop_roots();
  return m;
}


/*============

Observateurs

============*/

/*========================

Fonctions sur les listes

========================*/

liste concatene_listes(liste l1,liste l2)
{
  liste result;
  Push_roots(r,3);

  r[0] = l1;
  r[1] = l2;

  if (N_EST_PAS_VIDE(r[0]))
    {
      r[2] = concatene_listes(QUEUE_DE_LISTE(r[0]),r[1]);
      result = construit_liste(TETE_DE_LISTE(r[0]),r[2]);
    }
  else
    {
      result = r[1];
    }
  Pop_roots();
  return result;
}

