/***************************************************************************

Le type list de CAML : interface

Project:                Cime
Author(s):             Claude March\'e

File name:        camllist.h
Created on:              27 jan 93
Last modified on: 02 fev 93

***************************************************************************/

#if !defined(CAMLLIST_H)

#if defined (OCAML)
#include <caml/mlvalues.h>
#else
#include <mlvalues.h>
#endif

typedef value liste;

/*=============

Constructeurs 

=============*/

liste liste_vide(void);
liste construit_liste(value x,liste l);

/*===============

Observateurs

===============*/

#if defined(OCAML)
#define EST_VIDE(l)          (Is_int(l))
#define N_EST_PAS_VIDE(l)    (Is_block(l))
#define TETE_DE_LISTE(l)     (Field(l,0))
#define QUEUE_DE_LISTE(l)    (Field(l,1))
#else
#define EST_VIDE(l)          (!Tag_val(l))
#define N_EST_PAS_VIDE(l)    (Tag_val(l))
#define TETE_DE_LISTE(l)     (Field(l,0))
#define QUEUE_DE_LISTE(l)    (Field(l,1))
#endif

/*========================

Fonctions sur les listes 

========================*/

liste concatene_listes(liste l1,liste l2);

#define CAMLLIST_H
#endif

