/***************************************************************************

Le type terme de CAML : interface

Project:                Cime
Author(s):             Claude March\'e

File name:        camlterm.h
Created on:              27 jan 93
Last modified on: 04 fev 93

***************************************************************************/

#if !defined(CAMLTERM_H)

#if defined (OCAML)
#include <caml/mlvalues.h>
#else
#include <mlvalues.h>
#endif

#include "camllist.h"

typedef enum {
  TYPE_CAML_VARIABLE = 0,
  TYPE_CAML_FREE = 1,
  TYPE_CAML_AC = 2,
  TYPE_CAML_C = 3
  }
type_operateur;

typedef enum {
  CAML_VAR = 0,
  CAML_TERM = 1
  }
term_tag;

typedef value terme;
typedef value regle;
typedef value equation;

/*=============

Constructeurs

=============*/

terme build_term(term_tag t,int f,liste l);

terme construit_terme(type_operateur t,int f,liste l);

equation construit_equation(terme t1, terme t2);

value declare_operator(value vt,value vf);

/*============

Observateurs

============*/

type_operateur type_de_l_operateur(terme t);
int numero_de_l_operateur(terme t);
value liste_des_sous_termes(terme t);

/*========================

Fonctions sur les termes 

========================*/


/*=================================

Fonction d'aplatissement des termes:

Exemple:

aplatir_term <<a+(b+c)>>

donne <<a+b+c>>

=================================*/

/*
terme aplatir_terme(terme t);
*/
#define CAMLTERM_H
#endif

