(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: content.ml,v 1.3 2001/04/20 13:42:19 marche Exp $

***************************************************************************)


open Orderings_generalities

type 'a content =
    Uncomputed
  | No_value
  | Max
  | Some of 'a


(*
  compare_i o i i' compares i and i' of type 'a content, given the
  ordering o an type 'a.
*)
let compare_i o i i' = 
  match i,i' with
      Max, Max -> Equivalent
    | Max, _ -> Greater_than
    | _ , Max -> Less_than
    | No_value, No_value -> Equivalent
    | No_value, _ -> failwith "compare_i"
    | _, No_value -> failwith "compare_i"
    | Uncomputed, _ -> failwith "compare_i"
    | _, Uncomputed -> failwith "compare_i"
    | (Some ii), (Some ii') -> o ii ii'

type i1 = int content
type i2 = int content
type i3 = int array content

(*
  compare_i1 is the usual ordering on integers. It is intended to
  be the ordering argument of compare_i for the type i1.
*)

let compare_i1 = 
  compare_i 
    (fun i i' -> 
       if i<i'
       then Less_than
       else 
	 if i>i'
	 then Greater_than
	 else Equivalent)

(*
  compare_i1 is the usual ordering on integers. It is intended to
  be the ordering argument of compare_i for the type i2.
*)

let compare_i2 = 
  compare_i 
    (fun i i' -> 
       if i<i'
       then Less_than
       else 
	 if i>i'
	 then Greater_than
	 else Equivalent)

(*
  compare_i3 is the lexicographic extension of usual ordering on integers 
  on arrays. It is intended to be the ordering argument of compare_i for 
  the type i3.
*)

let compare_i3 =
  compare_i
    (fun vi vi' ->
       try
	 for j = 0 to (pred (Array.length vi)) do
	   if vi.(j) < vi'.(j)
	   then failwith "Less_than"
	   else 
	     if vi.(j) > vi'.(j)
	     then failwith "Greater"
	 done;
	 Equivalent
       with 
	   Failure "Less_than" -> Less_than
	 | Failure "Greater" -> Greater_than)

