(***************************************************************************

Critical equations : body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: critical_equations.ml,v 1.1 2000/05/16 17:36:39 monate Exp $

***************************************************************************)

(*

Obsolete header:

Project: Cime

Last modified by: $Author: monate $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/oldcimroot/critical_equations.ml,v $
Revision:         $Revision: 1.1 $ 
Last modified on: $Date: 2000/05/16 17:36:39 $

***************************************************************************)

open Normalised_rewriting;;
open Substitution;;

open Terms;;
open Positions;;

(*============================

Compute critical equations obtained form critical pairs, removing
those where substitution is S-reducible

=============================*)

let make_critical_equations (head_cp,deep_cp) =

let rec make_head_equations = function
  [] -> []
| (r1,r2,theta)::eqs ->
  if (s_reducible theta)
    then make_head_equations eqs
    else (substitute theta r1,substitute theta r2)::(make_head_equations eqs) 

and add_deep_equations stock = function
  [] -> stock
| (r1,l2,p,r2,theta)::eqs ->
  if (s_reducible theta)
    then add_deep_equations stock eqs
    else add_deep_equations 
      	   ((substitute theta r1,replace_and_substitute theta l2 p r2)
      	     ::stock) eqs
in (add_deep_equations (make_head_equations head_cp) deep_cp)


;;
