(***************************************************************************


CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: critical_pair_criteria.ml,v 1.1 2000/05/16 17:36:40 monate Exp $

***************************************************************************)

(*

Obsolete header:

Last modified by: $Author: monate $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/oldcimroot/critical_pair_criteria.ml,v $
Revision:         $Revision: 1.1 $ 
Last modified on: $Date: 2000/05/16 17:36:40 $

***************************************************************************)


open Terms;;
open Equations_as_obj;;
open Substitution;;
open Positions;;
open Orderings;;
open Dnet;;
open Normalised_rewriting;;

module type CRITICAL_PAIR_CRITERIA =
  sig
    type equation
    val make_essential_critical_pairs :
      term ordering -> int * regle_etendue dnet ->
        (term * term * substitution) list * 
	(term * term * position * term * substitution) list -> 
	  equation list
  end
;;

let nombre_de_paires_critiques_essentielles_trouvees = ref 0;;

let reset_stat_counters () = 
  nombre_de_paires_critiques_essentielles_trouvees := 0
;;

let increm_nombre_de_paires_critiques_essentielles n =
  nombre_de_paires_critiques_essentielles_trouvees := 
  n + !nombre_de_paires_critiques_essentielles_trouvees;;

let nombre_de_paires_critiques_essentielles () =
  !nombre_de_paires_critiques_essentielles_trouvees
;;

module Critical_pair_criteria =
  functor (Eqt : EQUATION) ->
    struct

open Eqt;;

type equation = t;;

let make_essential_critical_pairs
  ordre rule_dnet (hcpl,pcpl) =

  let hecpl =
    List.fold_left 
      (fun l (r1,r2,theta) -> 
     (*
       printf "substitution : %s\n" (string_of_substitution theta);
       flush stdout;
     *)
	 if (rs_reducible ordre rule_dnet theta)
	 then 
	   begin
      	   (*
      	     printf "reductible !\n";
             flush stdout;
           *)
      	     l
	   end
	 else 
	   begin
	     let eq' = make_equation (substitute theta r1) 
			 (substitute theta r2) in
	       eq'::l
	   end)
      []
      hcpl
  in
  let crit_pairs =
    List.fold_left (fun l (r1,l1,p,r2,theta) -> 
     (*
       printf "substitution : %s\n" (string_of_substitution theta);
       flush stdout;
     *)
	 if (rs_reducible ordre rule_dnet theta)
	 then l
	 else 
	   begin
	     let eq' = make_equation (substitute theta r1)
			 (replace_and_substitute theta l1 p r2) in
	       eq'::l
	   end)
      hecpl
      pcpl
  in	
    nombre_de_paires_critiques_essentielles_trouvees :=
    !nombre_de_paires_critiques_essentielles_trouvees+(List.length crit_pairs);
    crit_pairs
;;


    end;;

module Standard_critical_pair_criteria = Critical_pair_criteria (Equation1);;
module G_critical_pair_criteria = Critical_pair_criteria (Equation_with_goal);;
