(***************************************************************************

Criteria for dicarding critical pairs (for the moment, reducibility of 
the substitution).

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: critical_pair_criteria.mli,v 1.2 2001/04/20 13:42:19 marche Exp $

***************************************************************************)

(*

Obsolete header:

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/oldcimroot/critical_pair_criteria.mli,v $
Revision:         $Revision: 1.2 $ 
Last modified on: $Date: 2001/04/20 13:42:19 $

***************************************************************************)

open Terms;;
open Equations_as_obj;;
open Substitution;;
open Positions;;
open Orderings;;
open Dnet;;

val reset_stat_counters : unit -> unit
val increm_nombre_de_paires_critiques_essentielles : int -> unit
val nombre_de_paires_critiques_essentielles : unit -> int

module type CRITICAL_PAIR_CRITERIA =
  sig
    type equation
    val make_essential_critical_pairs :
      term ordering -> int * regle_etendue dnet ->
        (term * term * substitution) list * 
	(term * term * position * term * substitution) list -> 
	  equation list
  end

module Standard_critical_pair_criteria :
  (CRITICAL_PAIR_CRITERIA with type equation = Equation1.t);;

module G_critical_pair_criteria :
  (CRITICAL_PAIR_CRITERIA with type equation = Equation_with_goal.t);;
