(***************************************************************************

  Detection of redundant equations, for the case of ordered completion.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: encompassment.ml,v 1.2 2001/04/20 13:42:20 marche Exp $

***************************************************************************)

(*

Obsolete header:

  CiME Project - Dmons research team - LRI - Universit Paris XI

  $Id: encompassment.ml,v 1.2 2001/04/20 13:42:20 marche Exp $

***************************************************************************)



open C_declare_operator
open Symbols
open Terms
open Matching

(*
open Pretty_printing;;
open Format;;
open Messages;;
*)

let definir_symbole_egal () =
  definir_operateur C 2 INFIX [] "="


(*
  For efficiency, we assume that [p] is true over couples of AC-equal terms.
*)

let rec il_existe_un_et_tous_les_autres_egaux p l l' = 
  match l,l' with
      [],[] -> true
    | (h::tl),(h'::tl') -> 
	begin
	  if egaux_ac h h'
	  then il_existe_un_et_tous_les_autres_egaux p tl tl'
	  else 
	    p(h,h') & 
	    begin
	      try List.for_all2 egaux_ac tl tl'
	      with 
		  Invalid_argument "List.for_all2" -> false
	    end
	end
    | _, _ -> false

	  
let rec enleve_le_terme t = function
    [] -> raise Not_found 
  | h::l -> 
      if egaux_ac t h
      then l
      else h::(enleve_le_terme t l)

	
let rec enleve_les_termes_communs = function
    [],_ as ll -> ll
  | _,[] as ll -> ll
  | (h::t),l -> 
      try let l'= enleve_le_terme h l in
        enleve_les_termes_communs (t,l')
      with 
	  Not_found -> 
	    let t',l' = enleve_les_termes_communs (t,l) in
	      (h::t'),l'

       
let safe_top_symbol_id = function
    VAR _ -> not_a_symbol_id
  | TERM (f,_) -> f


(*
  est_un_entourage_de (u,v) (s,t) retourne 
  - true si s=C[u\theta]_p et t=C[v\theta]_p
  - false sinon
*)
	
let rec est_un_entourage_de_avec_var x (u,v) (s,t) = 
(*
    message "est_un_entourage_de est appelee sur (u,v) (s,t) avec";
    print_string "u=";
    print_term u;
    force_newline();
    print_string "v=";
    print_term v;
    force_newline();
    print_string "s=";
    force_newline();
    print_term s;
    print_string "t=";
    print_term t;
    force_newline();
    print_flush();
    let res = 
*)
  let egal = get_symbol_id "=" in
    try 
      let _ = filtrage_ac (TERM(egal,[s;t])) (TERM(egal,[u;v])) in
      true
    with 
	No_match -> 
	  begin
	    match s,t with
      		TERM(f,l), TERM(f',l') -> 
		  if f=f'
		  then 
		    begin
		      if is_ac f
		      then 
	       		begin
			  if (safe_top_symbol_id u = f) or 
			    (safe_top_symbol_id v = f)
			  then 
			    try 
			      let _ = filtrage_ac (TERM(egal,[s;t])) 
                       			(TERM(egal,[add_left_var f x u;
						    add_left_var f x v])) in
				true
			    with No_match -> 
			      il_existe_un_et_tous_les_autres_egaux 
                       		(est_un_entourage_de_avec_var x (u,v)) l l'
			  else 
			    il_existe_un_et_tous_les_autres_egaux 
			      (est_un_entourage_de_avec_var x (u,v)) l l'
               		end
		      else 
	       		il_existe_un_et_tous_les_autres_egaux 
			  (est_un_entourage_de_avec_var x (u,v)) l l' 
		    end
		  else false
	      | _ -> false
	  end
(*
  in print_string "Le resultat est ";
  if res then print_string "true" else print_string "false";
  force_newline();
  print_flush();
  res
*)


let est_un_entourage_de u_v (s,t as s_t) =
  let x = new_var (variables_de_liste_de_termes [s;t]) in
    est_un_entourage_de_avec_var x u_v s_t


