(***************************************************************************

Generic Normalization

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: generic_normalization.mli,v 1.1 2000/05/16 17:36:43 monate Exp $

***************************************************************************)

open Positions
open Terms
open Substitution

exception Irreducible

(*

  [(innermost_normalize red t)] retourne la forme normale de [t] vis-a-vis 
  de la relation de reduction [red] appliquee avec la strategie innermost, et 
  echoue s'il faut plus d'etapes qu'autorisees par les options courantes.

  [red] sera en general une fonction qui effectue un pas de S-reecriture ou
  de R/S-reecriture en tete.

*)

(**)
val innermost_normalize_avec_test : 
     (int ref) -> (term -> term) -> term -> term
(*
val innermost_normalize : (term -> term) -> term -> term
*)

(*

  [(outermost_normalize red t)] retourne la forme normale de [t] vis-a-vis 
  de la relation de reduction [red] appliquee avec la strategie outermost, et 
  echoue s'il faut plus d'etapes qu'autorisees par les options courantes.

  [red] sera en general une fonction qui effectue un pas de S-reecriture ou
  de R/S-reecriture en tete.

*)

val outermost_normalize_pos : 
      (int ref) -> (term -> term) -> term -> position -> position -> term

val outermost_normalize : (term -> term) -> term -> term


(*

  [(efficient_innermost_normalize red t)] returns the innermost normal
form of [t] w.r.t to the reduction relation [red].

  [red] is a function which, given a term [t], returns a pair
  [(u,sigma)] such that [t] rewrites to [u sigma], or raises
  [Irreducible] if [t] is irreducible.

  The substitution will be applied during the normalization process.

*)

val efficient_innermost_normalize_avec_test : 
  int ref -> 
    (term -> term * substitution) -> 
      substitution -> term -> term ;;

val efficient_innermost_normalize : 
  (term -> term * substitution) -> term -> term ;;

