(***************************************************************************

 Completion with ordered strategy: body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: goal_oriented_strategy.ml,v 1.2 2001/04/20 13:42:21 marche Exp $

***************************************************************************)

(*

Obsolete header:

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/oldcimroot/goal_oriented_strategy.ml,v $
Revision:         $Revision: 1.2 $ 
Last modified on: $Date: 2001/04/20 13:42:21 $

***************************************************************************)

open Format;;
open Messages;;
open Args;;
open Content;;
open Terms;;
open Equations;;
open Equations_as_obj;;
open Equation_with_goal;;
open Equation_with_goal_set;;
open Orderings;;
open Normalised_rewriting;;
open Simplifications;;
open G_simplifications;;
open Ord_interactive;;
open Stack;;
open Completion_state;;
open G_completion;;
open Symmetrise;;
open G_symmetrise;;
open Orient;;
open G_orient;;
open Select_new_rule;;
open G_select_new_rule;;
open Deduce;;
open G_deduce;;




type transition_rule =
    SYMMETRISE
  | ORIENT
  | SELECT_NEW_RULE
  | DEDUCE
;;

let choice_stack = create ();;

let steps_to_proceed = ref 0;;


(*=====================================

Boucle principale de la compl\'etion

=======================================*)

let init_state order eq_list conj_list = 
  etat.conjectures <- 
  List.fold_left 
    (fun res conj -> 
       let u = conj#first_term
       and v = conj#second_term in
       let u1 = normalisation_par_la_theorie_courante u
       and v1 = normalisation_par_la_theorie_courante v in 
	 if egaux_ac u1 v1
	 then res
	 else
	   let conj' = Conjectures.make_equation u1 v1 in
	     Conjectures_set.insert_equation conj' res;
	     res)
    (Conjectures_set.make_empty_equation_set ()) conj_list;
  etat.prove_conjectures <- not (Conjectures_set.is_empty etat.conjectures);
  add_new_eqs (normalize
		 (List.map 
		    (function eq -> 
		       let eq' = make_aged_equation etat.date 
				   eq#first_term eq#second_term in
			 set_interest2 No_value eq';
			 eq')
		    eq_list))
;;

let indice_du_min ordre l = 
  let rec indice_du_min_aux = function
      ind_min,_,_,[] -> ind_min
    | ind_min,min,ind_cour,h::t -> 
     	if ordre h min = Less_than
     	then indice_du_min_aux (ind_cour,h,ind_cour+1,t)
     	else indice_du_min_aux (ind_min,min,ind_cour+1,t) in

  match l with
      h::t -> indice_du_min_aux (0,h,1,t)
    | [] -> -1
;;

let to_do () = 
  if options_courantes.orientation_prioritaire
  then 
    if not (is_empty etat.eqs_to_process)
    then SYMMETRISE
    else 
      if  not (is_empty etat.preoriented_eqs)
      then ORIENT
      else 
	if not (is_empty etat.pre_rules)
        then SELECT_NEW_RULE
	else DEDUCE
  else 
    match 
      indice_du_min compare_i3
      	[min_interest3 etat.eqs_to_process;
         min_interest3 etat.preoriented_eqs;
	 min_interest3 etat.pre_rules;
	 Rules_set.min_interest3 etat.rules]
    with
	0 -> SYMMETRISE
      | 1 -> ORIENT
      | 2 -> SELECT_NEW_RULE
      | _ -> DEDUCE
;;

let goal_oriented_completion order eq_list conj_list = 

(* mise a jour des coefficients respectifs de la taille et de l'age
   pour le calcul de l'interet d'une equation *)

  config_completion_state ();

(* initialisation de l'etat de la completion *)

  init_state order eq_list conj_list;

(* boucle principale de la completion ordonnee *)
  try
    
    while 
      (not (is_empty etat.eqs_to_process)) or 
      (not (is_empty etat.preoriented_eqs)) or
      (not (is_empty etat.pre_rules)) or
      (etat.major_deduce_index < max_int)
    do

      etat.date <- succ etat.date;
      
      if (options_courantes.afficher_etats) 
      then 
	begin
	  if (!steps_to_proceed <= 1) then afficher_etat ();
	  if !steps_to_proceed <= 1
	  then 
	    begin
              message 
		"n<Return> to proceed n steps (default 1), q to interrupt";
      	      let n= read_line() 
	      in 
            	if n="q" 
      	    	then raise Completion_aborted
	    	else steps_to_proceed := 
		  try int_of_string(n)
	          with Failure _ -> 1
	    end
	  else steps_to_proceed := !steps_to_proceed - 1;
       	end;

      match to_do() with
    	| SYMMETRISE -> symmetrise order
    	| ORIENT -> orient order
    	| SELECT_NEW_RULE -> select_new_rule order
    	| DEDUCE -> deduce order

    done; 

    if etat.postponed_eqs <> []
    then 
      begin
      	print_string "Only unorientable equations left:";
      	force_newline ();
      	print_list_of_equations etat.postponed_eqs;
      	force_newline ();
      	print_flush ();
      	raise Completion_failed
      end;
    
    if etat.prove_conjectures
    then message "Warning : not all conjectures were proved";

    (Rules_set.set_to_list etat.rules), etat.disc_net
      
  with ex -> 
    begin
(*
      afficher_etat ();
*)
      raise ex    
    end
;;
