(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: induction.ml,v 1.1 2000/05/16 17:36:43 monate Exp $

***************************************************************************)

open Messages;;
open Terms;;
open Specif;;
open Tree_automata;;
open Symbols;;
open Equations;;
open Types;;


exception Disproof;;

type gauto = 
    None
  | One of ((symbol_id, term, sorte list, state) automata * state epsilon_rule list) ;;

let gauto2auto = function 
    One x -> x 
  | None -> failwith "Bad error in induction.ml...." ;;

type etat_induction = 
    {
      mutable induction_on : bool;
      mutable sys_regles : regle list;
      mutable automate : gauto (* (symbol_id, term, sorte list, state) automata * state epsilon_rule list *)
  } ;;

let induction = 
  { induction_on = false;
    sys_regles = [];
    automate = None (* ((make_signature_automata ()),[])*)
  };;


let rec see_as_peigne = function
    TERM(f,[t1]) -> 
      if (is_ac f) 
      then (see_as_peigne t1) 
      else (TERM(f,[see_as_peigne t1]))

  |  TERM(f,(t1::tlist)) ->  
       if (is_ac f) 
       then (TERM(f,[t1;see_as_peigne (TERM(f,tlist))]))
       else (TERM(f,List.map see_as_peigne (t1::tlist)))

  | TERM(f,[]) as t -> 
      if (is_ac f) 
      then failwith "Fatal in Induction.see_as_peigne" 
      else t

  | VAR x as v -> v;;


let see_as_peigne_bis t =
  message "Terme ";
  print_term t;
  message "\n est vu comme "; 
  print_term (see_as_peigne t);
  see_as_peigne t;;


let ground_reducible ttt =
  message 
    ("Is "^(string_of_term ttt)^" ground reducible for the system defined by");
  print_liste_de_regles induction.sys_regles;
  let the_peigne = see_as_peigne ttt in
  let result = 
    let env = create_current_env the_peigne in
      nd_test_var_acceptance env (fst (gauto2auto induction.automate)) 
	the_peigne in 
    if (snd result)
    then 
      begin
	message "\nThe automaton says NO ";
	print_newline ()
      end
    else 
      begin
	message "\nThe automaton says YES ";
	print_newline ()
      end;
 (* List.map Pretty_printing.print_state (fst result);flush stdout; *) 

    not (snd result)
;;
