(***************************************************************************

AC matching: body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: matching.ml,v 1.1 2000/05/16 17:36:44 monate Exp $

***************************************************************************)


open Format;;
open Messages;;
open Args;;
(**)
open C_matching;;
open Unix;;
(**)
open Terms;;
open Match_comb;;
open Symbols;;


(*=========================================

Matching function

(filtrage_ac t p) returns a substitution \sigma such that 
 t =_AC p\sigma (t is the term, p is the pattern).

raises No_match if there is no such \sigma

============================================*)

exception No_match;;

let user_time_matching = ref 0.0;;
let system_time_matching = ref 0.0;;
let failure_due_to_size = ref 0;;

(*
type match_result =
  None
| Some of (var_id * term) list
;;
*)


let matching_cache = Cache.create 1;;

let number_of_cache_add = ref 0;;
let number_of_cache_find = ref 0;;
let number_of_failed_cache_find = ref 0;;


let matching_cache_statistics () = 
  (!number_of_cache_add,
   !number_of_cache_find,
   !number_of_failed_cache_find,
   Cache.collision_rate matching_cache,
   Cache.max_hash_length matching_cache)
;;


let do_matching t1 t2 =
  match t2 with
  VAR x -> [(x,t1)]
| TERM _ -> 
  try 
  if (top_symbol_id t1) <> (top_symbol_id t2)
  then raise No_match 
  else (if (taille_terme t2) > (taille_terme t1) 
        then (failure_due_to_size := !failure_due_to_size+1;
             raise No_match)
        else 
(*
      try
        incr number_of_cache_find;
        match Cache.find (t1,t2) matching_cache with
            None -> raise No_match
          | Some sol -> sol
      with Not_found -> 
        incr number_of_failed_cache_find;
*)
      	try 
(*
	  if (string_of_symbol_id (top_symbol_id t1))=""
	  then
	    begin
            print_string "On appelle le matching sur ";
	    print_string (string_of_raw_term t1);
	    print_string " = ";
	    print_string (string_of_raw_term t2);
	    force_newline ();
	    print_flush ()
	    end
	   else
            begin
            print_string "On appelle le matching sur ";
	    print_string (string_of_term t1);
	    print_string " = ";
	    print_string (string_of_term t2);
	    force_newline ();
	    print_flush ()
            end; 
*)
          let sol = (**) if options_courantes.c_matching
                    then filtrage_ac_in_C t1 t2 
                    else (**) resoud_match_pb t2 t1 
          in
(*
               print_string "On a la solution:";
	       force_newline();
               if (sol=[])
               then (print_string "L'identite est solution";
                     force_newline();
                     print_string "--------------";
		     force_newline();
		     print_flush ())
               else
               begin
               List.iter (function (u,v) -> print_string (string_of_term(VAR u));
                                          print_string " = ";
                                          print_string (string_of_term v);
                                          force_newline ())
                       sol;
	       print_string "-----------------";
	       force_newline();
               print_flush ();
               end;
*)
(*
	  Cache.add (t1,t2) (Some sol) matching_cache;
	  incr number_of_cache_add;
*)
      	  sol
        with Failure _ ->   (* Failure "no match" raised by C *)
(*
              print_string "On n'a pas de solution";
	      force_newline();
	      print_flush ();
*)
(*
	  Cache.add (t1,t2) None matching_cache;
	  incr number_of_cache_add;
*)
      	  raise No_match)
  with Invalid_argument _ -> raise No_match
;;
    

let filtrage_ac t1 t2 =
(**)
  let times_before_matching = times() in 
(**)
    try
      let sol = do_matching t1 t2 in
(**)
      let times_after_matching = times() in
    	user_time_matching := 
      	!user_time_matching 
      	+. ( times_after_matching.tms_utime -. 
	       times_before_matching.tms_utime);
    	system_time_matching := 
      	!system_time_matching 
      	+. ( times_after_matching.tms_stime -. 
	       times_before_matching.tms_stime);
(**)
    	sol
(*
  with Failure "no match" ->   (* Failure "no match" raised by C *)
*)
    with No_match -> 
(**)
      let times_after_matching = times() in
    	user_time_matching := 
      	!user_time_matching 
      	+. ( times_after_matching.tms_utime -. 
	       times_before_matching.tms_utime);
    	system_time_matching := 
      	!system_time_matching 
      	+. ( times_after_matching.tms_stime -. 
	       times_before_matching.tms_stime);
(**)
    	raise No_match
;;

(*
let filtrage_ac =
  Time_profiler.profile2
    "Matching.filtrage_ac"
    filtrage_ac
;;
*)

let matching_times ()=
  !user_time_matching,!system_time_matching
;;


let matching_failures_due_to_size () = !failure_due_to_size;;
