(***************************************************************************

AC matching: specifications

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: matching.mli,v 1.1 2000/05/16 17:36:45 monate Exp $

***************************************************************************)


open Symbols
open Terms

(*=========================================

Matching function

(filtrage_ac t p) returns a substitution \sigma such that 
 t =_AC p\sigma (t is the term, p is the pattern).

raises No_match if there is no such \sigma

============================================*)

exception No_match

val filtrage_ac : 
  term -> term
  -> (var_id * term) list


(*

(matching_times ()) returns the pair (user time, system time) spent in
matching, in seconds

*)

val matching_times :
  unit
  -> float * float

val matching_failures_due_to_size : unit -> int

val matching_cache_statistics :
  unit
  -> int * int * int * float * int


