(***************************************************************************

Th\'eorie canonique pour la r\'e\'ecriture normalis\'ee : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: norm_theory.mli,v 1.2 2001/04/20 13:42:22 marche Exp $

***************************************************************************)

(*

Obsolete header:

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/oldcimroot/norm_theory.mli,v $
Revision:         $Revision: 1.2 $ 
Last modified on: $Date: 2001/04/20 13:42:22 $

***************************************************************************)


open Symbols;;
open Positions;;
open Equations;;
open Dnet;;

(*=========================================

La th\'eorie canonique modulo laquelle on travaille est m\'emoris\'ee
dans une variable globale.

=========================================*)

type theorie_connue =
  No_theory 
| A of symbol_id 
| AU of symbol_id * symbol_id
| ACU of symbol_id * symbol_id
| ACI of symbol_id
| ACUI of symbol_id * symbol_id
| ACUN of symbol_id * symbol_id * int
| G of symbol_id * symbol_id * symbol_id
| AG of symbol_id * symbol_id * symbol_id
| CR of symbol_id * symbol_id * symbol_id * symbol_id * symbol_id
| BR of symbol_id * symbol_id * symbol_id * symbol_id 
| FP of int * symbol_id * symbol_id * symbol_id * symbol_id * symbol_id
| Int of symbol_id * symbol_id * symbol_id * symbol_id * symbol_id * symbol_id * symbol_id
| Rat of symbol_id * symbol_id * symbol_id * symbol_id * symbol_id * symbol_id * symbol_id * symbol_id
| USER of regle list
;;

type description_theorie_canonique =
  {
    mutable theories : theorie_connue list;
    mutable theory_assoc_list : (symbol_id,theorie_connue) SymbolMap.t;
    mutable regles : regle list;
    mutable regles_compilees : int * regle_etendue dnet
  }
;;


val theorie_canonique_courante : description_theorie_canonique;;

val print_theorie : theorie_connue list -> unit;;

val string_of_theorie : theorie_connue -> string;;

(*

(systeme_canonique_associe_a th) retourne la liste des regles formant un systeme convergent pour la theorie th

*)


val systeme_canonique_associe_a : theorie_connue -> regle list;;
    
val construit_theorie_canonique : theorie_connue list -> unit;;

val compile_theorie_courante : unit -> unit;;

val clear_current_theory : unit -> unit;;

(*====================

[norm_theory_of f] retourne la theorie dans laquelle f se trouve,
raise Not_found si aucune

===================*)

val norm_theory_of :
  symbol_id
  -> theorie_connue
;;

(*===================

Quelques regles classiques

===================*)

val idempotence :
  symbol_id 
  -> regle
;;

val nilpotence :
  symbol_id -> symbol_id -> int 
  -> regle
;;

val inverse_a_droite : 
  symbol_id -> symbol_id -> symbol_id
  -> regle;;

(*
val inverse_a_droite_etendue : symbol_id -> symbol_id -> symbol_id
      -> regle;;
*)

val inverse_a_gauche : symbol_id -> symbol_id -> symbol_id
      -> regle;;

(*
val inverse_a_gauche_etendue : symbol_id -> symbol_id -> symbol_id
      -> regle;;
*)

