(***************************************************************************

Normalised rewriting: interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: normalised_rewriting.mli,v 1.1 2000/05/16 17:36:46 monate Exp $

***************************************************************************)

open Symbols;;
open Positions;;
open Terms;;
open Equations;;
open Substitution;;
open Orderings;;
open Dnet;;

(*==============================

teste si une substitution est reductible par la
theorie courante

===============================*)

val s_reducible :
  substitution
  -> bool
;;

(*==============================

teste si une substitution est reductible par reeecriture S-normalisee

===============================*)

val rs_reducible :
      term ordering -> int * regle_etendue dnet -> substitution
	  -> bool
;;

(*==============================

Normalisation d'un terme par la theorie courante S

================================*)


val normalisation_par_la_theorie_courante :
      term -> term;;

(*=====================================

  reecriture_normalisee_par_un_systeme_de_regles n t R effectue un pas de reecriture 
  normalisee sur t: mise en forme normale vis-a-vis de la theorie courante puis un
  pas de reecriture usuelle par R.

======================================*)

(*
val reecriture_normalisee_par_un_systeme_de_regles_partagees : 
	int -> term -> regle_partagee list 
	-> term;;
*)

val reecriture_normalisee_par_un_systeme_de_regles : 
      int -> term ordering -> term -> int * regle_etendue dnet
	-> term;;


(*=====================================

normalisation_normalisee_par_un_systeme_de_regles it\`ere la fonction
pr\'ec\'edente tant que c'est possible.

(normalisation_normalisee_par_un_systeme_de_regles s R) renvoie un
terme $t$ tel que $s$ se r\'e\'ecrit de facon normalis\'ee en $t$ par
$R$ et $t$ est $R$-irr\'eductible.

======================================*)

(*
val normalisation_normalisee_par_un_systeme_de_regles_partagees :
	int -> term -> regle_partagee list 
	-> term;;
*)

val last_number_of_normalized_rewrite_steps : unit -> int;;

val normalisation_normalisee_par_un_systeme_de_regles :
	int -> term ordering -> term -> int * regle_etendue dnet
	  -> term;;

val normalisation_forcee_par_un_systeme_de_regles :
	int -> term ordering -> term -> int * regle_etendue dnet
	  -> term;;

(*======================

Normalise a pair of terms and raise 
Ireeducible if none are reducible

=======================*)

val normalise_pair :
	int -> term ordering -> term -> term -> int * regle_etendue dnet
	  -> term * term;;

(*
val normalise_pair_partage :
	int -> term -> term -> regle_partagee list
	-> term * term;;
*)





