(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: positions.ml,v 1.1 2000/05/16 17:36:47 monate Exp $

***************************************************************************)




type position =
   Top
 | Pos of int * position
;;


exception No_more_pos;;

let string_of_position = 
let rec strp = function
   Top -> ""
 | Pos(i,p) -> "." ^   (string_of_int i) ^ (strp p)
in  function
   Top -> "top"
 | Pos(i,p) -> (string_of_int i) ^ (strp p)

;;


let build_pos p n = 
let rec do_build = function
   Top      -> Pos(n,Top)
 | Pos(i,q) -> Pos(i,do_build q)
in do_build p;;


(*
  decompose_pos est la function inverse de build_pos.
*)

let rec decompose_pos = function
  Top -> failwith "decompose_pos"
| Pos(i,Top) -> (Top,i)
| Pos(i,p) -> let (q,j) = decompose_pos p in
              (Pos(i,q),j)
;; 

let rec allonge p q = match (p,q) with
  Top, _ -> raise No_more_pos
| Pos(i,p'), Pos(j,q') -> if (i=j)
                          then Pos(i,allonge p' q')
			  else failwith "allonge"
| Pos(i,_), Top -> Pos(i,Top)
;;

let rec is_smaller_pos p q = 
  match p,q with
    Top , _ -> true
  | Pos _, Top -> false
  | Pos (i,p'), Pos (j,q') -> (i<j) or ((i=j) & (is_smaller_pos p' q'))
	;;
