(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: unification.ml,v 1.1 2000/05/16 17:36:51 monate Exp $

***************************************************************************)


open Unix;;
open Llist;;
open Unif_comb;;
open Lazy_unif_comb;;
open Substitution;;
open Terms;;
open Theorie;;
open Type_de_donnees;;



(*===================

[set_of_unifiers s t] returns the set of most general unifiers of [s]
and [t] according to the current unification theory

===================*)

let number_of_calls = ref 0;;
let number_of_solutions = ref 0;;

let user_time_unif = ref 0.0;;
let system_time_unif = ref 0.0;;

let build_substitution m = build_subst 
    (List.map (function (VAR x,t) -> (x,t) 
           |  (t, VAR x) -> (x,t) 
           | _ -> failwith "Bug in Unification.set_of_unifiers: resoud_unif_pb did not return a problem in solved form!") m)
;;

let unif_type_save = ref (!unif_type);;

let select_ac_only_unification () = 
    unif_type := AC_ONLY
;;

let select_ac_complete_unification () = 
    unif_type := AC_COMPLETE
;;

let select_plain_unification () = 
    unif_type := PLAIN
;;

let save_unif_type () =
    unif_type_save := !unif_type
;;

let restore_unif_type () =
    unif_type := !unif_type_save
;;

let set_of_unifiers s t =
  let times_before_unif = times() in 
  if !unif_type <> PLAIN & (try (top_symbol_id s) <> (top_symbol_id t)
                            with Invalid_argument _ -> false)
  then 
    [] 
  else 
    begin
    number_of_calls := (succ !number_of_calls);
(*
    Printf.printf "On appelle l'unificateur sur %s=%s\n" 
           (string_of_term s) (string_of_term t);
    flush stdout;
*)

(**)
    let l = resoud_unif_pb [(s,t)] in 
(**)
(*
    let l = llist_to_list (lazy_resoud_unif_pb [(s,t)]) in 
*)
(*
    if l = []
    then Printf.printf "Pas de solution\n"
    else
      begin
    Printf.printf "On a les solutions suivantes :\n";
    List.iter (function m -> 
         if (m=[])
         then Printf.printf "L'identite est solution \n-------------------\n"
         else
         begin
         List.map (function (u,v) -> Printf.printf "%s=%s\n" (string_of_term u) 
                                                         (string_of_term v))
             m;
	 Printf.printf "-------------------\n"
         end)
        l
	  end;
*)
    let l2= List.map build_substitution l in
      number_of_solutions := (List.length l) + !number_of_solutions;
      let times_after_unif = times() 
      in
        user_time_unif:= 
      	  !user_time_unif +. 
      	  (times_after_unif.tms_utime -. times_before_unif.tms_utime);
        system_time_unif:= 
      	  !system_time_unif +. 
      	  (times_after_unif.tms_stime -. times_before_unif.tms_stime);
        l2
    end
;;

let unification_stats () =
  (!number_of_calls,!number_of_solutions)
;;

let unification_times ()=
  !user_time_unif,!system_time_unif
;;

let are_unifiable s t = lazy_unifiability s t;;
