(***************************************************************************

Completion strategy: body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: xstrategy.ml,v 1.1 2000/05/16 17:36:52 monate Exp $

***************************************************************************)

(*

Obsolete header:

Last modified by: $Author: monate $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/oldcimroot/xstrategy.ml,v $
Revision:         $Revision: 1.1 $ 
Last modified on: $Date: 2000/05/16 17:36:52 $

***************************************************************************)

open Unix
open Irreducible
open Terms
open Equations
open Orderings
open Normalised_rewriting
open Simplifications
open Ac_critical_pairs
open Format
open Messages
open Norm_theory
open Args
open A
open Au
open Acu
open Aci
open Acui
open Acun
open G
open Ag
open Symmetrization
open Cr
open Br
open Fp
open Rat
open User
open Critical_pair_criteria
open Ord_interactive
open Stack
open Term_orderings
open Encompassment
open Dnet
open Top_layer

open Tk
open Xconfig

(*
exception Completion_failed
exception Completion_aborted
*)


type structure_fenetres =
  {
    mutable completion_frame : Widget.widget;
    mutable other_frame : Widget.widget;
    mutable eqs_frame : Widget.widget;
    mutable eqs_label : Widget.widget;
    mutable eqs_text : Widget.widget;
    mutable eqs_scroll : Widget.widget;
    mutable sym_eqs_frame   : Widget.widget;
    mutable sym_eqs_label : Widget.widget;
    mutable sym_eqs_text   : Widget.widget;
    mutable sym_eqs_scroll   : Widget.widget;
    mutable pre_rules_frame  : Widget.widget;
    mutable pre_rules_label : Widget.widget;
    mutable pre_rules_text  : Widget.widget;
    mutable pre_rules_scroll  : Widget.widget;
    mutable rules_frame  : Widget.widget;
    mutable rules_label : Widget.widget;
    mutable rules_text  : Widget.widget;
    mutable rules_scroll  : Widget.widget;

    mutable conjectures_frame  : Widget.widget;
    mutable conjectures_label : Widget.widget;
    mutable conjectures_text  : Widget.widget;
    mutable conjectures_scroll  : Widget.widget;

    mutable signature_frame  : Widget.widget;
    mutable signature_label : Widget.widget;
    mutable signature_text  : Widget.widget;
    mutable signature_scroll  : Widget.widget;

    mutable stats_frame  : Widget.widget;
    mutable stats_label : Widget.widget;
    mutable stats_text  : Widget.widget;

    mutable one_step_button : Widget.widget;
    mutable ten_steps_button : Widget.widget;
    mutable forever_button : Widget.widget;
    mutable abort_button : Widget.widget;
    mutable undo_button : Widget.widget;
    mutable orient_module_label : tagOrId;
    mutable symmetrize_module_label : tagOrId;
    mutable select_rule_module_label : tagOrId;
    mutable orient_module_canvas : Widget.widget;
    mutable symmetrize_module_canvas : Widget.widget;
    mutable select_rule_module_canvas : Widget.widget;
    mutable deduce_module_canvas_bottom : Widget.widget;
    mutable deduce_module_canvas_right : Widget.widget
  } 


let config_fenetres =
  {
    completion_frame = Widget.dummy;
    other_frame = Widget.dummy;
    eqs_frame = Widget.dummy;
    eqs_label = Widget.dummy;
    eqs_text = Widget.dummy;
    eqs_scroll = Widget.dummy;
    sym_eqs_frame   = Widget.dummy;
    sym_eqs_label = Widget.dummy;
    sym_eqs_text   = Widget.dummy;
    sym_eqs_scroll = Widget.dummy;
    pre_rules_frame  = Widget.dummy;
    pre_rules_label = Widget.dummy;
    pre_rules_text  = Widget.dummy;
    pre_rules_scroll = Widget.dummy;
    rules_frame  = Widget.dummy;
    rules_label = Widget.dummy;
    rules_text  = Widget.dummy;
    rules_scroll = Widget.dummy;

    conjectures_frame  = Widget.dummy;
    conjectures_label = Widget.dummy;
    conjectures_text  = Widget.dummy;
    conjectures_scroll = Widget.dummy;

    signature_frame  = Widget.dummy;
    signature_label = Widget.dummy;
    signature_text  = Widget.dummy;
    signature_scroll = Widget.dummy;

    stats_frame  = Widget.dummy;
    stats_label = Widget.dummy;
    stats_text  = Widget.dummy;

    one_step_button  = Widget.dummy;
    ten_steps_button  = Widget.dummy;
    forever_button  = Widget.dummy;
    abort_button  = Widget.dummy;
    undo_button  = Widget.dummy;
    orient_module_label = Id 0;
    symmetrize_module_label = Id 0;
    select_rule_module_label = Id 0;
    orient_module_canvas = Widget.dummy;
    symmetrize_module_canvas = Widget.dummy;
    select_rule_module_canvas = Widget.dummy;
    deduce_module_canvas_bottom = Widget.dummy;
    deduce_module_canvas_right = Widget.dummy
  } 


let initialiser_fenetres top toolbar_frame = 

  config_fenetres.completion_frame <- 
     Frame.create top 
       [ (*
	   Background(Green);
	 *)
         BorderWidth (Pixels 2)];

  config_fenetres.other_frame <- 
     Frame.create top [BorderWidth (Pixels 2)];

  config_fenetres.eqs_frame <- 
     Frame.create config_fenetres.completion_frame [Relief Sunken; BorderWidth (Pixels 2)];
  config_fenetres.eqs_label <-
     Label.create config_fenetres.eqs_frame 
       [ Font xconfig.text_font; Text Xconfig.eqs_title (*; BorderWidth (Pixels 2); Relief Sunken *)];
  config_fenetres.eqs_text <- 
     Text.create config_fenetres.eqs_frame 
       [Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ; 
	 Wrap WrapWord; 
	 TextHeight 12; TextWidth 48;State Disabled];
  config_fenetres.eqs_scroll <- 
     Scrollbar.create config_fenetres.eqs_frame [];
  Scrollbar.configure config_fenetres.eqs_scroll 
    [ScrollCommand (Text.yview config_fenetres.eqs_text)]; 
  Text.configure config_fenetres.eqs_text 
    [YScrollCommand (Scrollbar.set config_fenetres.eqs_scroll)];


  config_fenetres.sym_eqs_frame <- 
     Frame.create config_fenetres.completion_frame [Relief Sunken; BorderWidth (Pixels 2)];
  config_fenetres.sym_eqs_label <-
     Label.create config_fenetres.sym_eqs_frame 
       [ Font xconfig.text_font; Text Xconfig.sym_eqs_title (*; BorderWidth (Pixels 2); Relief Sunken *)];
  config_fenetres.sym_eqs_text <- 
     Text.create config_fenetres.sym_eqs_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Wrap WrapWord; TextHeight 5; TextWidth 48;State Disabled];
  config_fenetres.sym_eqs_scroll <- 
     Scrollbar.create config_fenetres.sym_eqs_frame [];
  Scrollbar.configure config_fenetres.sym_eqs_scroll 
    [ScrollCommand (Text.yview config_fenetres.sym_eqs_text)]; 
  Text.configure config_fenetres.sym_eqs_text 
    [YScrollCommand (Scrollbar.set config_fenetres.sym_eqs_scroll)];

  config_fenetres.pre_rules_frame <- 
     Frame.create config_fenetres.completion_frame [Relief Sunken; BorderWidth (Pixels 2)];
  config_fenetres.pre_rules_label <-
     Label.create config_fenetres.pre_rules_frame 
       [ Font xconfig.text_font; Text Xconfig.pre_rules_title (*; BorderWidth (Pixels 2); Relief Sunken *)];
  config_fenetres.pre_rules_text <- 
     Text.create config_fenetres.pre_rules_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Wrap WrapWord ; TextHeight 5; TextWidth 48;State Disabled];
  config_fenetres.pre_rules_scroll <- 
     Scrollbar.create config_fenetres.pre_rules_frame [];
  Scrollbar.configure config_fenetres.pre_rules_scroll 
    [ScrollCommand (Text.yview config_fenetres.pre_rules_text)]; 
  Text.configure config_fenetres.pre_rules_text 
    [YScrollCommand (Scrollbar.set config_fenetres.pre_rules_scroll)];

  config_fenetres.rules_frame <- 
     Frame.create config_fenetres.completion_frame [Relief Sunken; BorderWidth (Pixels 2)];
  config_fenetres.rules_label <-
     Label.create config_fenetres.rules_frame 
       [ Font xconfig.text_font; Text Xconfig.rules_title (*; BorderWidth (Pixels 2); Relief Sunken *)];
  config_fenetres.rules_text <- 
     Text.create config_fenetres.rules_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Wrap WrapWord; TextHeight 12; TextWidth 48;State Disabled];
  config_fenetres.rules_scroll <- 
     Scrollbar.create config_fenetres.rules_frame [];
  Scrollbar.configure config_fenetres.rules_scroll 
    [ScrollCommand (Text.yview config_fenetres.rules_text)]; 
  Text.configure config_fenetres.rules_text 
    [YScrollCommand (Scrollbar.set config_fenetres.rules_scroll)];

  config_fenetres.conjectures_frame <- 
     Frame.create config_fenetres.other_frame 
       [Relief Sunken; BorderWidth (Pixels 2)]; 
  config_fenetres.conjectures_label <-
     Label.create config_fenetres.conjectures_frame 
       [ Font xconfig.text_font; Text Xconfig.conjectures_title (*; BorderWidth (Pixels 2); Relief Sunken *)];
  config_fenetres.conjectures_text <- 
     Text.create config_fenetres.conjectures_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Wrap WrapWord; 
	 TextHeight 12; TextWidth 48;State Disabled];
  config_fenetres.conjectures_scroll <- 
     Scrollbar.create config_fenetres.conjectures_frame [];
  Scrollbar.configure config_fenetres.conjectures_scroll 
    [ScrollCommand (Text.yview config_fenetres.conjectures_text)]; 
  Text.configure config_fenetres.conjectures_text 
    [YScrollCommand (Scrollbar.set config_fenetres.conjectures_scroll)];

  config_fenetres.signature_frame <- 
     Frame.create config_fenetres.other_frame 
       [Relief Sunken; BorderWidth (Pixels 2)]; 
  config_fenetres.signature_label <-
     Label.create config_fenetres.signature_frame 
       [ Font xconfig.text_font; Text Xconfig.signature_title (*; BorderWidth (Pixels 2); Relief Sunken *)];
  config_fenetres.signature_text <- 
     Text.create config_fenetres.signature_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Wrap WrapWord; 
	 TextHeight 12; TextWidth 48;State Disabled];
  config_fenetres.signature_scroll <- 
     Scrollbar.create config_fenetres.signature_frame [];
  Scrollbar.configure config_fenetres.signature_scroll 
    [ScrollCommand (Text.yview config_fenetres.signature_text)]; 
  Text.configure config_fenetres.signature_text 
    [YScrollCommand (Scrollbar.set config_fenetres.signature_scroll)];

  config_fenetres.stats_frame <- 
     Frame.create config_fenetres.other_frame 
       [Relief Sunken; BorderWidth (Pixels 2)]; 
  config_fenetres.stats_label <-
     Label.create config_fenetres.stats_frame 
       [ Font xconfig.text_font; Text Xconfig.stats_title (*; BorderWidth (Pixels 2); Relief Sunken *)];
  config_fenetres.stats_text <- 
     Text.create config_fenetres.stats_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Wrap WrapWord; 
	 TextHeight 3; TextWidth 48;State Disabled];

  config_fenetres.one_step_button <-
     Button.create toolbar_frame 
       [ Font xconfig.text_font; 
	 Background (NamedColor xconfig.bgcolor) ;
	 Text Xconfig.one_step_title;
	 State Disabled];
  config_fenetres.ten_steps_button <-
     Button.create toolbar_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Text Xconfig.ten_steps_title;State Disabled];
  config_fenetres.forever_button <-
     Button.create toolbar_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Text Xconfig.forever_title;State Disabled];
  config_fenetres.abort_button <-
     Button.create toolbar_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Text Xconfig.abort_title;State Disabled];
  config_fenetres.undo_button <-
     Button.create toolbar_frame 
       [ Font xconfig.text_font; Background (NamedColor xconfig.bgcolor) ;
	 Text Xconfig.undo_title;State Disabled];

  config_fenetres.orient_module_canvas <-
     Canvas.create config_fenetres.completion_frame
       [ Height (Pixels 40);Width(Pixels 440)
         (*; BorderWidth (Pixels 2); Relief Sunken *)];

  Canvas.create_line config_fenetres.orient_module_canvas
       [ Pixels 20; Pixels 0; Pixels 20; Pixels 40]
       [ ArrowStyle Arrow_Last; 
	 FillColor(NamedColor "red");
	 Width(Pixels 10);
         ArrowShape (Pixels 10,Pixels 15,Pixels 5)];

  config_fenetres.select_rule_module_canvas <-
     Canvas.create config_fenetres.completion_frame
       [ Height (Pixels 40);Width(Pixels 440)
         (*; BorderWidth (Pixels 2); Relief Sunken *)];

  Canvas.create_line config_fenetres.select_rule_module_canvas
       [ Pixels 20; Pixels 0; Pixels 20; Pixels 40]
       [ ArrowStyle Arrow_Last; 
	 FillColor(NamedColor "red");
	 Width(Pixels 10);
         ArrowShape (Pixels 10,Pixels 15,Pixels 5)];

  config_fenetres.symmetrize_module_canvas <-
     Canvas.create config_fenetres.completion_frame
       [ Height (Pixels 40);Width(Pixels 440)
         (*; BorderWidth (Pixels 2); Relief Sunken *)];

  Canvas.create_line config_fenetres.symmetrize_module_canvas
       [ Pixels 20; Pixels 0; Pixels 20; Pixels 40]
       [ ArrowStyle Arrow_Last; 
	 FillColor(NamedColor "red");
	 Width(Pixels 10);
         ArrowShape (Pixels 10,Pixels 15,Pixels 5)];

  config_fenetres.orient_module_label <-
     Canvas.create_text config_fenetres.orient_module_canvas
       (Pixels 40) (Pixels 20)
       [ Anchor W ; Font xconfig.text_font; 
	 Text "Orientation" ; (* LMargin2 (Pixels 40); *)
	 Justify Justify_Left;
	 FillColor(NamedColor "red");
	 Width (Pixels 400) 
         (*; BorderWidth (Pixels 2); Relief Sunken *)];

  config_fenetres.symmetrize_module_label <-
     Canvas.create_text config_fenetres.symmetrize_module_canvas
       (Pixels 40) (Pixels 20)
       [ Anchor W ; Font xconfig.text_font; 
	 Text "Symtrisation" ; (* LMargin2 (Pixels 40); *)
	 Justify Justify_Left;
	 FillColor(NamedColor "red");
	 Width (Pixels 400) 
         (*; BorderWidth (Pixels 2); Relief Sunken *)];


  config_fenetres.select_rule_module_label <-
     Canvas.create_text config_fenetres.select_rule_module_canvas
       (Pixels 40) (Pixels 20)
       [ Anchor W ; Font xconfig.text_font; 
	 FillColor(NamedColor "red");
	 Text "Slection de rgles" ; (* LMargin2 (Pixels 40); *)
	 Justify Justify_Left;
	 Width (Pixels 400) 
         (*; BorderWidth (Pixels 2)*)];

  config_fenetres.deduce_module_canvas_bottom <-
     Canvas.create top
       [ (*
	   Background(White);
         *)
         Height (Pixels 40);Width(Pixels 440);
         BorderWidth (Pixels 0) ];

  Canvas.create_line config_fenetres.deduce_module_canvas_bottom
       [ Pixels 20; Pixels 0; Pixels 20; Pixels 20;Pixels 110;Pixels 20]
       [ FillColor(NamedColor "red");
	 Width(Pixels 10)];

  Canvas.create_text config_fenetres.deduce_module_canvas_bottom
    (Pixels 120) (Pixels 20)
    [ Anchor W ; Font xconfig.text_font; 
      Text "Unification" ; (* LMargin2 (Pixels 40); *)
      FillColor(NamedColor "red");
      Justify Justify_Left	 
         (*; BorderWidth (Pixels 2); Relief Sunken *)];

  Canvas.create_line config_fenetres.deduce_module_canvas_bottom
       [ Pixels 240; Pixels 20; Pixels 450; Pixels 20]
       [ FillColor(NamedColor "red");
	 Width(Pixels 10)];

  config_fenetres.deduce_module_canvas_right <-
     Canvas.create top
       [ (*
	 BorderWidth (Pixels 2);
         Relief Raised;
	   *)
         (*
	   Background(White);
         *) 
         Height (Pixels 720);Width(Pixels 40)
        ];

  Canvas.create_line config_fenetres.deduce_module_canvas_right
       [ Pixels 0; Pixels 700; 
	 Pixels 25; Pixels 700; 
	 Pixels 25; Pixels 20; 
	 Pixels 0; Pixels 20]
       [ ArrowStyle Arrow_Last; 
	 FillColor(NamedColor "red");
	 Width(Pixels 10);
         ArrowShape (Pixels 10,Pixels 15,Pixels 5)];

  ()
;;






let pack_fenetres () =

  pack [config_fenetres.other_frame] 
    [Side Side_Right; Fill Fill_Both; Expand true; PadX (Pixels 0); IPadX(Pixels 0)];

  pack [config_fenetres.deduce_module_canvas_right] 
    [Side Side_Right; Anchor S; PadX (Pixels 0); IPadX(Pixels 0)];

  pack [config_fenetres.completion_frame] 
    [Side Side_Top; Fill Fill_Both; Expand true; PadX (Pixels 0); IPadX(Pixels 0)];

  pack [config_fenetres.deduce_module_canvas_bottom] 
    [Side Side_Right; Anchor E; PadX (Pixels 0); IPadX(Pixels 0) ];

  pack [ config_fenetres.signature_frame] 
    [Side Side_Top; Fill Fill_Both; Expand true];

  pack [ config_fenetres.stats_frame] 
    [Side Side_Top; Fill Fill_X; PadY (Pixels 20)];

  pack [ config_fenetres.conjectures_frame] 
    [Side Side_Top; Fill Fill_Both; Expand true];

  pack [config_fenetres.eqs_frame] 
    [Side Side_Top; Fill Fill_Both; Expand true];

  pack [config_fenetres.orient_module_canvas] 
    [Side Side_Top;Fill Fill_X];

  pack [config_fenetres.sym_eqs_frame] 
    [Side Side_Top; Fill Fill_Both; Expand true];

  pack [config_fenetres.symmetrize_module_canvas] 
    [Side Side_Top; Fill Fill_X];

  pack [config_fenetres.pre_rules_frame] 
    [Side Side_Top; Fill Fill_Both; Expand true];

  pack [config_fenetres.select_rule_module_canvas] 
    [Side Side_Top; Fill Fill_X];

  pack [config_fenetres.rules_frame] 
    [Side Side_Top; Fill Fill_Both; Expand true];

  pack [config_fenetres.eqs_label] [Fill Fill_X; Side Side_Top];
  pack [config_fenetres.sym_eqs_label] [Fill Fill_X; Side Side_Top];
  pack [config_fenetres.pre_rules_label] [Fill Fill_X; Side Side_Top];
  pack [config_fenetres.rules_label] [Fill Fill_X; Side Side_Top];
  pack [config_fenetres.conjectures_label] [Fill Fill_X; Side Side_Top];
  pack [config_fenetres.signature_label] [Fill Fill_X; Side Side_Top];
  pack [config_fenetres.stats_label] [Fill Fill_X; Side Side_Top];

  pack [config_fenetres.eqs_scroll] 
    [Fill Fill_Y;Side Side_Right] ;
  pack [config_fenetres.sym_eqs_scroll] 
    [Fill Fill_Y;Side Side_Right] ;
  pack [config_fenetres.pre_rules_scroll] 
    [Fill Fill_Y;Side Side_Right] ;
  pack [config_fenetres.rules_scroll] 
    [Fill Fill_Y;Side Side_Right] ;
  pack [config_fenetres.conjectures_scroll] 
    [Fill Fill_Y;Side Side_Right] ;
  pack [config_fenetres.signature_scroll] 
    [Fill Fill_Y;Side Side_Right] ;
  pack [config_fenetres.eqs_text] 
    [Fill Fill_Both; Expand true] ;
  pack [config_fenetres.sym_eqs_text] 
    [Fill Fill_Both; Expand true] ;
  pack [config_fenetres.pre_rules_text] 
    [Fill Fill_Both; Expand true] ;
  pack [config_fenetres.rules_text] 
    [Fill Fill_Both; Expand true] ;
  pack [config_fenetres.conjectures_text] 
    [Fill Fill_Both; Expand true] ;
  pack [config_fenetres.signature_text] 
    [Fill Fill_Both; Expand true] ;
  pack [config_fenetres.stats_text] 
    [Fill Fill_Both; Expand true] ;
  pack [ config_fenetres.one_step_button;
	 config_fenetres.ten_steps_button;
	 config_fenetres.forever_button;
	 config_fenetres.abort_button;
	 config_fenetres.undo_button ] [Fill Fill_X]

  





     
(*=====================================

L'\'etat courant de la compl\'etion est repr\'esent\'e par un
enregistrement contenant:

. L'ensemble des equations a orienter
. l'ensemble des equations inorientables
. l'ensemble des equations preorientees
. l'ensemble des preregles
. l'emsemble des regles

=======================================*)

type etat_completion = 
{
mutable eq_to_orient:equation list;
mutable min_eqs_interest : int;
mutable postponed_eqs:equation list; 
mutable preoriented_eqs: equation list; 
mutable min_pre_eqs_interest1 : int;
mutable min_pre_eqs_interest2 : int;
mutable pre_rules:equation list;
mutable min_pre_rules_interest1 : int;
mutable min_pre_rules_interest2 : int;
mutable rules:regle list;
mutable disc_net: regle_etendue dnet;
mutable min_rules_interest1 : int;
mutable min_rules_interest2 : int;
mutable major_deduce_index : int;
mutable minor_deduce_index : int;
mutable date : int;
mutable nb_crit_pairs : int;
mutable user_time : float;
mutable sys_time : float;
mutable num_rule : int;
mutable conjectures : (equation * equation * bool) list;
mutable prove_conjectures : bool;
mutable current_ordering : term ordering
}

let choice_stack = create()

let maxint = 1000000

let etat = { eq_to_orient = []; 
  	     min_eqs_interest = maxint;
             postponed_eqs = []; 
             preoriented_eqs = []; 
	     min_pre_eqs_interest1 = maxint;
	     min_pre_eqs_interest2 = maxint;
             pre_rules = []; 
      	     min_pre_rules_interest1 = maxint;
      	     min_pre_rules_interest2 = maxint;
             rules = [];
	     disc_net = empty_dnet ();
             min_rules_interest1 = maxint;
             min_rules_interest2 = maxint;
      	     major_deduce_index = maxint;
      	     minor_deduce_index = maxint;
             date = 0;
             nb_crit_pairs = 0;
	     user_time = 0.0;
	     sys_time = 0.0;
	     num_rule = 0;
	     conjectures = [];
	     prove_conjectures = false;
	     current_ordering = (function (s,t) -> Greater)
           }

let clear_completion_state () =

  etat.eq_to_orient <- []; 
  etat.min_eqs_interest <- maxint;
  etat.postponed_eqs <- []; 
  etat.preoriented_eqs <- []; 
  etat.min_pre_eqs_interest1 <- maxint;
  etat.min_pre_eqs_interest2 <- maxint;
  etat.pre_rules <- []; 
  etat.min_pre_rules_interest1 <- maxint;
  etat.min_pre_rules_interest2 <- maxint;
  etat.rules <- [];
  etat.min_rules_interest1 <- maxint;
  etat.min_rules_interest2 <- maxint;
  etat.major_deduce_index <- maxint;
  etat.minor_deduce_index <- maxint;
  etat.date <- 0;
  etat.nb_crit_pairs <- 0;
  etat.user_time <- 0.0;
  etat.sys_time <- 0.0;
  etat.num_rule <- 0;
  etat.conjectures <- [];
  etat.prove_conjectures <- false;
  etat.current_ordering <- (function (s,t) -> Greater)

type transition_rule =
     SYMMETRISE
   | ORIENT
   | SELECT_NEW_RULE
   | DEDUCE


let indice_du_min l =

  let rec indice_du_min_aux ind_min min ind_cour = function
      [] -> ind_min
    | h::t -> 
     	if (h < min)
     	then indice_du_min_aux ind_cour h (ind_cour+1) t
     	else indice_du_min_aux ind_min min (ind_cour+1) t 
  in
  indice_du_min_aux (-1) maxint 0 l

let what_to_do () = 
    if options_courantes.orientation_prioritaire
    then 
      if etat.min_eqs_interest < maxint
      then SYMMETRISE
      else 
	if etat.min_pre_eqs_interest1 < maxint
	then ORIENT
	else 
	  if etat.min_pre_rules_interest1 < maxint
          then SELECT_NEW_RULE
	  else DEDUCE

    else 
      match indice_du_min [etat.min_eqs_interest;
                            etat.min_pre_eqs_interest1;
			    etat.min_pre_rules_interest1;
			    etat.min_rules_interest1] 
      with
      	0 -> SYMMETRISE
      | _ -> 
	  begin
            match indice_du_min [ etat.min_pre_eqs_interest2;
		 	      	  etat.min_pre_rules_interest2;
			      	  etat.min_rules_interest2] 
	    with
              0 -> ORIENT
	    | 1 -> SELECT_NEW_RULE
	    | _ -> DEDUCE
          end
;;

let completion_is_finished () =
  (etat.eq_to_orient = []) & 
  (etat.preoriented_eqs = []) & 
  (etat.pre_rules = []) &
  (etat.major_deduce_index = maxint)
;;


let steps_to_proceed = ref 0

let orientation ordre eq = let u=eq.u 
                           and v=eq.v in
                           match (ordre (u,v)) with
    Greater -> u,v
  | Less_than -> v,u
  | _ -> raise Non_orientable


let orientation_seule ordre = 
let rec do_orient = function
    [] -> []
  | eq::eql -> let u,v = (orientation ordre eq) in
            (make_rule ordre (u,v))::(do_orient eql)
in do_orient





(*
exception Il_faut_deduire
*)

(*====================================

Calcul $R,E$ ensembles des r\`egles normalis\'ees et des \'equations critiques
de $(u,v)$ sachant que $u\succ v$

=======================================*)


let couple_normalisant (* ordre *) u v = function
    No_theory      -> failwith "Strategy.couple_normalisant"
  | ACU (n,m)      -> couple_normalisant_acu n m u v
  | AU (n,m)       -> couple_normalisant_au n m u v
  | A (n)          -> couple_normalisant_a n u v
  | ACI (n)        -> couple_normalisant_aci n u v
  | ACUI (n,m)     -> couple_normalisant_acui n m u v
  | ACUN (n,m,k)     -> couple_normalisant_acun n m k u v
  | G (n,m,k)      -> couple_normalisant_g (* ordre *) n m k u v
  | AG (n,m,k)     -> couple_normalisant_ag (* ordre *) n m k u v
  | CR (n,m,k,j,i) -> couple_normalisant_cr (* ordre *) n m k j i u v
  | BR (n,m,k,j) -> couple_normalisant_br (* ordre *) n m k j u v
  | FP (p,n,m,k,j,i) -> couple_normalisant_fp (* ordre *) p n m k j i u v
  | Rat (un_z,coef,irred,plus,zero,moins,mult,un) -> couple_normalisant_rat (* ordre *) un_z coef irred plus zero moins mult un u v
  | USER r_list -> couple_normalisant_user r_list u v
  
let rec flat_map_split f = function
    [] -> ([],[])
  | t::l -> let (e1,r1) = f t
            and (e2,r2) = flat_map_split f l
            in (e1 @ e2, r1 @ r2)  

(*
let rec nettoyer (regles_reduites,regles_a_reduire,equations) =
  match regles_a_reduire with
     [] -> (regles_reduites,equations)
   | r::rl -> let (R1,E1) = (collapse (compose [r] regles_reduites) 
                                     regles_reduites) in
                nettoyer (R1 @ regles_reduites,rl,E1 @ equations)
*)

let ensembles_critiques (* ordre *) u v =  
  let (ec,rc) = flat_map_split (couple_normalisant (* ordre *) u v) 
                     theorie_canonique_courante.theories
  in if rc = []
        then ([(u,v)],ec)
        else (rc,ec)

let coef_size = ref 1
let coef_date = ref 0

let interest_of_date size date =
  (!coef_size * size) + (!coef_date * date)

let interest_of size = interest_of_date size etat.date

let insere_eq num interest u v = 

let rec enlever_entourage = function
    [] -> []
  | eq::l ->
      if est_un_entourage_de (u,v) (eq.u,eq.v)
      then (enlever_entourage l)
      else eq::(enlever_entourage l)
      
      
and insere_rec = 

  function
      [] -> [{ n=num;
	       is_oriented=false;
	       interest=interest;
	       lhs_interest= -1;
	       u=u;v=v;a=etat.date}]
    | eq::l as l' -> 
	if (interest < eq.interest)
    	then { n=num;
	       is_oriented=false;
	       interest=interest;
	       lhs_interest=(-1);
	       u=u;v=v;a=etat.date}::(enlever_entourage l')
        else 
	  if est_un_entourage_de (eq.u,eq.v) (u,v)
	  then l'
	  else eq::(insere_rec l)

in insere_rec





let insere_oriented_eq num interest1 interest2 u v =
let rec insere_rec = function
    [] -> [{n=num;is_oriented=true;interest=interest1;lhs_interest=interest2;u=u;v=v;a=(-1)}]
  | eq::l as l' -> 
      if interest2 < eq.lhs_interest
        then {n=num;is_oriented=true;interest=interest1;lhs_interest=interest2;u=u;v=v;a=(-1)}::l'
        else if interest2=eq.lhs_interest & interest1=eq.interest
	       then let u'=eq.u
                    and v'=eq.v in
                    if (egaux_ac(u,u')) & (egaux_ac(v,v'))
      	       	    or (egaux_ac(u,v')) & (egaux_ac(v,u'))
	            then l'
		    else eq::(insere_rec l)
      	    else eq::(insere_rec l)
in insere_rec

(*
let insere_regle num size x u v = 
let rec insere_rec = function
    [] -> [REGLE(num,size,x,u,v)]
  | (REGLE(_,s2,_,_,_) as rule)::l as l' -> 
      if size < s2 
        then (REGLE(num,size,x,u,v))::l'
        else rule::(insere_rec l)
in insere_rec
*)


(*=====================================

Boucle principale de la compl\'etion

=======================================*)

(*
let add_new_eq n u v =
  let u',v' = rename_pair (u,v) in
  let u = sort_term u'
  and v = sort_term v'
  in
  let t=(size_eq u v) in
    etat.eq_to_orient <- insere_eq n t u v etat.eq_to_orient;
    if t<etat.min_eqs_size
      then etat.min_eqs_size <- t
*)

let add_new_eq eq =
  let u',v' = rename_pair (eq.u,eq.v) in
  let u = sort_term u'
  and v = sort_term v'
  and interest1 = eq.interest
  in
  let t = if interest1<0 then interest_of(size_eq u v) else interest1
  in
  etat.eq_to_orient <- insere_eq eq.n t u v etat.eq_to_orient;
  if t<etat.min_eqs_interest
    then etat.min_eqs_interest <- t
     
let add_new_eqs = List.iter add_new_eq
     
       
let add_new_preoriented_eq eq = 
  let u',v' = rename_pair (eq.u,eq.v) in
  let u = sort_term u'
  and v = sort_term v'
  and i1 = eq.interest
  and i2 = eq.lhs_interest
  in
  let i1 = if i1 < 0 then interest_of(size_eq u v) else i1 
  and i2 = if i2 < 0 then interest_of(size_rule u v) else i2  
  in
  etat.preoriented_eqs <- insere_oriented_eq eq.n i1 i2 u v etat.preoriented_eqs;
  if i1<etat.min_pre_eqs_interest1
      then etat.min_pre_eqs_interest1 <- i1;
  if i2<etat.min_pre_eqs_interest2
      then etat.min_pre_eqs_interest2 <- i2

let add_postponed_eq eq =
  etat.postponed_eqs <- eq::etat.postponed_eqs

let add_new_pre_rule date eq = 
  let i1=eq.interest
  and i2=eq.lhs_interest 
  and u=eq.u
  and v=eq.v in
  let i1=if i1<0 then interest_of_date (size_eq u v) date else i1
  and i2=if i2<0 then interest_of_date (size_rule u v) date else i2
  in
  etat.pre_rules <- insere_oriented_eq eq.n i1 i2 u v etat.pre_rules;
  if (i1 < etat.min_pre_rules_interest1)
     then etat.min_pre_rules_interest1 <- i1;
  if (i2 < etat.min_pre_rules_interest2)
     then etat.min_pre_rules_interest2 <- i2


(*

  get_rule_of_index n returns the rule of (fun a->let rec f n=function b::tl->if b=a then n else f (n+1) tl|_->raise Not_found in f 0) n if it List.exists, raises
  Not_found otherwise

*)


let get_rule_of_index ind =
let rec get_rule = function
  [] -> raise Not_found
| r::rl -> if r.num=ind 
           then r 
           else get_rule rl 
in get_rule etat.rules

let rule_of_index_exists ind =
  try
    get_rule_of_index ind;
    true
  with Not_found -> false



(*

  (existing_index_at_least n) returns the smallest integer m>=n such
  that a rule of (fun a->let rec f n=function b::tl->if b=a then n else f (n+1) tl|_->raise Not_found in f 0) m List.exists, raises Not_found if impossible.

  CAUTION : this function assumes that etat.rules is sorted by
  increasing indices

*)

let existing_index_at_least ind =
let rec get_rule = function
  [] -> raise Not_found
| r::rl -> if r.num>=ind 
           then r
           else get_rule rl 
in get_rule etat.rules


(*

  increm_deduce_indices ()
  find the next pair 

(major (fun a->let rec f n=function b::tl->if b=a then n else f (n+1) tl|_->raise Not_found in f 0), minor (fun a->let rec f n=function b::tl->if b=a then n else f (n+1) tl|_->raise Not_found in f 0))

*)

let increm_deduce_indices () =
  begin
    etat.minor_deduce_index <- 
       begin
	 try let r = existing_index_at_least (etat.minor_deduce_index+1)
	     in r.num
	 with Not_found -> maxint
       end;
    if etat.minor_deduce_index > etat.major_deduce_index
	or not (rule_of_index_exists etat.major_deduce_index)
    then 
      begin
	try 
	  let r = existing_index_at_least (etat.major_deduce_index+1)
	  in
	  etat.major_deduce_index <- r.num;
	  etat.min_rules_interest1 <- r.rule_interest;
	  etat.min_rules_interest2 <- r.rule_lhs_interest;
	  etat.minor_deduce_index <- 
	     begin
	       try let r = existing_index_at_least 1
		   in r.num
	       with Not_found -> maxint
	     end
	with Not_found -> 
	  begin
	    etat.major_deduce_index <- maxint;
      	    etat.min_rules_interest1 <- maxint;
      	    etat.min_rules_interest2 <- maxint;
	    etat.minor_deduce_index <- maxint
	  end
      end
  end

(*

  update_deduce_indices () checks if the current pair (major (fun a->let rec f n=function b::tl->if b=a then n else f (n+1) tl|_->raise Not_found in f 0),
  minor (fun a->let rec f n=function b::tl->if b=a then n else f (n+1) tl|_->raise Not_found in f 0)) is valid, that is points to rules that still exist. If
  not, increm the pair.

  This should be called each time a rule is added or removed of etat.rules

*)


let update_deduce_indices () =
  try
    get_rule_of_index etat.minor_deduce_index;
    get_rule_of_index etat.major_deduce_index;
    ()
  with Not_found -> increm_deduce_indices()
  

let add_new_rule ordre eq =
  etat.num_rule <- etat.num_rule+1;
  let rule = make_numbered_rule ordre etat.num_rule (eq.u,eq.v) in
  let num = rule.num
  and l = rule.l
  and r = rule.r in
  rule.rule_interest <- interest_of(size_eq l r);
  rule.rule_lhs_interest <- interest_of(size_rule l r);
  open_hovbox 0;
  print_string "New rule produced :";
  (fun(x,y)->print_break x y) (2,1);
  print_regle rule;
  force_newline ();
  close_box();
  print_flush();
  (* Collapse *)
  let rules,collapsed_rules,collapsed_numbers = 
    collapse (function _ -> Greater) etat.rules rule
  in
  etat.rules <- rules @ [rule];
  etat.disc_net <- List.fold_right 
       remove_pattern_from_dnet collapsed_numbers etat.disc_net; 

  let pattern = rule.l in
  let extended_rule = fabrique_regle_etendue LEFT rule pattern in
  etat.disc_net <- add_pattern_to_dnet extended_rule pattern etat.disc_net;
  update_deduce_indices();
  if etat.major_deduce_index = maxint
    then begin
      	 etat.major_deduce_index <- num;
      	 etat.minor_deduce_index <- 0;
         update_deduce_indices();
         etat.min_rules_interest1 <- rule.rule_interest;
         etat.min_rules_interest2 <- rule.rule_lhs_interest
	 end;
  Print_statistiques.incr_nombre_de_regles_retenues 
    (-(List.length collapsed_rules));
  if (options_courantes.niveau_de_verbosite >= 1)
    then begin
         print_string "Collapsed rules became:";
       	 print_liste_d_equations collapsed_rules;
         force_newline ();
         print_flush ()
         end;
  let simplified_collapsed_rules = 
    simplify (function _ -> Greater) collapsed_rules etat.disc_net
  in
   if (options_courantes.niveau_de_verbosite >= 1)
    then begin
         print_string "Simplified collapsed rules:";
       	 print_liste_d_equations simplified_collapsed_rules;
         force_newline ();
         print_flush ()
         end;
  add_new_eqs simplified_collapsed_rules


let couple_normalisant_general (* ordre *) u v =  
  let (ec,rc) = flat_map_split (couple_normalisant (* ordre *) u v) 
                     theorie_canonique_courante.theories
  in 
  let ec' = List.map (function (u,v) -> (make_equation u v)) ec
  and rc' = List.map (function (u,v) -> (make_equation u v)) rc
  in
  if rc' = []
        then ([make_equation u v],ec')
        else (rc',ec')

let interest_of_first_eq = function
  [] -> maxint
| (eq::_) -> eq.interest
     

let interest_of_first_preoriented_eq = function
  [] -> maxint
| (eq::_) -> eq.lhs_interest



let display_signature signature =
  begin
    Text.configure config_fenetres.signature_text [State Normal];
    Text.delete config_fenetres.signature_text
      (TextIndex(LineChar(1,0),[])) (TextIndex(End,[]));
    List.iter
      (function (op_list,fix,(typ,arity)) ->
      	begin
	  Text.insert config_fenetres.signature_text
	    (TextIndex(End,[])) 
	    (List.hd op_list) 
	    ["symboles"];
	  List.iter 
	    (function s ->
	      Text.insert config_fenetres.signature_text
	      	(TextIndex(End,[])) 
	      	(","^s) 
	      	["symboles"])
	    (List.tl op_list);
	  let pluriel =
	    if (List.length op_list) >= 2
		then "s"
		else ""
	  in
	  Text.insert config_fenetres.signature_text
	    (TextIndex(End,[])) 
	    (" : "^(match fix with
	      Symbols.PREFIX -> ""
	    | Symbols.INFIX  -> 
		if typ=C_declare_operator.AC then "" else "infixe "
	    | Symbols.POSTFIX -> "postfixe " 
	    | Symbols.DEFAULT -> "")^
	     (match (typ,arity) with
	       (C_declare_operator.VARIABLE,_) -> "variable"^pluriel
	     | (C_declare_operator.AC,_) -> "AC"
	     | (C_declare_operator.C,_) -> "commutatif"^pluriel
	     | (_,0) -> "constante"^pluriel
	     | (_,1) -> "unaire"^pluriel
	     | (_,2) -> "binaire"^pluriel
	     | (_,n) -> (string_of_int n))^
	     "\n")
	    ["fix"]
	end)
      signature;
    
    Text.tag_configure config_fenetres.signature_text "symboles" 
      [Foreground(Black)];
    Text.tag_configure config_fenetres.signature_text "fix" 
      [Foreground(Blue)];
    Text.configure config_fenetres.signature_text [State Disabled]

  end
;;





let xprint_liste_d_equations text_widget eqs_list selected =  
  begin
    Text.configure text_widget [State Normal];
    Text.delete text_widget
      (TextIndex(LineChar(1,0),[])) (TextIndex(End,[]));
    if eqs_list <> []
    then
      begin
      	Text.insert text_widget
	  (TextIndex(End,[])) 
	  ((string_of_equation (List.hd eqs_list))^"\n") 
	  (if selected then ["selected"] else ["all"]);
	List.iter
	  (function e ->
      	    Text.insert text_widget
	      (TextIndex(End,[])) 
	      ((string_of_equation e)^"\n") 
	      ["all"])
	  (List.tl eqs_list);
      end;
    Text.tag_configure text_widget "selected" 
      [Foreground(Red);Background(White);LMargin2 (Pixels 40)];
    Text.tag_configure text_widget "all" 
      [LMargin2 (Pixels 20)];
    Text.configure text_widget [State Disabled]
  end

let xprint_liste_de_conjectures text_widget conj_list is_final_state =  
  begin
    Text.configure text_widget [State Normal];
    Text.delete text_widget
      (TextIndex(LineChar(1,0),[])) (TextIndex(End,[]));
    List.iter
      (function (e,e',b) ->
      	Text.insert text_widget
	  (TextIndex(End,[])) 
	  ( if b 
	    then "vrai"
	    else if is_final_state
		then "faux"
		else "    ")
	  ["answer"];
      	Text.insert text_widget
	  (TextIndex(End,[])) 
	  (" "^(string_of_equation e)^"\n")
	  ["all"];
      	Text.insert text_widget
	  (TextIndex(End,[])) 
	  ("     "^
	   (string_of_equation e')^"\n") 
	  ["conj"])
      conj_list;
    Text.tag_configure text_widget "all" 
      [LMargin2 (Pixels 40)];
    Text.tag_configure text_widget "conj" 
      [Foreground(Blue);LMargin2 (Pixels 40)];
    Text.tag_configure text_widget "answer" 
      [Foreground(Red);Background(White)];
    Text.configure text_widget [State Disabled]
  end
;;

let xprint_liste_de_regles text_widget (* scrollbar_widget *) rules_list selected =  
  begin
    Text.configure text_widget [State Normal];
    let (x,y) = (* Scrollbar.get scrollbar_widget *) Text.yview_get text_widget 
    in
    Text.delete text_widget
      (TextIndex(LineChar(1,0),[])) (TextIndex(End,[]));
    List.iter
      (function r ->
      	let str = 
	  (if r.num = etat.major_deduce_index
	   then  
	    if r.num = etat.minor_deduce_index
	    then "->>"
	    else "-->"
	   else 
	    if r.num = etat.minor_deduce_index
	    then "-> "
	    else "   ")^
	  (string_of_rule r)
	in 
	begin
	  Text.insert text_widget
	    (TextIndex(End,[])) 
	    (str^"\n") 
	    (if selected & 
	      (r.num = etat.major_deduce_index or 
	       r.num = etat.minor_deduce_index) 
	    then ["selected"] else ["all"]);
	end)
      rules_list;
    Text.tag_configure text_widget "selected" 
      [Foreground(Red);Background(White);LMargin2 (Pixels 100)];
    Text.tag_configure text_widget "all" 
      [LMargin2 (Pixels 100)];
(*
    Scrollbar.set scrollbar_widget x y;
*)
    Text.yview text_widget (MoveTo x);
    
    Text.configure text_widget [State Disabled]
  end
;;


let temps_ecoule () =
let user_time = etat.user_time 
and sys_time = etat.sys_time
in
if user_time >= 60.0
then 
  begin
  let um = Pervasives.truncate(user_time /. 60.0) 
  in
  let us = Pervasives.truncate(user_time -. float(um) *. 60.0) 
  in
  sprintf "%dmn %02ds" um us
  end
else
  sprintf "%5.2fs" user_time
;;


let xdisplay_statistiques () =
  let text_widget = config_fenetres.stats_text
  in 
  let inserer s = 
    Text.insert text_widget
      (TextIndex(End,[])) 
      (s^"\n") 
      ["all"]
  in

  begin
    Text.configure text_widget [State Normal];
    Text.delete text_widget
      (TextIndex(LineChar(1,0),[])) (TextIndex(End,[]));

    inserer ("tape de la compltion            : "^
	     (string_of_int etat.date));
    inserer ("Nb de paires critiques engendres : "^
	     (string_of_int etat.nb_crit_pairs));
    inserer ("Temps pass                       : "^
	     (temps_ecoule()));

    Text.tag_configure text_widget "all" 
      [LMargin2 (Pixels 40)];
    Text.tag_configure text_widget "conj" 
      [Foreground(Blue);LMargin2 (Pixels 40)];
    Text.tag_configure text_widget "answer" 
      [Foreground(Red);Background(White)];
    Text.configure text_widget [State Disabled]
  end
;;    





let afficher_etat () =
  let w =what_to_do()
  in
  begin
(*
    print_string "affichage de l'etat";
    print_newline();
    print_string (sprintf "Deduction indices : %d %d" 
                    etat.major_deduce_index etat.minor_deduce_index);
    print_newline ();
*)
    xprint_liste_d_equations 
      config_fenetres.eqs_text etat.eq_to_orient (w=SYMMETRISE);
  (*
    print_liste_d_equations etat.postponed_eqs;
    *)
    xprint_liste_d_equations 
      config_fenetres.sym_eqs_text etat.preoriented_eqs (w=ORIENT);
    xprint_liste_d_equations 
      config_fenetres.pre_rules_text etat.pre_rules (w=SELECT_NEW_RULE);
    xprint_liste_de_regles 
      config_fenetres.rules_text 
      (* config_fenetres.rules_scroll *)
      etat.rules (w=DEDUCE);
  
    xprint_liste_de_conjectures 
      config_fenetres.conjectures_text
      etat.conjectures
      (completion_is_finished());

    xdisplay_statistiques();

    let buttons_state = 
      if completion_is_finished() or !steps_to_proceed>0
      then Disabled
      else Normal
    in
    begin
      Button.configure config_fenetres.one_step_button
	[State buttons_state];
      Button.configure config_fenetres.ten_steps_button
	[State buttons_state];
      Button.configure config_fenetres.forever_button
	[State buttons_state];
    end;
    
    let abort_button_state =
      if !steps_to_proceed>0
      then Normal
      else Disabled
    in
    Button.configure config_fenetres.abort_button
	[State abort_button_state];

    let undo_button_state =
      if !steps_to_proceed>0 or Stack.length(choice_stack)=0
      then Disabled 
      else Normal
    in
    Button.configure config_fenetres.undo_button
      [State undo_button_state]

 (*
   Tk.update()
   *)
  end



(* Symmetrise *)

let symmetrise order =
  let eq = List.hd etat.eq_to_orient in
  
  etat.eq_to_orient <- List.tl etat.eq_to_orient;
  etat.min_eqs_interest <- interest_of_first_eq etat.eq_to_orient;
  try 
    let sym_eq = (symmetrize order eq) 
    in
    if (options_courantes.niveau_de_verbosite >= 1)
    then 
      begin
      	print_string "Orienting and symmetrizing the equation ";
      	print_equation eq;
      	(fun(x,y)->print_break x y) (1,0);
      	print_string "into";
      	(fun(x,y)->print_break x y) (1,40);
      	print_equation sym_eq;
      	force_newline ();
      	print_flush ()
      end;
    try 
      let sym_eqs = 
	forced_left_simplify (function _ -> Greater) sym_eq etat.disc_net
      in add_new_eqs sym_eqs
    with Irreducible -> add_new_preoriented_eq sym_eq
      	
  with Non_orientable -> 
    begin
      open_hovbox 0;
      print_string "Postponing the equation";
      (fun(x,y)->print_break x y)(1,2);
      print_equation eq;
      force_newline ();
      close_box ();
      print_flush ();
      add_postponed_eq eq
    end






 (* Orient *)

let orient order =

  let eq = List.hd etat.preoriented_eqs
  in
  etat.preoriented_eqs <- List.tl etat.preoriented_eqs;
  etat.min_pre_eqs_interest1 <- interest_of_first_eq etat.preoriented_eqs;
  etat.min_pre_eqs_interest2 <- interest_of_first_preoriented_eq etat.preoriented_eqs;
  let psi,theta = (couple_normalisant_general eq.u eq.v) 
  in
  if (options_courantes.niveau_de_verbosite >= 1)
  then 
    begin
      print_string "Normalising pair of the equation";
      (fun(x,y)->print_break x y) (1,0);
      print_equation eq;
      print_string " is";
      force_newline ();
      print_string  "Psi =";
      print_liste_d_equations psi;
      print_string ";";
      (fun(x,y)->print_break x y) (1,0);
      print_string "Theta =";
      print_liste_d_equations theta;
      force_newline ();
      print_flush ()
    end;
  if (options_courantes.niveau_de_verbosite >= 2)
  then begin
    print_string " ---- SIMPLIFYING...";
    force_newline ()
  end;  
  let final_psi,psi_collapsed = 
    simplify_and_left_split (function _ -> Greater) psi etat.disc_net
  and final_theta = simplify (function _ -> Greater) theta etat.disc_net
  in
  if (options_courantes.niveau_de_verbosite >= 1)
  then 
    begin
      print_string "Theta Simplified =";
      print_liste_d_equations final_theta;
      force_newline ();
      print_flush ()
    end;
  add_new_eqs final_theta;
  add_new_eqs psi_collapsed;
  List.iter (add_new_pre_rule eq.a) final_psi




let reduce_a_conjecture max = function
  (e1,e2,b) as conj ->
    if b then conj
    else 
      try
      	let (t1,t2) = normalise_pair e2.n (function _ -> Greater) e2.u e2.v etat.disc_net
	in 
	begin
	  let eq' = make_aged_equation e1.a t1 t2 in
          eq'.n <- max;
	  (e1,eq',egaux_ac(t1,t2))
	end
      with Irreducible -> conj
;;




let solve_conjectures () =
  etat.conjectures <-
    List.map (reduce_a_conjecture 0 (* (max_num_rules etat.rules) *)) etat.conjectures
;;



(* Select create rule *)

let select_new_rule order =
     begin
     let eq = List.hd etat.pre_rules
     in
     etat.pre_rules <- List.tl etat.pre_rules;
     Print_statistiques.incr_nombre_de_regles_produites ();
     Print_statistiques.incr_nombre_de_regles_retenues 1;
     etat.min_pre_rules_interest1 <- interest_of_first_eq etat.pre_rules;
     etat.min_pre_rules_interest2 <- interest_of_first_preoriented_eq etat.pre_rules;
     (* Collapse is made in add_new_rule *)
     add_new_rule order eq; 
     (* Compose *)
     let rules = compose (function _ -> Greater) etat.rules etat.disc_net 
     in
     etat.rules <- rules;
     (* Let's try solving conjectures *)
     if etat.prove_conjectures
       then solve_conjectures();
     (* Simplify *)
     let eq,eq_simpl = simplify_and_split (function _ -> Greater) etat.eq_to_orient etat.disc_net
     in
     etat.eq_to_orient <- eq;
     etat.min_eqs_interest <- interest_of_first_eq eq;
     add_new_eqs eq_simpl;
     let eq,eq_simpl = simplify_and_split (function _ -> Greater) etat.postponed_eqs etat.disc_net
     in
     etat.postponed_eqs <- eq;
     add_new_eqs eq_simpl;
     let eq,eq_simpl = simplify_and_split etat.preoriented_eqs etat.rules
     in
     etat.preoriented_eqs <- eq;
     etat.min_pre_eqs_interest1 <- interest_of_first_eq eq;
     etat.min_pre_eqs_interest2 <- interest_of_first_preoriented_eq eq;
     add_new_eqs eq_simpl;
     let eq,eq_simpl = simplify_and_split etat.pre_rules etat.rules
     in
     etat.pre_rules <- eq;
     etat.min_pre_rules_interest1 <- interest_of_first_eq eq;
     etat.min_pre_rules_interest2 <- interest_of_first_preoriented_eq eq;
     add_new_eqs eq_simpl
     
     end









 (* Deduce *)


let deduce order =
  begin
(*
    if (etat.minor_deduce_index > etat.major_deduce_index)
    then increment_major_deduce_index ();
*)
    try let major_rule = (get_rule_of_index etat.major_deduce_index)
    in
    if (etat.minor_deduce_index = etat.major_deduce_index)
    then (* Auto-deduce *)
      begin
    	if (options_courantes.niveau_de_verbosite >= 1)
        then 
	  begin
      	    print_string " ---- SELF-DEDUCTION with ";
            print_regle major_rule;
            force_newline ();
            print_flush ()
	  end;
	let crit_sets = (auto_paires_critiques_ac_etendues major_rule) 
	in
	let crit_pairs = 
	  (make_essential_critical_pairs order etat.rules crit_sets) 
	in
	etat.nb_crit_pairs <- etat.nb_crit_pairs + (List.length crit_pairs);
	if options_courantes.niveau_de_verbosite >= 2
        then 
	  begin
      	    print_string "set of essential critical pairs:";
            (fun(x,y)->print_break x y) (1,0);
	    print_liste_d_equations crit_pairs;
            force_newline ();
            print_flush ()
      	  end;
        if options_courantes.niveau_de_verbosite >= 1
        then 
	  message 
	    (sprintf "%d essential critical pairs." (List.length crit_pairs));
        if options_courantes.niveau_de_verbosite >= 1
        then message " ---- SIMPLIFY & DELETE ------------------------------";
        let simpl_crit_pairs = (simplify crit_pairs etat.rules) 
	in
	add_new_eqs simpl_crit_pairs
      end
    else
      begin
	try
      	  let minor_rule = (get_rule_of_index etat.minor_deduce_index) 
	  in
          if (options_courantes.niveau_de_verbosite >= 1)
          then 
	    begin
      	      print_string " ---- DEDUCTION with";
              (fun(x,y)->print_break x y) (1,0);
              print_regle major_rule;
              print_string " and ";
              print_regle minor_rule;
              force_newline ();
              print_flush ()
	    end;
	  let crit_sets = 
      	    (paires_critiques_ac_etendues major_rule minor_rule) 
	  in
	  let crit_pairs = 
	    (make_essential_critical_pairs order etat.rules crit_sets) 
	  in
  	  if (options_courantes.niveau_de_verbosite >= 2)
          then 
	    begin
      	      print_string "set of essential critical pairs:";
              (fun(x,y)->print_break x y) (1,0);
	      print_liste_d_equations crit_pairs;
              force_newline ();
              print_flush ()
            end;
          if (options_courantes.niveau_de_verbosite >= 1)
          then 
	    begin
              print_string 
		(sprintf "%d essential critical pairs." 
		   (List.length crit_pairs));
              force_newline ();
              print_flush ()
            end;
          if (options_courantes.niveau_de_verbosite >= 1)
          then message "----- SIMPLIFY & DELETE ----------------------------";
          let simpl_crit_pairs = (simplify crit_pairs etat.rules) 
	  in
          if (options_courantes.niveau_de_verbosite >= 1)
          then message "----- END of SIMPLIFY & DELETE ---------------------";
	  add_new_eqs simpl_crit_pairs
	with Not_found -> ()
      end;
    increm_deduce_indices ()
    with Not_found -> 
      begin
	failwith "bug in Xstrategy.deduce";
	increm_deduce_indices ()
      end
  end



let several_steps_of_completion () =
  begin
(* push the state onto the stack if the Undo_possible option is on *)
(* the state is pushed even if the answer to the next ordering question *)
(* is undo ! *)
  
  if true (* options_courantes.undo_possible *)
  then 
    begin
      let new_state = 
      	{ eq_to_orient = etat.eq_to_orient;
  	  min_eqs_interest = etat.min_eqs_interest;
          postponed_eqs = etat.postponed_eqs;
          preoriented_eqs = etat.preoriented_eqs;
	  min_pre_eqs_interest1 = etat.min_pre_eqs_interest1;
	  min_pre_eqs_interest2 = etat.min_pre_eqs_interest2;
          pre_rules = etat.pre_rules;
      	  min_pre_rules_interest1 = etat.min_pre_rules_interest1;
      	  min_pre_rules_interest2 = etat.min_pre_rules_interest2;
          rules = etat.rules;
          min_rules_interest1 = etat.min_rules_interest1;
          min_rules_interest2 = etat.min_rules_interest2;
      	  major_deduce_index = etat.major_deduce_index;
      	  minor_deduce_index = etat.minor_deduce_index;
          date = etat.date;
          nb_crit_pairs = etat.nb_crit_pairs;
          user_time = etat.user_time;
          sys_time = etat.sys_time;
          num_rule = etat.num_rule;
	  conjectures = etat.conjectures;
	  prove_conjectures = etat.prove_conjectures;
	  current_ordering = etat.current_ordering
        } 
      in push new_state choice_stack
    end;
  
(* end of pushing the state *)
    while (!steps_to_proceed > 0) do
      begin
	etat.date <- succ etat.date;
	steps_to_proceed := !steps_to_proceed - 1;

	let order = etat.current_ordering 
	and before = Unix.times()
	in
	begin
	  match what_to_do() 
      	  with
    	    SYMMETRISE -> symmetrise order
      	  | ORIENT -> orient order
      	  | SELECT_NEW_RULE -> select_new_rule order
      	  | DEDUCE -> deduce order
	end;
	let after = Unix.times()
	in
	etat.user_time <- 
	   etat.user_time +. 
	     after.tms_utime -. before.tms_utime;
	etat.sys_time <- 
	   etat.sys_time +. 
	     after.tms_stime -. before.tms_stime;
	if completion_is_finished()
    	then 
	  begin
	(* completion succeeded or failed *)
	    
	    steps_to_proceed := 0;

  	    if etat.postponed_eqs <> []
     	    then begin
              print_string "Only unorientable equations left:";
              force_newline ();
              print_liste_d_equations etat.postponed_eqs;
              force_newline ();
              print_flush ();
	  (*
	    raise Completion_failed
	    *)
      	    end;
	    
(*
  	    if etat.prove_conjectures
    	    then begin
      	      message "Warning : not all conjectures were proved"
	    end;
*)
	    
	  end;
	if !steps_to_proceed>0
	then
	  begin
	    afficher_etat ();
	    Tk.update()
	  end
      end
    done;
    
    afficher_etat ()    
  end


let one_step_of_completion () =
  begin
    steps_to_proceed := 1;
    several_steps_of_completion ()
  end

let ten_steps_of_completion () =
  begin
    steps_to_proceed := 10;
    several_steps_of_completion ()
  end

let forever_completion () =
  begin
(*
    Button.configure config_fenetres.one_step_button
      [State Disabled];
    Button.configure config_fenetres.ten_steps_button
      [State Disabled];
    Button.configure config_fenetres.forever_button
      [State Disabled];    
    Button.configure config_fenetres.abort_button
      [State Normal];    
    Button.configure config_fenetres.undo_button
      [State Disabled];    
*)
    steps_to_proceed := 1000000;
    several_steps_of_completion ()
  end

let abort_completion () =
  begin
    steps_to_proceed := 0;
(*
    Button.configure config_fenetres.one_step_button
      [State Normal];
    Button.configure config_fenetres.ten_steps_button
      [State Normal];
    Button.configure config_fenetres.forever_button
      [State Normal];    
    Button.configure config_fenetres.undo_button
      [State Normal];    
    Button.configure config_fenetres.abort_button
      [State Disabled];    
*)
    afficher_etat();
  end


let undo_one_step () =
  try 
    if true (* options_courantes.undo_possible *)
    then 
      begin
        let new_state = pop(choice_stack) in 
	etat.eq_to_orient <- new_state.eq_to_orient;
  	etat.min_eqs_interest <- new_state.min_eqs_interest;
        etat.postponed_eqs <- new_state.postponed_eqs; 
        etat.preoriented_eqs <- new_state.preoriented_eqs;
	etat.min_pre_eqs_interest1 <- new_state.min_pre_eqs_interest1;
	etat.min_pre_eqs_interest2 <- new_state.min_pre_eqs_interest2;
        etat.pre_rules <- new_state.pre_rules;
      	etat.min_pre_rules_interest1 <- new_state.min_pre_rules_interest1;
      	etat.min_pre_rules_interest2 <- new_state.min_pre_rules_interest2;
        etat.rules <- new_state.rules;
        etat.min_rules_interest1 <- new_state.min_rules_interest1;
        etat.min_rules_interest2 <- new_state.min_rules_interest2;
      	etat.major_deduce_index <- new_state.major_deduce_index;
      	etat.minor_deduce_index <- new_state.minor_deduce_index;
	etat.conjectures <- new_state.conjectures;
	etat.prove_conjectures <- new_state.prove_conjectures;
        etat.date <- new_state.date;
        etat.nb_crit_pairs <- new_state.nb_crit_pairs;
        etat.user_time <- new_state.user_time;
        etat.sys_time <- new_state.sys_time;
        etat.num_rule <- new_state.num_rule;
	etat.current_ordering <- new_state.current_ordering;

(*
    	Button.configure config_fenetres.one_step_button
	  [State Normal];
    	Button.configure config_fenetres.ten_steps_button
	  [State Normal];
    	Button.configure config_fenetres.forever_button
	  [State Normal];    
*)
	afficher_etat ()
      end
    else raise Empty
  with Empty -> 
    begin
      message "No more undo information"
    (*
      add_new_eq eq
      *)
    end


let initialise_completion order eq_list conj_list = 

  let strat = options_courantes.strategy_number in
     if strat = 0
        then begin
      	     coef_size := 1;
      	     coef_date := 0
	     end
	else if strat < 0
               then begin
      	            coef_size := 1;
      	            coef_date := -strat
	            end
	       else begin
      	            coef_size := strat;
      	            coef_date := 1
	            end;

  etat.current_ordering <- (ordre_of_ordre_disponible order);

  add_new_eqs (normalize eq_list);

  etat.prove_conjectures <- conj_list <> [];
  etat.conjectures <- 
     List.map (function eq ->
       let [eq'] = (normalize [eq])
       in (eq',eq',egaux_ac(eq'.u,eq'.v)))
       conj_list;

  Stack.clear choice_stack;

  Button.configure config_fenetres.one_step_button
    [State Normal; Command one_step_of_completion];
  Button.configure config_fenetres.ten_steps_button
    [State Normal; Command ten_steps_of_completion];
  Button.configure config_fenetres.forever_button
    [State Normal; Command forever_completion];
  Button.configure config_fenetres.abort_button
    [State Disabled; Command abort_completion];
  Button.configure config_fenetres.undo_button
    [State Disabled; Command undo_one_step];


  let ordre = string_of_ordre order
  in
  let ordre' =
    (* if String.length ordre > 40
	then String.sub ordre 0 41
	else *) ordre
  in

  Canvas.coords_set 
    config_fenetres.orient_module_canvas
    config_fenetres.orient_module_label
    [(Pixels 40);(Pixels 0)];

  Canvas.configure_text 
    config_fenetres.orient_module_canvas
    config_fenetres.orient_module_label
    [ Anchor NW; 
      Text ("Orientation : "^ordre')];

  Canvas.coords_set
    config_fenetres.symmetrize_module_canvas
    config_fenetres.symmetrize_module_label
    [(Pixels 40);(Pixels 0)];

  Canvas.configure_text 
    config_fenetres.symmetrize_module_canvas
    config_fenetres.symmetrize_module_label
    [ Anchor NW; 
      Text ("Symtrisation : "^
	    (let th = theorie_canonique_courante.theories
	    in
	    if th=[]
	    then "aucun module"
	    else
	      "modules "^(string_of_theorie (List.hd th))^
	      (List.fold_left
		 (fun s t -> 
		   s^", "^(string_of_theorie t))
		 ""
		 (List.tl th))))];
  
  afficher_etat ()

;;
(*

let completion order eq_list conj_list = 

  let strat = options_courantes.strategy_number in
     if strat = 0
        then begin
      	     coef_size := 1;
      	     coef_date := 0
	     end
	else if strat < 0
               then begin
      	            coef_size := 1;
      	            coef_date := -strat
	            end
	       else begin
      	            coef_size := strat;
      	            coef_date := 1
	            end;

  add_new_eqs (normalize eq_list);

  etat.prove_conjectures <- conj_list <> [];
  etat.conjectures <- (normalize conj_list);
  

  try 

  while (etat.eq_to_orient <> []) or 
      	(etat.preoriented_eqs <> []) or 
      	(etat.pre_rules <> []) or
	(etat.major_deduce_index < maxint)
  do
    begin
      etat.date <- succ etat.date;
      
      if (!steps_to_proceed <= 1) then afficher_etat ();
      if !steps_to_proceed <= 1
      then 
	begin
          message "n<Return> to proceed n steps (default 1), q to interrupt";
      	  let n= read_line() 
          in 
          if n="q" 
      	  then raise Completion_aborted
	  else steps_to_proceed := 
	     try int_of_string(n)
	     with Failure _ -> 1
	end
      else steps_to_proceed := !steps_to_proceed - 1;
    
      match what_to_do() 
      with
    	SYMMETRISE -> symmetrise order
      | ORIENT -> orient order
      | SELECT_NEW_RULE -> select_new_rule order
      | DEDUCE -> deduce order
	    
   end
  done;

  if etat.postponed_eqs <> []
     then begin
          print_string "Only unorientable equations left:";
          force_newline ();
          print_liste_d_equations etat.postponed_eqs;
          force_newline ();
          print_flush ();
	  raise Completion_failed
      	  end;

  if etat.prove_conjectures
    then begin
      	 message "Warning : not all conjectures were proved"
	 end;

  etat.rules

  with ex -> 
    begin
      afficher_etat ();
      raise ex    
    end
*)

(*
let completion =
  Time_profiler.profile3
    "Strategy.completion"
    completion
*)
