(*

  \subsection{Counting normal forms}

*)
 
module CharSet : Ordered_sets.OrderedSet with type 'a elt = 'a

(* Raised when one tries to count the number of words in an infinite 
   language.*)

exception Infinite_language

(* [count_nf sigma left_members compiled_srs] returns the number 
   of words not reducible by the [left_members] of the [compiled_srs]. *)
val count_nf :  
  'a CharSet.t -> 'a Words.word list -> 'a String_rewriting.compiled_srs -> int
