(***************************************************************************

Main.ml for testing standard matching and unification

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: main.ml,v 1.2 2000/03/27 15:07:34 monate Exp $

***************************************************************************)


open Format;;


open Signatures;;
open User_signatures;;
open Rewrite_rules;;
open User_terms;;
open Variables;;

let main () =
try
  let my_sig = User_signatures.from_string "0:0;s:1;p:2;"
  and my_vars = new Variables.from_string "x y z t"
  in
  let t1 = term_of_string my_sig my_vars "p(x,s(y))"
  and t2 = term_of_string my_sig my_vars "p(s(0),s(0))"
  and t3 = term_of_string my_sig my_vars "p(s(z),t)"
  in
  let s1 = Matching.matching t1 t2
  in
    Substitution.print my_sig my_vars s1;
    print_newline();
  let s2 = Unification.unification_no_occur_check t1 t3
  in
    Substitution.print my_sig my_vars s2;

with 
    Matching.No_match -> 
      print_string "No match";
      print_newline()
  | Unification.No_unifier -> 
      print_string "No unifier";
      print_newline()
  | Exit ->
      print_string "Program aborted.";
      print_newline()
;;



Printexc.catch main ();;

(*
Time_profiler.print_profile();;
*)

