(***************************************************************************

Standard unification

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: standard_unification.mli,v 1.2 2001/04/03 15:45:26 contejea Exp $

***************************************************************************)



open Gen_terms;;


(* 

   [(unification term1 term2)] returns the most general unifier of
   [term1] and [term2]. Raises No_unifier if no unifier is found.

   This is standard unification : all symbols are assumed to be free.

   [(pre_unification term1 term2)] does the same but without
   occur_check, a la prolog. And terms headed by the same commutative
   or AC symbol are supposed to be unifyable

*)

exception No_unifier;;



(**)
val unification_no_occur_check : 
  'symbol term -> 'symbol term -> (unit,'symbol term) Variables.VarMap.t;; 
(**)

val pre_unifiable : 
  'symbol #Signatures.signature -> 'symbol term -> 'symbol term -> bool;;









