(***************************************************************************

Abstract syntax: specifications

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: abstract_syntax.mli,v 1.3 1998/04/28 13:36:03 marche Exp $

***************************************************************************)

(*

Obsolete header:

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/syntax/abstract_syntax.mli,v $
Revision:         $Revision: 1.3 $ 
Last modified on: $Date: 1998/04/28 13:36:03 $

***************************************************************************)

open Norm_theory;;
open Equations;;
open Equations_as_obj;;
open Term_orderings;;
open Symbols;;

exception Erreur_de_syntaxe of string;;

type lexer_state_type =
  Standard_lexer | Poly_lexer | Ident_lexer | Term_lexer
;;

type type_etat_analyse =
  {
    mutable numero_ligne : int;
    mutable numero_colonne_avant : int;
    mutable numero_colonne_apres : int;
    mutable dernier_token_lu : string;
    mutable lexer_state : lexer_state_type;
    mutable top_allowed : bool 
  };;

val etat_analyse : type_etat_analyse;;

type predefined_or_user_theory =
  PRDF of string list
| USR of regle list
;;

type abstract_syntax =
  Abstract_include of string
| Abstract_operators of (string list * Symbols.fix_type * (C_declare_operator.symbol_type * int)) list
| Abstract_theory of predefined_or_user_theory list
| Abstract_unification_theory of predefined_or_user_theory list
| Abstract_unification_type of unif_type
| Abstract_axioms of pair_of_terms list
| Abstract_ordering of ordre_disponible
| Abstract_problems of probleme list
| Abstract_conjectures of pair_of_terms list
| Abstract_inductive of pair_of_terms list
| Abstract_sortes of sorte_de_base list 
| Abstract_subsortes of (sorte_de_base*sorte_de_base) list
;;

val theory_of_abstract_theory :
  predefined_or_user_theory  -> theorie_connue;;


