type token =
    IDENT of (string)
  | PREFIX_IDENT of (string)
  | INFIX_IDENT of (string)
  | POSTFIX_IDENT of (string)
  | STRING of (string)
  | VIRGULE
  | POINT_VIRGULE
  | DEUX_POINTS
  | GUILLEMET
  | PARGAUCHE
  | PARDROITE
  | CROGAUCHE
  | CRODROIT
  | EGAL
  | FLECHE
  | TOKEN_USER
  | TERMINAISON
  | DP_TERMINATION
  | OPERATEURS
  | THEORIE
  | UNIFICATION
  | EQUATIONS
  | ORDRE
  | PROBLEMES
  | CONJECTURES
  | KW_END
  | EOF
  | MATCHING
  | REDUIRE
  | UNIFIER
  | MATCHER
  | COMPARER
  | WITH
  | LIBRE_UNIFIER
  | TOKEN_VARIABLE
  | TOKEN_AC
  | TOKEN_C
  | CONSTANTE
  | UNAIRE
  | BINAIRE
  | PREFIXE
  | INFIXE
  | POSTFIXE
  | TOKEN_RPO
  | TOKEN_RPS
  | TOKEN_MAPO
  | TOKEN_POLY
  | TOKEN_INTERACTIF
  | SUPERIEUR
  | INFERIEUR
  | TOKEN_SEMI_INTERACTIF
  | MUL
  | TOKEN_LEXICO
  | LRLEX
  | RLLEX
  | ONLY
  | COMPLETE
  | PLAIN
  | TYPE
  | TOKEN_INCLUDE
  | INDUCTIVE
  | PLUS
  | MINUS
  | EXP
  | MULT
  | POLY_VAR of (string)
  | INT of (int)
  | SORTES
  | AS
  | SUBSORTES

open Parsing
# 10 "parser.mly"

open Abstract_syntax;;
open C_declare_operator;;
open Symbols;;
open Terms;;
open Equations;;
open Equations_as_obj;;
open Term_orderings;;
open Rpo;;
(*
open Norm_theory;;
*)
open Poly_interp;;
open Errors;;

let current_poly_vars = ref ([] : string list)
;;

let monome_de_variable var =
  try
    IntPolynomials.var (Listutils.index var !current_poly_vars)
  with Not_found -> semantical_error "Undeclared polynomial variable"
;;

(* Line 28, file parser.ml *)
let yytransl_const = [|
  262 (* VIRGULE *);
  263 (* POINT_VIRGULE *);
  264 (* DEUX_POINTS *);
  265 (* GUILLEMET *);
  266 (* PARGAUCHE *);
  267 (* PARDROITE *);
  268 (* CROGAUCHE *);
  269 (* CRODROIT *);
  270 (* EGAL *);
  271 (* FLECHE *);
  272 (* TOKEN_USER *);
  273 (* TERMINAISON *);
  274 (* DP_TERMINATION *);
  275 (* OPERATEURS *);
  276 (* THEORIE *);
  277 (* UNIFICATION *);
  278 (* EQUATIONS *);
  279 (* ORDRE *);
  280 (* PROBLEMES *);
  281 (* CONJECTURES *);
  282 (* KW_END *);
    0 (* EOF *);
  283 (* MATCHING *);
  284 (* REDUIRE *);
  285 (* UNIFIER *);
  286 (* MATCHER *);
  287 (* COMPARER *);
  288 (* WITH *);
  289 (* LIBRE_UNIFIER *);
  290 (* TOKEN_VARIABLE *);
  291 (* TOKEN_AC *);
  292 (* TOKEN_C *);
  293 (* CONSTANTE *);
  294 (* UNAIRE *);
  295 (* BINAIRE *);
  296 (* PREFIXE *);
  297 (* INFIXE *);
  298 (* POSTFIXE *);
  299 (* TOKEN_RPO *);
  300 (* TOKEN_RPS *);
  301 (* TOKEN_MAPO *);
  302 (* TOKEN_POLY *);
  303 (* TOKEN_INTERACTIF *);
  304 (* SUPERIEUR *);
  305 (* INFERIEUR *);
  306 (* TOKEN_SEMI_INTERACTIF *);
  307 (* MUL *);
  308 (* TOKEN_LEXICO *);
  309 (* LRLEX *);
  310 (* RLLEX *);
  311 (* ONLY *);
  312 (* COMPLETE *);
  313 (* PLAIN *);
  314 (* TYPE *);
  315 (* TOKEN_INCLUDE *);
  316 (* INDUCTIVE *);
  317 (* PLUS *);
  318 (* MINUS *);
  319 (* EXP *);
  320 (* MULT *);
  323 (* SORTES *);
  324 (* AS *);
  325 (* SUBSORTES *);
    0|]

let yytransl_block = [|
  257 (* IDENT *);
  258 (* PREFIX_IDENT *);
  259 (* INFIX_IDENT *);
  260 (* POSTFIX_IDENT *);
  261 (* STRING *);
  321 (* POLY_VAR *);
  322 (* INT *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\001\000\004\000\004\000\004\000\004\000\004\000\
\004\000\004\000\004\000\004\000\004\000\004\000\004\000\005\000\
\016\000\021\000\007\000\010\000\014\000\017\000\019\000\020\000\
\020\000\018\000\018\000\012\000\022\000\003\000\006\000\006\000\
\006\000\006\000\024\000\024\000\025\000\025\000\023\000\023\000\
\027\000\027\000\027\000\027\000\028\000\029\000\029\000\029\000\
\029\000\029\000\029\000\029\000\026\000\030\000\030\000\031\000\
\009\000\009\000\009\000\008\000\008\000\032\000\032\000\033\000\
\033\000\034\000\035\000\035\000\036\000\011\000\011\000\038\000\
\013\000\013\000\039\000\039\000\039\000\039\000\039\000\039\000\
\039\000\039\000\048\000\040\000\043\000\045\000\045\000\044\000\
\047\000\047\000\041\000\041\000\041\000\049\000\049\000\049\000\
\049\000\046\000\046\000\042\000\042\000\051\000\051\000\052\000\
\052\000\015\000\015\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\050\000\054\000\054\000\056\000\057\000\
\057\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\037\000\037\000\037\000\037\000\037\000\037\000\058\000\
\058\000\002\000\000\000\000\000\000\000"

let yylen = "\002\000\
\001\000\001\000\002\000\002\000\002\000\002\000\003\000\003\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\003\000\
\005\000\001\000\003\000\001\000\001\000\002\000\001\000\002\000\
\002\000\003\000\001\000\003\000\001\000\003\000\005\000\003\000\
\001\000\001\000\001\000\000\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\002\000\001\000\003\000\001\000\
\002\000\002\000\001\000\001\000\002\000\003\000\004\000\002\000\
\003\000\001\000\001\000\003\000\003\000\002\000\003\000\003\000\
\001\000\004\000\006\000\004\000\004\000\006\000\005\000\001\000\
\003\000\003\000\004\000\001\000\001\000\002\000\000\000\001\000\
\002\000\003\000\000\000\001\000\003\000\001\000\003\000\003\000\
\003\000\001\000\003\000\001\000\003\000\002\000\002\000\001\000\
\001\000\002\000\003\000\003\000\002\000\005\000\004\000\004\000\
\004\000\004\000\004\000\003\000\003\000\005\000\001\000\002\000\
\003\000\001\000\001\000\003\000\003\000\003\000\002\000\003\000\
\003\000\001\000\003\000\004\000\004\000\004\000\003\000\001\000\
\003\000\002\000\002\000\002\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\016\000\019\000\000\000\020\000\
\028\000\021\000\017\000\002\000\001\000\000\000\018\000\022\000\
\023\000\139\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\140\000\000\000\
\056\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\004\000\003\000\005\000\066\000\006\000\000\000\000\000\
\000\000\009\000\000\000\000\000\084\000\000\000\085\000\088\000\
\080\000\000\000\000\000\010\000\073\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\059\000\000\000\011\000\000\000\000\000\012\000\029\000\013\000\
\000\000\014\000\000\000\015\000\000\000\000\000\000\000\000\000\
\138\000\030\000\000\000\032\000\041\000\042\000\043\000\000\000\
\053\000\000\000\008\000\007\000\000\000\061\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\057\000\058\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\135\000\034\000\048\000\047\000\
\046\000\049\000\050\000\051\000\052\000\000\000\045\000\055\000\
\000\000\062\000\000\000\000\000\071\000\000\000\000\000\000\000\
\081\000\000\000\000\000\000\000\000\000\000\000\000\000\082\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\107\000\027\000\000\000\132\000\137\000\133\000\134\000\
\000\000\000\000\064\000\063\000\083\000\074\000\000\000\089\000\
\000\000\000\000\000\000\000\000\076\000\000\000\000\000\077\000\
\086\000\000\000\000\000\000\000\000\000\068\000\000\000\114\000\
\115\000\000\000\000\000\000\000\000\000\000\000\000\000\039\000\
\000\000\065\000\090\000\095\000\096\000\097\000\000\000\000\000\
\000\000\093\000\000\000\119\000\000\000\079\000\000\000\000\000\
\000\000\025\000\000\000\000\000\102\000\104\000\105\000\103\000\
\075\000\000\000\078\000\000\000\099\000\000\000\000\000\122\000\
\123\000\000\000\038\000\036\000\101\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\118\000\124\000\000\000\
\000\000\129\000\000\000\000\000\120\000\121\000"

let yydgoto = "\004\000\
\018\000\031\000\034\000\019\000\020\000\035\000\021\000\046\000\
\074\000\022\000\050\000\023\000\060\000\024\000\075\000\025\000\
\026\000\080\000\027\000\082\000\028\000\207\000\036\000\208\000\
\209\000\037\000\096\000\142\000\143\000\038\000\154\000\048\000\
\146\000\049\000\112\000\113\000\114\000\052\000\152\000\062\000\
\155\000\216\000\063\000\064\000\159\000\195\000\153\000\065\000\
\156\000\196\000\217\000\232\000\077\000\197\000\242\000\221\000\
\254\000\087\000"

let yysindex = "\146\000\
\077\000\130\255\063\255\000\000\000\000\000\000\255\254\000\000\
\000\000\000\000\000\000\000\000\000\000\077\255\000\000\000\000\
\000\000\000\000\077\000\063\255\030\255\130\255\157\255\089\255\
\130\255\099\255\099\255\130\255\111\255\130\255\000\000\002\000\
\000\000\000\000\040\000\021\255\188\255\128\255\176\255\246\254\
\030\255\000\000\000\000\000\000\000\000\000\000\124\255\030\255\
\131\255\000\000\039\255\172\255\000\000\175\255\000\000\000\000\
\000\000\196\255\198\255\000\000\000\000\211\255\212\255\225\255\
\130\255\226\255\228\255\130\255\130\255\130\255\130\255\024\255\
\000\000\134\255\000\000\064\255\232\255\000\000\000\000\000\000\
\213\255\000\000\191\255\000\000\130\255\059\255\230\255\130\255\
\000\000\000\000\063\255\000\000\000\000\000\000\000\000\117\255\
\000\000\063\255\000\000\000\000\063\255\000\000\130\255\130\255\
\130\255\143\255\143\255\143\255\063\255\063\255\177\255\231\255\
\237\255\035\255\130\255\130\255\242\255\094\255\112\255\017\255\
\000\000\000\000\130\255\130\255\089\255\099\255\099\255\052\255\
\235\255\130\255\244\255\245\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\179\255\000\000\000\000\
\153\255\000\000\239\255\242\255\000\000\247\255\240\255\126\255\
\000\000\020\255\173\255\249\255\185\255\250\255\241\255\000\000\
\130\255\130\255\248\255\251\255\130\255\130\255\130\255\113\255\
\242\255\000\000\000\000\254\255\000\000\000\000\000\000\000\000\
\099\255\063\255\000\000\000\000\000\000\000\000\143\255\000\000\
\063\255\063\255\063\255\063\255\000\000\063\255\063\255\000\000\
\000\000\063\255\255\255\004\000\238\255\000\000\242\255\000\000\
\000\000\242\255\242\255\242\255\130\255\099\255\253\255\000\000\
\008\000\000\000\000\000\000\000\000\000\000\000\115\255\006\000\
\009\000\000\000\007\000\000\000\252\255\000\000\241\255\250\254\
\242\255\000\000\099\255\099\255\000\000\000\000\000\000\000\000\
\000\000\063\255\000\000\018\000\000\000\250\254\250\254\000\000\
\000\000\163\255\000\000\000\000\000\000\220\255\081\255\193\255\
\250\254\250\254\229\255\250\254\154\255\000\000\000\000\135\255\
\135\255\000\000\193\255\220\255\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\037\000\000\000\000\000\000\000\
\000\000\000\000\000\000\088\000\139\255\000\000\022\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\139\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\150\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\161\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\212\000\000\000\000\000\000\000\204\255\204\255\029\000\000\000\
\031\000\000\000\000\000\000\000\038\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\223\000\000\000\000\000\036\000\
\000\000\000\000\043\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\012\000\000\000\000\000\
\000\000\000\000\000\000\048\000\000\000\000\000\000\000\000\000\
\000\000\151\255\000\000\206\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\049\000\000\000\000\000\234\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\204\255\000\000\000\000\
\000\000\000\000\000\000\042\000\000\000\000\000\207\255\000\000\
\000\000\052\000\055\000\056\000\000\000\000\000\001\000\000\000\
\066\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\053\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\058\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\060\000\000\000\000\000\000\000\000\000\
\000\000\209\255\000\000\000\000\000\000\000\000\000\000\034\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\010\255\
\025\255\000\000\041\255\000\000\000\000\000\000"

let yygindex = "\000\000\
\253\000\000\000\000\000\000\000\000\000\246\255\059\001\090\000\
\036\001\000\000\236\255\000\000\000\000\000\000\208\000\000\000\
\000\000\210\000\000\000\128\000\000\000\243\255\000\000\110\000\
\112\000\000\000\000\000\000\000\000\000\242\000\003\000\000\000\
\171\000\000\000\156\255\000\000\005\000\000\000\233\255\000\000\
\155\255\076\255\000\000\000\000\000\000\127\000\168\000\000\000\
\046\000\000\000\000\000\000\000\000\000\000\000\129\255\000\000\
\100\000\189\255"

let yytablesize = 559
let yytable = "\061\000\
\037\000\089\000\147\000\238\000\078\000\039\000\032\000\084\000\
\157\000\044\000\219\000\040\000\081\000\083\000\163\000\164\000\
\125\000\129\000\006\000\088\000\125\000\033\000\039\000\047\000\
\072\000\092\000\051\000\091\000\076\000\051\000\033\000\126\000\
\051\000\185\000\086\000\126\000\130\000\088\000\039\000\090\000\
\127\000\088\000\131\000\047\000\127\000\045\000\073\000\128\000\
\167\000\162\000\047\000\128\000\104\000\245\000\088\000\239\000\
\040\000\130\000\240\000\241\000\198\000\088\000\174\000\033\000\
\130\000\035\000\088\000\186\000\187\000\131\000\125\000\125\000\
\117\000\118\000\119\000\120\000\013\000\124\000\121\000\122\000\
\134\000\042\000\150\000\151\000\149\000\126\000\126\000\031\000\
\218\000\128\000\029\000\255\000\133\000\039\000\127\000\127\000\
\088\000\127\000\030\000\079\000\039\000\128\000\128\000\145\000\
\128\000\066\000\067\000\165\000\148\000\051\000\247\000\248\000\
\081\000\172\000\088\000\088\000\068\000\069\000\070\000\071\000\
\085\000\000\001\001\001\072\000\003\001\166\000\205\000\168\000\
\169\000\076\000\100\000\029\000\183\000\101\000\128\000\097\000\
\184\000\102\000\060\000\030\000\103\000\249\000\250\000\251\000\
\252\000\073\000\001\000\002\000\003\000\026\000\135\000\136\000\
\137\000\138\000\139\000\140\000\094\000\094\000\178\000\004\001\
\033\000\094\000\123\000\179\000\005\001\229\000\199\000\230\000\
\231\000\202\000\203\000\204\000\044\000\044\000\044\000\044\000\
\044\000\044\000\105\000\188\000\145\000\098\000\141\000\189\000\
\106\000\053\000\054\000\055\000\056\000\057\000\215\000\191\000\
\083\000\215\000\059\000\192\000\220\000\251\000\252\000\053\000\
\054\000\055\000\056\000\057\000\044\000\107\000\058\000\108\000\
\059\000\225\000\091\000\070\000\092\000\069\000\091\000\116\000\
\092\000\069\000\126\000\116\000\109\000\110\000\106\000\249\000\
\250\000\251\000\252\000\093\000\094\000\095\000\212\000\213\000\
\214\000\024\000\111\000\115\000\215\000\116\000\125\000\127\000\
\132\000\160\000\158\000\161\000\088\000\173\000\177\000\175\000\
\176\000\180\000\182\000\224\000\194\000\181\000\190\000\251\000\
\193\000\037\000\200\000\206\000\088\000\201\000\037\000\037\000\
\236\000\222\000\223\000\227\000\040\000\228\000\234\000\043\000\
\233\000\235\000\040\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\246\000\253\000\054\000\040\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\002\001\130\000\
\087\000\067\000\130\000\130\000\109\000\131\000\136\000\130\000\
\131\000\131\000\130\000\130\000\098\000\131\000\072\000\108\000\
\131\000\131\000\111\000\037\000\037\000\112\000\113\000\100\000\
\110\000\041\000\035\000\037\000\130\000\037\000\040\000\040\000\
\035\000\117\000\131\000\099\000\170\000\226\000\040\000\171\000\
\040\000\244\000\243\000\144\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\210\000\237\000\211\000\005\000\
\006\000\007\000\008\000\009\000\010\000\011\000\012\000\006\001\
\000\000\000\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\035\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\035\000\000\000\035\000\014\000\
\015\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\
\000\000\017\000\031\000\031\000\000\000\000\000\000\000\000\000\
\000\000\000\000\031\000\000\000\031\000\060\000\060\000\060\000\
\060\000\060\000\060\000\060\000\060\000\000\000\000\000\000\000\
\026\000\026\000\026\000\026\000\026\000\026\000\026\000\026\000\
\000\000\000\000\000\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\033\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\060\000\060\000\000\000\
\000\000\000\000\000\000\000\000\000\000\060\000\000\000\060\000\
\026\000\026\000\000\000\000\000\000\000\000\000\000\000\000\000\
\026\000\000\000\026\000\033\000\033\000\000\000\000\000\000\000\
\000\000\000\000\000\000\033\000\000\000\033\000\070\000\070\000\
\070\000\070\000\070\000\070\000\070\000\070\000\000\000\000\000\
\000\000\106\000\106\000\106\000\106\000\106\000\106\000\106\000\
\106\000\000\000\000\000\000\000\024\000\024\000\024\000\024\000\
\024\000\024\000\024\000\024\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\070\000\070\000\
\000\000\000\000\000\000\000\000\000\000\000\000\070\000\000\000\
\070\000\106\000\106\000\000\000\000\000\000\000\000\000\000\000\
\000\000\106\000\000\000\106\000\024\000\024\000\000\000\000\000\
\000\000\000\000\000\000\000\000\024\000\000\000\024\000"

let yycheck = "\023\000\
\000\000\000\000\103\000\010\001\025\000\003\000\002\000\028\000\
\110\000\020\000\191\000\000\000\026\000\027\000\115\000\116\000\
\007\001\085\000\020\001\003\001\011\001\001\001\020\000\021\000\
\035\001\036\000\022\000\007\001\024\000\025\000\001\001\007\001\
\028\000\014\001\030\000\011\001\000\000\003\001\036\000\000\000\
\007\001\003\001\000\000\041\000\011\001\016\001\057\001\007\001\
\032\001\015\001\048\000\011\001\014\001\234\000\003\001\062\001\
\058\001\006\001\065\001\066\001\161\000\003\001\130\000\001\001\
\006\001\000\000\003\001\048\001\049\001\011\001\061\001\062\001\
\068\000\069\000\070\000\071\000\000\000\014\001\055\001\056\001\
\091\000\005\001\106\000\107\000\105\000\061\001\062\001\000\000\
\190\000\085\000\002\001\011\001\088\000\091\000\061\001\062\001\
\003\001\064\001\010\001\001\001\098\000\061\001\062\001\101\000\
\064\001\017\001\018\001\014\001\104\000\105\000\238\000\239\000\
\126\000\127\000\003\001\003\001\028\001\029\001\030\001\031\001\
\010\001\249\000\250\000\035\001\252\000\014\001\014\001\123\000\
\124\000\125\000\041\000\002\001\007\001\010\001\130\000\008\001\
\011\001\048\000\000\000\010\001\010\001\061\001\062\001\063\001\
\064\001\057\001\001\000\002\000\003\000\000\000\034\001\035\001\
\036\001\037\001\038\001\039\001\006\001\007\001\006\001\006\001\
\000\000\011\001\029\001\011\001\011\001\051\001\162\000\053\001\
\054\001\165\000\166\000\167\000\034\001\035\001\036\001\037\001\
\038\001\039\001\007\001\007\001\178\000\006\001\066\001\011\001\
\010\001\043\001\044\001\045\001\046\001\047\001\188\000\007\001\
\206\000\191\000\052\001\011\001\194\000\063\001\064\001\043\001\
\044\001\045\001\046\001\047\001\066\001\010\001\050\001\010\001\
\052\001\205\000\007\001\000\000\007\001\007\001\011\001\007\001\
\011\001\011\001\006\001\011\001\010\001\010\001\000\000\061\001\
\062\001\063\001\064\001\040\001\041\001\042\001\185\000\186\000\
\187\000\000\000\010\001\010\001\234\000\010\001\007\001\049\001\
\011\001\011\001\066\001\007\001\003\001\011\001\068\001\004\001\
\004\001\011\001\011\001\014\001\012\001\007\001\006\001\063\001\
\007\001\001\001\011\001\006\001\003\001\011\001\006\001\007\001\
\013\001\011\001\007\001\015\001\001\001\006\001\006\001\019\000\
\011\001\011\001\007\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\010\001\065\001\008\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\066\001\003\001\
\012\001\011\001\006\001\007\001\007\001\003\001\011\001\011\001\
\006\001\007\001\014\001\015\001\011\001\011\001\007\001\007\001\
\014\001\015\001\007\001\059\001\060\001\007\001\007\001\011\001\
\007\001\007\000\001\001\067\001\032\001\069\001\059\001\060\001\
\007\001\014\001\032\001\040\000\125\000\206\000\067\001\126\000\
\069\001\228\000\227\000\098\000\019\001\020\001\021\001\022\001\
\023\001\024\001\025\001\026\001\178\000\223\000\183\000\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\026\001\004\001\
\255\255\255\255\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\026\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\059\001\060\001\255\255\255\255\
\255\255\255\255\255\255\255\255\067\001\255\255\069\001\059\001\
\060\001\255\255\255\255\255\255\255\255\255\255\255\255\067\001\
\255\255\069\001\059\001\060\001\255\255\255\255\255\255\255\255\
\255\255\255\255\067\001\255\255\069\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\255\255\255\255\255\255\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\026\001\
\255\255\255\255\255\255\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\059\001\060\001\255\255\
\255\255\255\255\255\255\255\255\255\255\067\001\255\255\069\001\
\059\001\060\001\255\255\255\255\255\255\255\255\255\255\255\255\
\067\001\255\255\069\001\059\001\060\001\255\255\255\255\255\255\
\255\255\255\255\255\255\067\001\255\255\069\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\255\255\255\255\
\255\255\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\026\001\255\255\255\255\255\255\019\001\020\001\021\001\022\001\
\023\001\024\001\025\001\026\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\059\001\060\001\
\255\255\255\255\255\255\255\255\255\255\255\255\067\001\255\255\
\069\001\059\001\060\001\255\255\255\255\255\255\255\255\255\255\
\255\255\067\001\255\255\069\001\059\001\060\001\255\255\255\255\
\255\255\255\255\255\255\255\255\067\001\255\255\069\001"

let yyact = [|
  (fun _ -> failwith "parser")
; (fun parser_env ->
    Obj.repr((
# 82 "parser.mly"
                           [] ) : Abstract_syntax.abstract_syntax list))
; (fun parser_env ->
    Obj.repr((
# 83 "parser.mly"
                           [] ) : Abstract_syntax.abstract_syntax list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration) in
    let _2 = (peek_val parser_env 0 : Abstract_syntax.abstract_syntax list) in
    Obj.repr((
# 84 "parser.mly"
                           _1::_2 ) : Abstract_syntax.abstract_syntax list))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 87 "parser.mly"
                        Abstract_include _2) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_operators) in
    let _2 = (peek_val parser_env 0 : 'operateurs) in
    Obj.repr((
# 88 "parser.mly"
                                   Abstract_operators _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_theory) in
    let _2 = (peek_val parser_env 0 : 'theorie) in
    Obj.repr((
# 89 "parser.mly"
                                Abstract_theory _2 ) : 'declaration))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'keyword_theory) in
    let _3 = (peek_val parser_env 0 : 'theorie) in
    Obj.repr((
# 90 "parser.mly"
                                         Abstract_unification_theory _3 ) : 'declaration))
; (fun parser_env ->
    let _3 = (peek_val parser_env 0 : 'unif_type) in
    Obj.repr((
# 91 "parser.mly"
                                  Abstract_unification_type _3 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_axioms) in
    let _2 = (peek_val parser_env 0 : 'equations) in
    Obj.repr((
# 92 "parser.mly"
                              Abstract_axioms _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_order) in
    let _2 = (peek_val parser_env 0 : 'ordre_plus) in
    Obj.repr((
# 93 "parser.mly"
                              Abstract_ordering _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_problems) in
    let _2 = (peek_val parser_env 0 : 'problemes) in
    Obj.repr((
# 94 "parser.mly"
                                 Abstract_problems _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_conjectures) in
    let _2 = (peek_val parser_env 0 : 'equations) in
    Obj.repr((
# 95 "parser.mly"
                                   Abstract_conjectures _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_sortes) in
    let _2 = (peek_val parser_env 0 : 'sortes) in
    Obj.repr((
# 96 "parser.mly"
                                          Abstract_sortes _2) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_subsortes) in
    let _2 = (peek_val parser_env 0 : 'subsortes) in
    Obj.repr((
# 97 "parser.mly"
                                          Abstract_subsortes _2) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'keyword_inductive) in
    let _2 = (peek_val parser_env 0 : 'equations) in
    Obj.repr((
# 98 "parser.mly"
                                          Abstract_inductive _2 ) : 'declaration))
; (fun parser_env ->
    Obj.repr((
# 101 "parser.mly"
               
  etat_analyse.top_allowed <- false;
  etat_analyse.lexer_state <- Ident_lexer ) : 'keyword_operators))
; (fun parser_env ->
    Obj.repr((
# 106 "parser.mly"
                 
  etat_analyse.top_allowed <- false;
  etat_analyse.lexer_state <- Term_lexer ) : 'keyword_conjectures))
; (fun parser_env ->
    Obj.repr((
# 111 "parser.mly"
               
  etat_analyse.top_allowed <- false;
  etat_analyse.lexer_state <- Term_lexer ) : 'keyword_inductive))
; (fun parser_env ->
    Obj.repr((
# 116 "parser.mly"
             
  etat_analyse.top_allowed <- false;
  etat_analyse.lexer_state <- Ident_lexer ) : 'keyword_theory))
; (fun parser_env ->
    Obj.repr((
# 121 "parser.mly"
               
  etat_analyse.top_allowed <- false;
  etat_analyse.lexer_state <- Term_lexer ) : 'keyword_axioms))
; (fun parser_env ->
    Obj.repr((
# 126 "parser.mly"
               
  etat_analyse.top_allowed <- false;
  etat_analyse.lexer_state <- Term_lexer ) : 'keyword_problems))
; (fun parser_env ->
    Obj.repr((
# 131 "parser.mly"
           etat_analyse.lexer_state <- Ident_lexer ) : 'keyword_sortes))
; (fun parser_env ->
    Obj.repr((
# 134 "parser.mly"
               etat_analyse.lexer_state <- Ident_lexer) : 'keyword_subsortes))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'base_sorte) in
    let _3 = (peek_val parser_env 0 : 'base_sorte) in
    Obj.repr((
# 137 "parser.mly"
                                     [(see_as_base_sort _1,see_as_base_sort _3)]) : 'subsortes))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'base_sorte) in
    let _3 = (peek_val parser_env 2 : 'base_sorte) in
    let _5 = (peek_val parser_env 0 : 'subsortes) in
    Obj.repr((
# 138 "parser.mly"
                                                     (see_as_base_sort _1,see_as_base_sort _3):: _5 ) : 'subsortes))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'base_sorte) in
    Obj.repr((
# 141 "parser.mly"
                make_new_sort _1) : 'sortes))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'base_sorte) in
    let _3 = (peek_val parser_env 0 : 'sortes) in
    Obj.repr((
# 142 "parser.mly"
                             make_new_sort _1 ; _3) : 'sortes))
; (fun parser_env ->
    Obj.repr((
# 145 "parser.mly"
          etat_analyse.lexer_state <- Standard_lexer ) : 'keyword_order))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 148 "parser.mly"
           _1) : 'base_sorte))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'operateurs) in
    Obj.repr((
# 151 "parser.mly"
                          () ) : unit))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'decl_arite) in
    Obj.repr((
# 154 "parser.mly"
                           [_1] ) : 'operateurs))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'decl_arite) in
    let _2 = (peek_val parser_env 0 : 'operateurs) in
    Obj.repr((
# 155 "parser.mly"
                           _1::_2 ) : 'operateurs))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'decl_arite) in
    Obj.repr((
# 156 "parser.mly"
                                         [_1] ) : 'operateurs))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'decl_arite) in
    let _3 = (peek_val parser_env 0 : 'operateurs) in
    Obj.repr((
# 157 "parser.mly"
                                         _1::_3 ) : 'operateurs))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'profile) in
    Obj.repr((
# 160 "parser.mly"
             [_1]) : 'profile_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'profile) in
    let _3 = (peek_val parser_env 0 : 'profile_list) in
    Obj.repr((
# 161 "parser.mly"
                                  _1::_3) : 'profile_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'base_sorte) in
    Obj.repr((
# 164 "parser.mly"
              [_1]) : 'profile))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'base_sorte) in
    let _3 = (peek_val parser_env 0 : 'profile) in
    Obj.repr((
# 165 "parser.mly"
                              _1::_3) : 'profile))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'op_list_colon) in
    let _2 = (peek_val parser_env 3 : 'fix) in
    let _3 = (peek_val parser_env 2 : 'arity) in
    let _5 = (peek_val parser_env 0 : 'profile_list) in
    Obj.repr((
# 170 "parser.mly"
      let t,a = _3 in
        if _2=INFIX & a<>2
          then raise (Erreur_de_syntaxe "Infix symbols must be binary")
          else 
	  if (List.exists (fun x -> (List.length x-1)<>a) _5)
	  then raise (Erreur_de_syntaxe "Profile must be compatible with arity")  
	  else 
	    begin
	      (List.iter (definir_operateur t a _2 (List.map see_as_functional_sort _5)) _1);
	      (_1,_2,_3)
	    end
	    ) : 'decl_arite))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'op_list_colon) in
    let _2 = (peek_val parser_env 1 : 'fix) in
    let _3 = (peek_val parser_env 0 : 'arity) in
    Obj.repr((
# 183 "parser.mly"
      let t,a = _3 in
        if _2=INFIX & a<>2
          then raise (Erreur_de_syntaxe "Infix symbols must be binary")
          else 
(* a virer *)
	  if (List.exists (fun x -> (List.length x-1)<>a) [])
	  then raise (Erreur_de_syntaxe "Profile must be compatible with arity")  
	  else 
	    begin
	      (List.iter (definir_operateur t a _2 (List.map see_as_functional_sort [])) _1);
(* jusque la *)
	      (_1,_2,_3)
	    end
	    ) : 'decl_arite))
; (fun parser_env ->
    Obj.repr((
# 199 "parser.mly"
            PREFIX ) : 'fix))
; (fun parser_env ->
    Obj.repr((
# 200 "parser.mly"
            INFIX  ) : 'fix))
; (fun parser_env ->
    Obj.repr((
# 201 "parser.mly"
             POSTFIX ) : 'fix))
; (fun parser_env ->
    Obj.repr((
# 202 "parser.mly"
            DEFAULT ) : 'fix))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'arityaux) in
    Obj.repr((
# 205 "parser.mly"
                   etat_analyse.lexer_state <- Ident_lexer;_1 ) : 'arity))
; (fun parser_env ->
    Obj.repr((
# 208 "parser.mly"
                   (C,2) ) : 'arityaux))
; (fun parser_env ->
    Obj.repr((
# 209 "parser.mly"
                   (AC,2) ) : 'arityaux))
; (fun parser_env ->
    Obj.repr((
# 210 "parser.mly"
                   (VARIABLE,0) ) : 'arityaux))
; (fun parser_env ->
    Obj.repr((
# 211 "parser.mly"
                   (FREE,0) ) : 'arityaux))
; (fun parser_env ->
    Obj.repr((
# 212 "parser.mly"
                   (FREE,1) ) : 'arityaux))
; (fun parser_env ->
    Obj.repr((
# 213 "parser.mly"
                   (FREE,2) ) : 'arityaux))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int) in
    Obj.repr((
# 214 "parser.mly"
                   (FREE,_1) ) : 'arityaux))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'op_list) in
    Obj.repr((
# 217 "parser.mly"
                        etat_analyse.lexer_state <- Standard_lexer; _1 ) : 'op_list_colon))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ident) in
    Obj.repr((
# 220 "parser.mly"
                           [_1] ) : 'op_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'ident) in
    let _3 = (peek_val parser_env 0 : 'op_list) in
    Obj.repr((
# 221 "parser.mly"
                           _1::_3 ) : 'op_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 224 "parser.mly"
                        _1 ) : 'ident))
; (fun parser_env ->
    Obj.repr((
# 239 "parser.mly"
                        Unif_type_AC_only ) : 'unif_type))
; (fun parser_env ->
    Obj.repr((
# 240 "parser.mly"
                        Unif_type_AC_complete ) : 'unif_type))
; (fun parser_env ->
    Obj.repr((
# 241 "parser.mly"
                        Unif_type_plain ) : 'unif_type))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'decl_theorie) in
    Obj.repr((
# 244 "parser.mly"
                         [_1] ) : 'theorie))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'decl_theorie) in
    let _2 = (peek_val parser_env 0 : 'theorie) in
    Obj.repr((
# 245 "parser.mly"
                         _1::_2 ) : 'theorie))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'ident) in
    let _3 = (peek_val parser_env 0 : 'id_list_end) in
    Obj.repr((
# 248 "parser.mly"
                                PRDF(_1::_3) ) : 'decl_theorie))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'keyword_user) in
    let _3 = (peek_val parser_env 1 : 'regle_list) in
    Obj.repr((
# 249 "parser.mly"
                                                etat_analyse.lexer_state <- Ident_lexer;USR(_3) ) : 'decl_theorie))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'ident) in
    Obj.repr((
# 252 "parser.mly"
                               [_1] ) : 'id_list_end))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'ident) in
    let _3 = (peek_val parser_env 0 : 'id_list_end) in
    Obj.repr((
# 253 "parser.mly"
                               _1::_3 ) : 'id_list_end))
; (fun parser_env ->
    Obj.repr((
# 256 "parser.mly"
               etat_analyse.lexer_state <- Term_lexer ) : 'keyword_user))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'regle) in
    Obj.repr((
# 259 "parser.mly"
                                   [_1] ) : 'regle_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'regle) in
    let _3 = (peek_val parser_env 0 : 'regle_list) in
    Obj.repr((
# 260 "parser.mly"
                                   _1::_3) : 'regle_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 263 "parser.mly"
                                      make_basic_rule ((flatten_term _1),
                                                       (flatten_term _3)) ) : 'regle))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'equation) in
    Obj.repr((
# 267 "parser.mly"
                                      [_1] ) : 'equations))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'equation) in
    let _3 = (peek_val parser_env 0 : 'equations) in
    Obj.repr((
# 268 "parser.mly"
                                      _1::_3 ) : 'equations))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 271 "parser.mly"
                                      new pair_of_terms (flatten_term _1) 
                                      	(flatten_term _3) ) : 'equation))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ordre) in
    Obj.repr((
# 276 "parser.mly"
          _1 ) : 'ordre_plus))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'ordre) in
    Obj.repr((
# 278 "parser.mly"
          SEMI_INTERACTIF(_3) ) : 'ordre_plus))
; (fun parser_env ->
    let _1 = (peek_val parser_env 5 : 'keyword_rpo) in
    let _3 = (peek_val parser_env 3 : 'precedence) in
    let _5 = (peek_val parser_env 1 : 'statuts) in
    Obj.repr((
# 283 "parser.mly"
      RPO(_3,_5) ) : 'ordre))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'keyword_rpo) in
    let _3 = (peek_val parser_env 1 : 'precedence) in
    Obj.repr((
# 285 "parser.mly"
      RPO(_3,[]) ) : 'ordre))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'keyword_mapo) in
    let _3 = (peek_val parser_env 1 : 'precedence) in
    Obj.repr((
# 287 "parser.mly"
      MAPO(_3,[]) ) : 'ordre))
; (fun parser_env ->
    let _1 = (peek_val parser_env 5 : 'keyword_mapo) in
    let _3 = (peek_val parser_env 3 : 'precedence) in
    let _5 = (peek_val parser_env 1 : 'statuts) in
    Obj.repr((
# 289 "parser.mly"
      MAPO(_3,_5) ) : 'ordre))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'keyword_poly) in
    let _3 = (peek_val parser_env 2 : 'mu_value) in
    let _4 = (peek_val parser_env 1 : 'poly_decl_list) in
    Obj.repr((
# 291 "parser.mly"
      POLY(_3,_4) ) : 'ordre))
; (fun parser_env ->
    Obj.repr((
# 293 "parser.mly"
      ORDRE_INTERACTIF ) : 'ordre))
; (fun parser_env ->
    let _3 = (peek_val parser_env 0 : 'ordre_List) in
    Obj.repr((
# 295 "parser.mly"
      LEXICO(_3) ) : 'ordre))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'rps_header) in
    let _2 = (peek_val parser_env 1 : 'regle_list) in
    Obj.repr((
# 297 "parser.mly"
      Rps(_1,_2) ) : 'ordre))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'ordre) in
    Obj.repr((
# 301 "parser.mly"
       
  etat_analyse.top_allowed <- true;
  etat_analyse.lexer_state <- Term_lexer;_3 ) : 'rps_header))
; (fun parser_env ->
    Obj.repr((
# 306 "parser.mly"
               
  etat_analyse.top_allowed <- true;
  etat_analyse.lexer_state <- Ident_lexer ) : 'keyword_rpo))
; (fun parser_env ->
    Obj.repr((
# 311 "parser.mly"
                
  etat_analyse.top_allowed <- true;
  etat_analyse.lexer_state <- Ident_lexer ) : 'keyword_mapo))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : int) in
    Obj.repr((
# 317 "parser.mly"
                
  etat_analyse.top_allowed <- true;
  etat_analyse.lexer_state <- Ident_lexer;_1 ) : 'mu_value))
; (fun parser_env ->
    Obj.repr((
# 321 "parser.mly"
                
  etat_analyse.top_allowed <- true;
  etat_analyse.lexer_state <- Ident_lexer;0 ) : 'mu_value))
; (fun parser_env ->
    Obj.repr((
# 326 "parser.mly"
               etat_analyse.lexer_state <- Standard_lexer ) : 'keyword_poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'ordre) in
    Obj.repr((
# 329 "parser.mly"
                      [_1] ) : 'ordre_List))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'ordre) in
    let _3 = (peek_val parser_env 0 : 'ordre_List) in
    Obj.repr((
# 330 "parser.mly"
                                     _1::_3 ) : 'ordre_List))
; (fun parser_env ->
    Obj.repr((
# 333 "parser.mly"
                                          [] ) : 'precedence))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'liste_ordonnee) in
    Obj.repr((
# 334 "parser.mly"
                       [_1] ) : 'precedence))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'liste_ordonnee) in
    let _3 = (peek_val parser_env 0 : 'precedence) in
    Obj.repr((
# 335 "parser.mly"
                                      _1::_3 ) : 'precedence))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ident) in
    Obj.repr((
# 338 "parser.mly"
               One_symbol (get_symbol_id _1) ) : 'liste_ordonnee))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'ident) in
    let _3 = (peek_val parser_env 0 : 'liste_ordonnee) in
    Obj.repr((
# 339 "parser.mly"
                                Equal_to (get_symbol_id _1,_3) ) : 'liste_ordonnee))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'ident) in
    let _3 = (peek_val parser_env 0 : 'liste_ordonnee) in
    Obj.repr((
# 340 "parser.mly"
                                    Greater_than (get_symbol_id _1,_3) ) : 'liste_ordonnee))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'ident) in
    let _3 = (peek_val parser_env 0 : 'liste_ordonnee) in
    Obj.repr((
# 341 "parser.mly"
                                    Lower_than (get_symbol_id _1,_3) ) : 'liste_ordonnee))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'poly_decl) in
    Obj.repr((
# 344 "parser.mly"
                 [_1] ) : 'poly_decl_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'poly_decl) in
    let _3 = (peek_val parser_env 0 : 'poly_decl_list) in
    Obj.repr((
# 345 "parser.mly"
                                          _1::_3 ) : 'poly_decl_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'statut) in
    Obj.repr((
# 348 "parser.mly"
                            [_1]   ) : 'statuts))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'statut) in
    let _3 = (peek_val parser_env 0 : 'statuts) in
    Obj.repr((
# 349 "parser.mly"
                            _1::_3 ) : 'statuts))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'ident) in
    Obj.repr((
# 353 "parser.mly"
      (get_symbol_id _1),MULTISET
    ) : 'statut))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'ident) in
    let _2 = (peek_val parser_env 0 : 'lexstat) in
    Obj.repr((
# 356 "parser.mly"
      let f=(get_symbol_id _1) in
      	if not (is_free f)
      	  then semantical_error	"Only free symbols can have a lexicographic status"
      	  else f,_2
    ) : 'statut))
; (fun parser_env ->
    Obj.repr((
# 363 "parser.mly"
          LR_LEXICO ) : 'lexstat))
; (fun parser_env ->
    Obj.repr((
# 364 "parser.mly"
          RL_LEXICO ) : 'lexstat))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'probleme) in
    Obj.repr((
# 367 "parser.mly"
                                      [_1] ) : 'problemes))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'probleme) in
    let _3 = (peek_val parser_env 0 : 'problemes) in
    Obj.repr((
# 368 "parser.mly"
                                      _1::_3 ) : 'problemes))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 372 "parser.mly"
      EQUATION_A_PROUVER(flatten_term _1,flatten_term _3) ) : 'probleme))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 374 "parser.mly"
      TERME_A_REDUIRE(flatten_term _2) ) : 'probleme))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'unif_type) in
    let _3 = (peek_val parser_env 2 : 'term) in
    let _5 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 376 "parser.mly"
      EQUATION_A_RESOUDRE(_1,flatten_term _3,flatten_term _5) ) : 'probleme))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'term) in
    let _4 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 378 "parser.mly"
      EQUATION_A_RESOUDRE(Unif_type_default,flatten_term _2,flatten_term _4) ) : 'probleme))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'term) in
    let _4 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 380 "parser.mly"
      EQUATION_A_MATCHER(flatten_term _2,flatten_term _4) ) : 'probleme))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'term) in
    let _4 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 382 "parser.mly"
      TERMES_A_COMPARER(flatten_term _2,flatten_term _4) ) : 'probleme))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'regle_list) in
    Obj.repr((
# 384 "parser.mly"
      TERMINAISON_A_PROUVER(_3) ) : 'probleme))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'regle_list) in
    Obj.repr((
# 386 "parser.mly"
      TERMINAISON_DP(_3) ) : 'probleme))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'entete_poly) in
    let _3 = (peek_val parser_env 0 : 'poly) in
    Obj.repr((
# 395 "parser.mly"
       
  etat_analyse.top_allowed <- true;
  etat_analyse.lexer_state <- Ident_lexer;
      (_1,_3)
      ) : 'poly_decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'poly_ident) in
    Obj.repr((
# 403 "parser.mly"
      current_poly_vars := [];
      _2 ) : 'entete_poly))
; (fun parser_env ->
    let _2 = (peek_val parser_env 3 : 'poly_ident) in
    let _5 = (peek_val parser_env 0 : 'poly_var_list_end) in
    Obj.repr((
# 406 "parser.mly"
      current_poly_vars := _5;
      
      let test_simple list =
      	let rec build_simple = function
      	    ([],l)	-> l
      	  | ((a::s), l)	-> build_simple (s,Listutils.union l [a])
      	in 
	  if ( (List.length list)=(List.length (build_simple (list,[]))) )
	  then ()
	  else 
	    semantical_error 
	      "Same variable symbols in polynomial declaration"
      in
      	test_simple !current_poly_vars;
      	
      	let f = _2 in
	  if (arity f)<>(List.length !current_poly_vars)
	  then semantical_error 
	    ((string_of_symbol_id _2)^" is supposed to be a "
      	     ^(string_of_int (arity f))^"-ary operator")       
	  else f
    ) : 'entete_poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ident) in
    Obj.repr((
# 430 "parser.mly"
          etat_analyse.lexer_state <- Poly_lexer;
      	  (get_symbol_id _1) ) : 'poly_ident))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : string) in
    Obj.repr((
# 434 "parser.mly"
                                        [_1] ) : 'poly_var_list_end))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'poly_var_list_end) in
    Obj.repr((
# 435 "parser.mly"
                                        _1::_3 ) : 'poly_var_list_end))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 439 "parser.mly"
      monome_de_variable _1 ) : 'poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int) in
    Obj.repr((
# 441 "parser.mly"
      IntPolynomials.cte (Num.Int _1) ) : 'poly))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'poly) in
    Obj.repr((
# 443 "parser.mly"
      _2 ) : 'poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'poly) in
    let _3 = (peek_val parser_env 0 : 'poly) in
    Obj.repr((
# 445 "parser.mly"
      IntPolynomials.add _1 _3 ) : 'poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'poly) in
    let _3 = (peek_val parser_env 0 : 'poly) in
    Obj.repr((
# 447 "parser.mly"
      IntPolynomials.sub _1 _3 ) : 'poly))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'poly) in
    Obj.repr((
# 449 "parser.mly"
      IntPolynomials.minus _2 ) : 'poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'poly) in
    let _3 = (peek_val parser_env 0 : 'poly) in
    Obj.repr((
# 451 "parser.mly"
      IntPolynomials.mult _1 _3 ) : 'poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'poly) in
    let _3 = (peek_val parser_env 0 : int) in
    Obj.repr((
# 453 "parser.mly"
      IntPolynomials.power _1 _3 ) : 'poly))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 457 "parser.mly"
     (* printf "forme a\n"; *)
      try
        VAR (var_id_of_string _1)
      with Not_found -> 
        let f=(get_symbol_id _1) in 
        if (arity f)=0
        then TERM(f,[])
        else semantical_error ("Bad number of arguments for " ^ _1)
     ) : 'term))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 467 "parser.mly"
       _2
     ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : string) in
    let _3 = (peek_val parser_env 1 : 'term_list) in
    Obj.repr((
# 470 "parser.mly"
       (* printf "forme f(...)\n"; *)
        let f=(get_symbol_id _1) in
        if (arity f)=(List.length _3)
        then TERM(f,_3)
        else semantical_error ("Bad number of arguments for " ^ _1)
    ) : 'term))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'term) in
    let _4 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 477 "parser.mly"
      (* printf "forme f(...)\n"; *)
      let f=(get_symbol_id _4) in
        if (arity f)=1
          then TERM(f,[_2])
          else semantical_error ("Bad number of arguments for " ^ _4)
    ) : 'term))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'term_list) in
    let _4 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 484 "parser.mly"
      (* printf "forme f(...)\n"; *)
      let f=(get_symbol_id _4) in
        if (arity f)=(List.length _2)
          then TERM(f,_2)
          else semantical_error ("Bad number of arguments for " ^ _4)
    ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _2 = (peek_val parser_env 1 : string) in
    let _3 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 491 "parser.mly"
      let f = (get_symbol_id _2) in
      TERM(f,[_1;_3])
    ) : 'term))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'term) in
    Obj.repr((
# 497 "parser.mly"
                        [_1] ) : 'term_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'term) in
    let _3 = (peek_val parser_env 0 : 'term_list) in
    Obj.repr((
# 498 "parser.mly"
                           _1 :: _3 ) : 'term_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'term) in
    Obj.repr((
# 501 "parser.mly"
             _1 ) : Terms.term))
(* Entry donnees *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
(* Entry term_eof *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
(* Entry signature_eof *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error }
let donnees (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf : Abstract_syntax.abstract_syntax list)
let term_eof (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 2 lexfun lexbuf : Terms.term)
let signature_eof (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 3 lexfun lexbuf : unit)
