
open Orderings_generalities;;
open Order_constraints;;

let rec check_order_constraint o f =
  match f with
    | True -> true
    | False -> false
    | Or(l) -> List.exists (check_order_constraint o) l
    | And(l) -> List.for_all (check_order_constraint o) l
    | Not(f) -> not(check_order_constraint o f)
    | Atom(t1,op,t2) ->
	match op,o t1 t2 with
	  | Eq, Equivalent -> true
	  | Ne, Greater_than -> true
	  | Ne, Less_than -> true
	  | Gt, Greater_than -> true
	  | Lt, Less_than -> true
	  | Ge, Greater_than -> true
	  | Ge, Greater_or_equivalent -> true
	  | Ge, Equivalent -> true
	  | Le, Less_than -> true
	  | Le, Less_or_equivalent -> true
	  | Le, Equivalent -> true
	  | _,_ -> false
;;
