(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: main.ml,v 1.4 2002/05/27 12:07:25 contejea Exp $

***************************************************************************)



(* testing acrpo *)

open Format;;
open Orderings_generalities;;

let my_sig = User_signatures.from_string 
  "* , + : AC ; 
   g,h,G,H,T,L : unary ;
   a,b,c,0,A,B,C : constant ;";;

let my_sig2 = User_signatures.from_string 
  "c,b,a : constant;
  multiply : 2;
  difference : 2;";;

let my_vars = Variables.from_string "x y z";;

let prec = 
  try
    User_terms.prec_of_string my_sig 
      "h > + > g > a > b , G > H , T > + , L > +, * > +"
  with 
      Term_syntax.Syntax_error _ -> failwith "syntax error in prec";
;;
  
let status f = if my_sig#is_ac f then Rpo.Multiset else Rpo.Lr_lexico;;


let order = Acrpo.acrpo my_sig prec status;;

let order2 = User_poly_ordering.of_string my_sig2 "
[b] = 1;
[difference](x,y) = x+y;
[multiply](x,y) = x.y + 4.x + 4.y;
[a] = 1;
[c] = 1;
";;

let test t1 t2 res =
  try
    let t1 = User_terms.term_of_string my_sig my_vars t1
    and t2 = User_terms.term_of_string my_sig my_vars t2
    in
    let c = order t1 t2 in
    print_string "comparing ";
    Gen_terms.print_term my_sig my_vars t1;
    print_string " and ";
    Gen_terms.print_term my_sig my_vars t2;
    printf " : %s" (string_of_comparison_result c);
    print_string (if c=res then " (ok)" else " WRONG");
    printf "(reverse : %s)" (string_of_comparison_result (order t2 t1));
    print_newline()
  with
      Term_syntax.Syntax_error _ -> 
	print_string "syntax error";
	print_newline()
;;


(*i
test "a" "a" Equivalent;;
test "g(a)" "a" Greater_than;;
test "a+a" "a" Greater_than;;
test "a+g(a)" "g(a)+a" Equivalent;;
test "g(a+a)" "g(a)+a" Less_than;;
test "h(a+a)" "h(a)+a" Greater_than;;
test "g(h(a) + a) + a" "g(h(a) + a) + a" Equivalent;;

(* Rubio 99 RTA, LNCS 1631, page 137 *)
test "g(h(a) + a) + a" "h(a) + a + a" Greater_than;;
test "h(a) + g(a)" "g(h(a)) + a" Greater_than;;
test "g(h(a)) +b+b+b" "g(h(a)+a)+a" Greater_than;;
test "h(a) + a" "h(a) + b" Greater_than;;

(* Rubio 99 RTA, page 139 *)
test "g(h(x)+x) + x" "h(x)+x+x" Greater_than;;
test "h(x)+g(x)" "g(h(x))+x" Greater_than;;
test "g(h(x))+x+x+y" "g(h(x)+y)+x" Greater_than;;
test "g(g(x))+x" "g(x)+g(x)" Greater_than;;

(* Rubio 99 RTA, page 141 *)
test "G(G(x)) + x" "G(x)+G(x)" Greater_than;;
test "x+x+G(x)" "x+H(x)" Greater_than;;

(* Rubio 99 RTA, page 142 *)
test "0+x" "x" Greater_than;;
test "x+x" "x" Greater_than;;
test "L(T(x))" "L(x)" Greater_than;;
test "L(T(y)+x)" "L(x+y)+L(y)" Greater_than;;
test "T(T(x))" "T(x)" Greater_than;;
test "T(x)+x" "T(x)" Greater_than;;
test "T(x+y)+x" "T(x+y)" Greater_than;;
test "T(T(y)+x)" "T(x+y)+T(y)" Greater_than;;

(* my own tests *)


test "A*B" "A+B" Greater_than;;
test "A*(B+C)" "C*B" Greater_than;;
test "x*y" "x+y" Greater_than;;

test "x*(y+z)" "(x*y)+(x*z)" Greater_than;;
test "(x*y)+(x*z)" "z*y" Greater_than;;
i*)

let debug s =
  Format.print_string s;
  Format.print_newline ();
  Format.print_flush ();;

let _ = 
test "x*(y+z)" "z*y" Greater_than;;



