(***************************************************************************

Term orderings: body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ord_interactive.ml,v 1.4 1999/02/17 12:42:40 contejea Exp $

***************************************************************************)

open Messages;;
open Orderings;;
open Terms;;



exception Undo of int;;
(*===============================================
Ordre 'interactif' sur les termes :
on demande a l'utilisateur de comparer les termes
================================================*)


let interactive_cache = Cache.create 1024;;

let get_in_cache t1 t2 = Cache.find (t1,t2) interactive_cache 
and return_via_cache t1 t2 result =
  Cache.add (t1,t2) result interactive_cache ;
  result
;;

let rec ordre_interactif s t =
  try
    get_in_cache s t
  with 
      Not_found ->
	try 
	  match get_in_cache t s with
	      Less_than -> Greater
	    | Greater -> Less_than 
	    | Equivalent -> Equivalent
	    | Uncomparable -> Uncomparable 
	    | _ -> failwith "Bug in Term_orderings.ordre_interactif" 
	with Not_found ->
	  match 
	    ask 
	      ("=====    Compare '" ^ (string_of_term s) ^ "' and '" ^
	       (string_of_term t) ^ "' : ") 
       	      ["=";"<";">";"#";"undo"] 
              "Answer '=' if equivalent, '>' if greater, '<' if lower,\
               '#' if uncomparable,\n'undo' to return to the previous \
               choice point"
	
	  with
	      "=" -> return_via_cache s t Equivalent
	    | "<" -> return_via_cache s t Less_than
	    | ">" -> return_via_cache s t Greater
	    | "#" -> return_via_cache s t Uncomparable
	    | "undo" -> raise (Undo 1)
	    | _   -> failwith "Bug in Term_orderings.ordre_interactif" ;;

