(***************************************************************************

Lexer for generic polynomials

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: poly_interp_lexer.mll,v 1.1 2002/05/27 13:27:10 contejea Exp $

***************************************************************************)


{

  open Poly_interp;;
  open Poly_interp_parser;;

  exception Syntax_error of string;;

  let interp brack_s =
    let s = String.sub brack_s 1 ((String.length brack_s) - 2) in
      try
	let f = !current_signature#symbol_of_string s in
	  INTERP(f)
      with 
	  Not_found ->
	    raise (Syntax_error ("undefined identifier "^s))
	
}

rule token = parse
    [' ''\t''\n']+  	{ token lexbuf }
  | ['[']['a'-'z''A'-'Z']['a'-'z''A'-'Z''0'-'9''_''\'']*[']']
                        { interp(Lexing.lexeme lexbuf) }
  | ['a'-'z''A'-'Z']['a'-'z''A'-'Z''0'-'9''_''\'']*
                        { VAR(Lexing.lexeme lexbuf) }
  | '='                 { EQUAL }
  | ';'                 { SEMICOLON }
  | ','                 { COMMA }
  | '+'                 { PLUS }
  | '-'                 { MINUS }
  | '.'                 { MULT }
  | '^'                 { EXP }
  | ['0'-'9']+          { INT (Num.num_of_string (Lexing.lexeme lexbuf)) }
  | '('            	{ LEFT_PAR }
  | ')'            	{ RIGHT_PAR }
  | _                   { raise (Syntax_error (Lexing.lexeme lexbuf)) }
  | eof			{ EOF }

