(***************************************************************************

  Term orderings: body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: rpo.ml,v 1.11 2002/07/11 13:26:07 pguillon Exp $

***************************************************************************)

(*

Obsolete header:

  CiME Project - Dmons research team - LRI - Universit Paris XI

  $Id: rpo.ml,v 1.11 2002/07/11 13:26:07 pguillon Exp $

***************************************************************************)

open Orderings_generalities;;
open Gen_terms;;

type rpo_status =
     Multiset
   | Lr_lexico
   | Rl_lexico
;;

type 'symbol status_function = 'symbol -> rpo_status;;

(*

(rpo >_prec >_status) is the recursive path ordering with respect to
precedence >_prec and status >_status

*)

(*=================
Fonctionnelle RPO 
prec : 
status : 
==================*)


let number_of_cache_add = ref 0
let number_of_cache_find = ref 0
let number_of_failed_cache_find = ref 0

let rpo_statistics () = 
  (!number_of_cache_add,!number_of_cache_find,!number_of_failed_cache_find)




let rpo prec status =
  let rpo_cache = Cache.create 1031 in
  let get_in_cache t1 t2 =
    incr number_of_cache_find;
    Cache.find (t1,t2) rpo_cache 

  and return_via_cache t1 t2 result =
(*
    print_string "adding '";
    print_string (string_of_term t1);
    print_string "','";
    print_string (string_of_term t2);
    print_string "' -> in cache ";
    print_newline();
    flush stdout;
*)
    incr number_of_cache_add;
    Cache.add (t1,t2) result rpo_cache ;
    result
  in

  let rec rpo_rec t1 t2 = match t1.Hcons.node,t2.Hcons.node with
      Term(f1,l1), Term(f2,l2) -> 
	begin
	  try (* 
	    let result = *) get_in_cache t1 t2
(*
	    in 
	      print_string "found '";
	      print_string (string_of_term t1);
	      print_string "','";
	      print_string (string_of_term t2);
	      print_string "' -> in cache ";
	      print_newline();
	      flush stdout;
	      result
*)
	  with Not_found ->
	    
	    incr number_of_failed_cache_find;
	    if exists_greater_or_equal rpo_rec l1 t2
	    then return_via_cache t1 t2 Greater_than
	    else 
	      if exists_greater_or_equal rpo_rec l2 t1
              then return_via_cache t1 t2 Less_than
              else 
		begin
                  match prec f1 f2 with
                      Uncomparable          -> 
			return_via_cache t1 t2 Uncomparable
                    | Greater_than -> 
			if greater_than_all rpo_rec t1 l2
			then return_via_cache t1 t2 Greater_than
			else return_via_cache t1 t2 Uncomparable
                    | Less_than -> 
			if greater_than_all rpo_rec t2 l1
			then return_via_cache t1 t2 Less_than
			else return_via_cache t1 t2 Uncomparable
                    | Equivalent            ->
			begin
			  match (status f1,status f2) with
			      (Multiset,Multiset)   -> 
   	       	       		return_via_cache t1 t2 
				  (multiset_extension rpo_rec l1 l2)
			    | (Lr_lexico,Lr_lexico) ->
  	       	       		return_via_cache t1 t2 
				  (rpo_lexico t1 t2 l1 l2)
			    | (Lr_lexico,Rl_lexico) ->
  	       	       		return_via_cache t1 t2 
				  (rpo_lexico t1 t2 l1 (List.rev l2))
			    | (Rl_lexico,Lr_lexico) ->
  	       	       		return_via_cache t1 t2 
				  (rpo_lexico t1 t2 (List.rev l1) l2)
			    | (Rl_lexico,Rl_lexico) ->
   	       	       		return_via_cache t1 t2 
				  (rpo_lexico t1 t2 (List.rev l1) 
				     (List.rev l2))
			    | _ -> assert false
				  (*i 
				    failwith ("Incompatible status in rpo for '" 
				    ^ (string_of_symbol_id f1) ^ "' and '" 
				    ^ (string_of_symbol_id f2) ^ "'")
				    i*)
			end
                    | _ -> assert false
                end
	end
	
    | (Var x,Term(_,l)) -> 
	if var_occurs_in_term_list x l
	then Less_than
	else Uncomparable
    | (Term(_,l),Var x) -> 
	if var_occurs_in_term_list x l
	then Greater_than
	else Uncomparable
    | (Var x1,Var x2) -> 
     if x1=x2
     then Equivalent
     else Uncomparable
       
  and rpo_lexico s1 s2 l1 l2 =
    match lexicographic_extension rpo_rec l1 l2 with
	Equivalent            -> 
          Equivalent
      | Greater_than -> 
          if greater_than_all rpo_rec s1 l2
          then Greater_than
          else Uncomparable
      | Less_than -> 
          if greater_than_all rpo_rec s2 l1
          then Less_than
          else Uncomparable
      | Uncomparable          ->
          Uncomparable
      | _ -> assert false
	    
  in
    
(*
  Hashtbl.clear rpo_cache;
*)
    rpo_rec






let check_rpo_conditions n prec = ()



