(***************************************************************************

Recursive Program Scheme functional for building new orderings

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: rps.mli,v 1.4 2001/01/31 16:08:33 monate Exp $

***************************************************************************)

open Orderings;;
open Terms;;
open Equations;;
open Dnet;;

(*

(rps R o) build an create [term_ordering] from an old one o and a set of
rewrite rules R, defined by

  t1 > t2  iff  R-nf(t1) o R-nf(t2) 

this defines a reduction ordering only if R satisfies some properties.
[(check_rps_conditions R)] checks whether these conditions are
satisfied, raise a [semantical_error] if not.

*)

val rps: int * regle_etendue dnet -> term ordering -> term ordering;;

val check_rps_conditions : regle list -> unit;;


