(***************************************************************************

Polynomial orderings provided by the user : body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user_poly_ordering.ml,v 1.1 2002/05/27 12:07:26 contejea Exp $

***************************************************************************)

exception Syntax_error of string;;

let of_string sigma s =
  let b = Lexing.from_string s 
  and _ = Poly_interp.current_signature := sigma in
  let interp_map = 
    Poly_interp_parser.poly_interp_entry Poly_interp_lexer.token b in
    Poly_interp.poly_ord sigma 
      (function f -> 
	 try
	   Signatures.SymbolMap.find f interp_map 
	 with Not_found -> 
	   raise 
	     (Syntax_error ("interpretation needed for symbol " ^ 
			    (sigma#string_of_symbol f))))
      
