(***************************************************************************

Signature lexer

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: term_lexer.mll,v 1.3 2002/03/04 10:16:10 urbain Exp $

***************************************************************************)


{

(*  open Symbols *)
  open Term_parser

  exception Invalid_char of string

  let ident s =
    try
      let f = symbol_id_of_string s
      in 
	if is_postfix f
        then POSTFIX_IDENT s
        else if is_infix f
        then INFIX_IDENT s
        else PREFIX_IDENT s
    with Not_found -> PREFIX_IDENT s (* une variable ou pas defini... *)
	
}

rule token = parse
    [' ''\t''\n'] 	{ token lexbuf }
  | ','            	{ COMMA }
  | ';'            	{ SEMICOLON }
  | "->"            	{ ARROW }
  | '('            	{ OPENPAR }
  | ')'            	{ CLOSEPAR }
  | (['a'-'z''A'-'Z''0'-'9''_''\'']+|
     ['^''+''.''&''*''-''/''!''?''@''~''#'])
      ('_'(['a'-'z''A'-'Z''0'-'9''_''\'']+|
	   ['^''+''.''&''*''-''/''!''?''@''~''#']))* 
                        { ident(Lexing.lexeme lexbuf) }
  | _                   { raise (Invalid_char (Lexing.lexeme lexbuf)) }
  | eof			{ EOF }


