(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user_terms.ml,v 1.2 1998/04/28 13:36:25 marche Exp $

***************************************************************************)


exception Syntax_error of string;;

exception Found of int;;

let sig_of_string s =
  try
    let b = Lexing.from_string s
    in
    let t = Signature_parser.signature Signature_lexer.token b
    in
    let u =
      List.fold_left
	(fun l (ops,ar,f,t) ->
	   l @ (List.map (fun x -> (x,ar,f,t)) ops))
	[]
	t
    in
      Array.of_list u
  with
      Parsing.Parse_error -> 
	raise (Syntax_error "")
    | Failure "lexing: empty token" -> 
	raise (Syntax_error "invalid character")
    | Signature_lexer.Invalid_char s ->
	raise (Syntax_error ("invalid character '"^s^"'"))
;;


let term_of_string s =
  try
    let b = Lexing.from_string s
    in
      Term_parser.term_eof Term_lexer.token b
    with
      Parsing.Parse_error -> 
	raise (Syntax_error "")
    | Failure "lexing: empty token" -> 
	raise (Syntax_error "invalid character")
    | Term_lexer.Invalid_char s ->
	raise (Syntax_error ("invalid character '"^s^"'"))
;;

let rule_set_of_string s =
  try
    let b = Lexing.from_string s
    in
      Term_parser.rule_set_eof Term_lexer.token b
    with
      Parsing.Parse_error -> 
	raise (Syntax_error "")
    | Failure "lexing: empty token" -> 
	raise (Syntax_error "invalid character")
    | Term_lexer.Invalid_char s ->
	raise (Syntax_error ("invalid character '"^s^"'"))
;;

