(***************************************************************************

Inclusion

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: printers.ml,v 1.1 2000/05/16 17:38:34 monate Exp $

***************************************************************************)

open Format;;

#directory "../terms";;

open Signatures;;
open User_signatures;;
open Variables;;
open User_terms;;
open Rewrite_rules;;

#directory "../integer_solver";;

open Finite_domains;;
open Non_linear_solving;;

#install_printer print_fd_solution;;

open Ordering_existence_constraints;;
open Dependency_pairs_criteria;;
open Generic_polynomials;;

#install_printer print_generic_polynomial;;
#install_printer print_fd_solution;;
#install_printer print_non_linear_constraints;;

(*
  
  [(time f x)] is [(f x)] but also show the execution time

*)

let time f x =
  let time_before = Unix.times ()
  in
  let show_time () =
    let time_after = Unix.times ()
    in
      print_string "Execution time : ";
      print_float (time_after.Unix.tms_utime -. time_before.Unix.tms_utime);
      print_string " sec.";
      print_newline()
      	
  in
    try
      let res = f x
      in show_time();res
    with e -> show_time();raise e      
;;

	  




