(***************************************************************************

Inclusion

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: test1.ml,v 1.1 2000/05/16 17:38:34 monate Exp $

***************************************************************************)

#use "printers.ml";;


(*

  definition de quelques symboles de fonctions

*)

let my_sig = 
  new user_signature 
    "0 : constant;
     s : unary;
     m,p : binary;
     +,* : AC;";;


let my_vars =
  new user_variables
    ["x";"y";"z"];;

let my_ordering_existence_constraint_printer = 
  print_ordering_existence_constraints my_sig my_vars;; 

#install_printer my_ordering_existence_constraint_printer;;

let my_print_rewrite_rule_set = print_rewrite_rule_set my_sig my_vars;;

#install_printer my_print_rewrite_rule_set;;


let my_print_interp = Generic_polynomials.print_interp my_sig;;

#install_printer my_print_interp ;;


let my_dupl_sig = signature_with_marks my_sig;;


let my_dupl_ordering_existence_constraint_printer = 
  print_ordering_existence_constraints my_dupl_sig my_vars;;

#install_printer my_dupl_ordering_existence_constraint_printer;;


let dp_termination_with_markings criterion r =
  print_string "Rewrite system : ";
  print_newline();
  my_print_rewrite_rule_set r;
  print_newline();
  print_newline();
  let ord_constr = criterion r
  in
    print_string "Ordering existence constraints : ";
    print_newline();
    my_ordering_existence_constraint_printer ord_constr;
    print_newline();
    print_newline();
    let interp,constr_ac,constr_mon,constr_dp = 
      Generic_polynomials.polynomial_constraints_of_orderings_existence_constraints
      	sigma ord_constr
    in
    let poly_constr = constr_ac@constr_dp
    in
      print_string "Polynomial ordering constraints : ";
      print_newline();
      print_non_linear_constraints poly_constr;
      print_newline();    
(*
      try
*)
	let sol =
	  time 
      	    (Non_linear_solving.non_linear_solve (Num.Int 20)) 
      	    poly_constr
      	in
	let new_interp = 
	  SymbolMap.fold
	    (fun f p i ->
	       SymbolMap.add 
		 f (Generic_polynomials.specialize_polynomial p sol) i)
	    interp
            SymbolMap.empty
	in interp,sol,new_interp
;;


(*

  quelques exemples de systemes de reecriture

*)


let peano =
  rule_set_of_string my_sig my_vars
    "p(x,0) -> x;
     p(x,s(y)) -> s(p(x,y));
     m(x,0) -> 0;
     m(x,s(y)) -> p(m(x,y),x);"
;;

let peano_add_ac =
  rule_set_of_string my_sig my_vars
     "x+0 -> x;
      s(x)+s(y) -> s(s(x+y));"
;;

let peano_ac = peano_add_ac @
  (rule_set_of_string my_sig my_vars
     "x * 0 -> 0;
      s(x) * s(y) -> (x*y) + x + y + s(0);")
;;

 
open Dependency_pairs_criteria;;

(*

dp_termination simple_dependency_pair_criterion peano;;

dp_termination simple_dependency_pair_criterion peano_add_ac;;

dp_termination simple_dependency_pair_criterion peano_ac;;

dp_termination (dependency_pair_criterion_with_markings my_sig) peano;;

dp_termination (dependency_pair_criterion_with_markings my_sig) peano_add_ac;;

dp_termination (dependency_pair_criterion_with_markings my_sig) peano_ac;;

dp_termination simple_dependency_graph_criterion peano;;

dp_termination simple_dependency_graph_criterion peano_add_ac;;

dp_termination simple_dependency_graph_criterion peano_ac;;

dp_termination (dependency_graph_criterion_with_markings my_sig) peano;;

dp_termination (dependency_graph_criterion_with_markings my_sig) peano_add_ac;;

dp_termination (dependency_graph_criterion_with_markings my_sig) peano_ac;;

*)
