(***************************************************************************

Signature lexer

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: poly_lexer.mll,v 1.2 2001/04/20 13:42:29 marche Exp $

***************************************************************************)


{

  open Poly_parser
  open Poly_syntax
  open Generic_polynomials
  open Signatures

  exception Invalid_char of string

  let ident s =
    try
      let is_marked = 
	String.get s 0 = '\'' & String.get s (pred (String.length s)) = '`'
      in
      let s' =
      	if is_marked 
      	then String.sub s 1 (pred (pred (String.length s)))
	else s
      in      	
      let f = !current_signature#symbol_of_string s
      in 
	if is_marked
	then Marked f
	else Original f
    with 
	Not_found ->
	  Errors.semantical_error ("undefined identifier "^s)
	
}

rule token = parse
    [' ''\t''\n'] 	{ token lexbuf }
  | ','            	{ COMMA }
  | ';'            	{ SEMICOLON }
  | "->"            	{ ARROW }
  | '('            	{ OPENPAR }
  | ')'            	{ CLOSEPAR }
  | ['a'-'z''A'-'Z''0'-'9']['a'-'z''A'-'Z''0'-'9''_''\'']*
  | ['^''+''.''&''*''-''/''!''?''@''~''#'] ('_'(['a'-'z''A'-'Z''0'-'9']+))* 
                        { ident(Lexing.lexeme lexbuf) }
  | _                   { raise (Invalid_char (Lexing.lexeme lexbuf)) }
  | eof			{ EOF }


