(* Dependency pairs of hierarchical TRS.
  
   Interface
*)
open Rewrite_rules;;
open Marked_dp_criteria;;


val rdp_of_rules :
  ('symbol Rewrite_rules.t) list ->
    ('symbol Gen_terms.term * 'symbol Gen_terms.term ) list
;;


val marked_rdp_of_rules :
  'symbol #Signatures.signature -> 
    'symbol Gen_terms.HashTerm.t ->
    'symbol dupl Gen_terms.HashTerm.t -> ('symbol Rewrite_rules.t) list ->
      (('symbol dupl) Gen_terms.term * ('symbol dupl) Gen_terms.term ) list
;;

  

val relative_dp_criterion : 
  Hierarchical_trs.htrs ->
    (Hierarchical_signatures.hsymbol) Termination_constraints.conj_termination_constraints;;


val marked_relative_dp_criterion : 
  Hierarchical_trs.htrs ->
    Hierarchical_signatures.hsymbol Marked_dp_criteria.dupl #Signatures.signature ->
      Hierarchical_signatures.hsymbol dupl Termination_constraints.conj_termination_constraints


