(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: hierarchical_trs.mli,v 1.7 2002/07/01 12:01:36 contejea Exp $

***************************************************************************)







type htrs = 
    {
      htrs_sig : Hierarchical_signatures.hierarchical_signature;
      htrs_new_rules : 
        Hierarchical_signatures.hsymbol Rewrite_rules.t list;
      htrs_imported : htrs list;
      htrs_all_rules : 
      Hierarchical_signatures.hsymbol Rewrite_rules.t list;
      proved_c_e_terminating : bool ref;
      hct : Hierarchical_signatures.hsymbol Gen_terms.HashTerm.t;
      marked_hct : Hierarchical_signatures.hsymbol Marked_dp_criteria.dupl Gen_terms.HashTerm.t;
    }
;;

(*

  [extend imported sigma vars rules] makes a new HTRS from the list
  [imported] of known HTRS, by adding the new signature [sigma] and
  the new rules syntactically given in the string [rules], those
  being defined on [sigma] and the signatures of the [imported] htrs.

  If a defined symbol in new rules [rules] is not defined in
  [sigma] then an exception [Overriden] is thrown.
*)



val extend :
  htrs list -> #User_signatures.user_signature -> 
    Variables.user_variables -> string -> htrs ;;

val assume_ce :
  htrs -> unit ;;

val clear_ce :
  htrs -> unit ;;

exception Overriden of string;;
