
open Gen_terms;;

type comparison_op = Eq | Ne | Le | Lt | Ge | Gt;;
    
type 'symbol formula =
  | True
  | False
  | Or of 'symbol formula list
  | And of 'symbol formula list
  | Not of 'symbol formula
  | Atom of 
      'symbol term * comparison_op * 'symbol term 
;;

(*

  the following functions build conjunctions and disjunctions, keeping
  formulas flattened.

*)

val conj : 'symbol formula -> 'symbol formula -> 'symbol formula;;
val disj : 'symbol formula -> 'symbol formula -> 'symbol formula;;
val conj_all : 'symbol formula list -> 'symbol formula;;
val disj_all : 'symbol formula list -> 'symbol formula;;

val make_formula_from_string_formula : 
  'symbol #Signatures.parseable_signature -> 'symbol HashTerm.t -> 
    string formula -> 'symbol formula

val print_formula :
  'symbol #Signatures.signature -> Variables.user_variables -> 'symbol formula -> unit


