(***************************************************************************

This module defines the class of sorted signatures, allowing
commutative or associative-commutative symbols.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: sorted_signatures.mli,v 1.1 2000/10/30 16:53:35 monate Exp $

***************************************************************************)


open Sorts
open User_signatures
open Signatures
		 
(*

  [profile_of_symbol f] returns [(l,r)] where [l] is the list of sorts
  of arguments of [f] and [r] is its return sort.

*)

class type ['a] sorted_signature = 
  object
    inherit ['a] signature
    method profile_of_symbol : 'a -> sort_id list * sort_id
  end
;;


class type user_sorted_signature = 
  object
    inherit [symbol_id] sorted_signature
    inherit user_signature
  end
;;

class virtual from_string : #sort -> string -> user_sorted_signature;;


