(***************************************************************************

Standard substitutions

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: substitution.mli,v 1.4 2002/07/01 12:01:36 contejea Exp $

***************************************************************************)

open Signatures
open Variables
open Gen_terms


type 'symbol substitution = (unit,'symbol term) VarMap.t;;



(* [(apply_term h t $\sigma$)] computes $t\sigma$ and uses the hashconsing table 
   of terms [h] *)

val apply_term : 
  'symbol HashTerm.t -> 'symbol term -> 'symbol substitution -> 'symbol term

val apply_sorted_term : 
  'symbol #signature -> 'symbol HashTerm.t -> 'symbol term -> 
    'symbol substitution -> 'symbol term

(*
val apply_rewrite_rule : 
  'symbol HashTerm.t -> 'symbol Rewrite_rules.t -> 
    'symbol substitution -> 'symbol Rewrite_rules.t
*)
(* 

   [(merge_subst subst1 subst2)] merges substitutions [subst1] and
   [subst2], that is put them together verifying that if [subst1]
   binds a variable $x$ to a term $t_1$ and [subst2] binds the same
   variable to $t_2$, then $t_1=t_2$

   Raises Conflict if not.

   This is standard substitution merging: equality of $t_1$ and $t_2$
   is performed assuming that all symbols are free.

*)

exception Conflict;;

val merge_substs : 
  'symbol substitution -> 'symbol substitution -> 'symbol substitution;;


val substitute :
  'symbol #Signatures.signature -> 'symbol HashTerm.t -> 
    'symbol substitution -> 
      'symbol term -> 'symbol term;;

val apply_subst_to_eqs :
  'symbol #Signatures.signature -> 'symbol HashTerm.t -> 
    'symbol substitution -> 
      ('symbol term * 'symbol term) list -> ('symbol term * 'symbol term) list

val print : 
  'symbol #Signatures.signature -> Variables.user_variables 
    -> 'symbol substitution -> unit;;

