(***************************************************************************

Terms defined on user signatures

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user_terms.mli,v 1.11 2002/07/16 09:29:36 contejea Exp $

***************************************************************************)


(*

  [(term_of_string sigma t)] returns the term over the signature
  [sigma], read in the string [s]

*)

val term_of_string : 
  'a #Signatures.parseable_signature -> 'a Gen_terms.HashTerm.t -> Variables.user_variables ->
    string -> 'a Gen_terms.term
;;

val equation_of_string : 
  'a #Signatures.parseable_signature -> 'a Gen_terms.HashTerm.t -> Variables.user_variables -> 
    string -> ('a Gen_terms.term * 'a Gen_terms.term) 
;;

(*

  [(equation_set_of_string sigma t)] returns the set of equations over
  the signature [sigma], read in the string [s]

*)

val equation_set_of_string : 
  'a #Signatures.parseable_signature -> 'a Gen_terms.HashTerm.t -> Variables.user_variables -> 
    string -> ('a Gen_terms.term * 'a Gen_terms.term) list
;;

(*

  [(rule_set_of_string sigma t)] returns the set of rewrite rules over
  the signature [sigma], read in the string [s]

*)

val rule_set_of_string : 
  'a #Signatures.parseable_signature -> 'a Gen_terms.HashTerm.t -> Variables.user_variables -> 
    string -> 'a  Rewrite_rules.t list
;;

(*

  [(prec_of_string sigma s)] returns the precedence over
  the signature [sigma], read in the string [s]

*)


val prec_of_string : 
  'a #Signatures.parseable_signature -> string 
    -> 'a Orderings_generalities.ordering
;;


val order_constraint_of_string :
  'a #Signatures.parseable_signature -> 'a Gen_terms.HashTerm.t -> Variables.user_variables -> 
    string -> 'a Order_constraints.formula

(*

  [(status_of_string sigma s)] returns the function status (for
  RPO-like term orderings) over the signature [sigma], read in the
  string [s] (raises the exception Invalid_status whenever an AC
  function symbol is not given a multiset status).

*)

exception Invalid_status of string

val status_of_string :  
  'a #Signatures.parseable_signature -> string 
    -> 'a Rpo.status_function

val user_hct : User_signatures.symbol_id Gen_terms.HashTerm.t
