(***************************************************************************

Calcul du couple_normalisant pour A(.) : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: a.mli,v 1.2 1998/04/28 13:36:38 marche Exp $

***************************************************************************)

open Symbols
open Terms


(*===============================

(\Theta_{A},\Psi_{A}

================================*)


val ajoute_variable_a_droite : symbol_id -> var_id -> term 
      -> term


(*
theta_a mult u v retourne theta(u,v) comme defini dans la completion 
normalisee, vis-a-vis de la theorie A(mult). On suppose que u>v.
*)

val theta_a :  symbol_id -> term -> term 
  -> (term * term) list

(*
psi_a mult u v retourne psi(u,v) comme defini dans la completion 
normalisee, vis-a-vis de la theorie A(mult). On suppose que u>v.
*)
val psi_a : symbol_id -> term -> term 
  -> (term * term) list

val couple_normalisant_a : symbol_id -> term -> term 
  -> (term * term) list * (term * term) list


(*
theta_sym_a mult u v retourne  theta(u,v) comme defini dans la completion 
normalisee, vis-a-vis de la theorie A(mult), mais pour la completion ordonnee,
dans le cas ou u et v sont incomparables pour >.
*)

val theta_sym_a : symbol_id -> term -> term 
  -> (term * term) list

(*
psi_sym_a mult u v retourne  psi(u,v) comme defini dans la completion 
normalisee, vis-a-vis de la theorie A(mult), mais pour la completion ordonnee,
dans le cas ou u et v sont incomparables pour >.
*)
val psi_sym_a : symbol_id -> term -> term 
  -> (term * term) list

val couple_normalisant_sym_a : symbol_id -> term -> term 
  -> (term * term) list * (term * term) list

