(***************************************************************************

Calcul du couple_normalisant pour ACI(+) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: aci.ml,v 1.2 1998/04/28 13:36:40 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Created on:             04 mai 93

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/aci.ml,v $
Revision:         $Revision: 1.2 $
Last modified on: $Date: 1998/04/28 13:36:40 $

***************************************************************************)

open Symbols
open Terms
open Ac_critical_pairs
open Critical_equations
open Orderings


(*===============================

(\Theta_{ACI},\Psi_{ACI}

================================*)

(*===============================

(\Theta_{ACI},\Psi_{ACI})

================================*)

let theta_aci plus u v = 
  Unification.select_ac_only_unification();
  let x = new_var (variables_du_terme u) in
  let y = next_new_var x in
  let var_x = VAR x
  and var_y = VAR y in
  let x_plus_x = TERM(plus,[var_x;var_x])
  and x_plus_x_plus_y = TERM(plus,[var_x;var_x;var_y])
  and x_plus_y = TERM(plus,[var_x;var_y]) in
  let sigma = 
    make_critical_equations 
      (paires_critiques_ac_larges u v x_plus_x var_x)
    @ make_critical_equations
      (paires_critiques_ac_larges u v x_plus_x_plus_y x_plus_y)
  in Unification.select_ac_complete_unification();
     sigma

let theta_sym_aci plus u v = 
  Unification.select_ac_only_unification();
  let x = new_var (variables_de_liste_de_termes [u;v]) in
  let y = next_new_var x in
  let var_x = VAR x
  and var_y = VAR y in
  let x_plus_x = TERM(plus,[var_x;var_x])
  and x_plus_x_plus_y = TERM(plus,[var_x;var_x;var_y])
  and x_plus_y = TERM(plus,[var_x;var_y]) in
  let sigma = 
    make_critical_equations 
      (paires_critiques_ac_larges u v x_plus_x var_x)
    @ make_critical_equations
      (paires_critiques_ac_larges u v x_plus_x_plus_y x_plus_y)
    @ make_critical_equations 
      (paires_critiques_ac_larges v u x_plus_x var_x)
    @ make_critical_equations
      (paires_critiques_ac_larges v u x_plus_x_plus_y x_plus_y)
  in Unification.select_ac_complete_unification();
     sigma



let couple_normalisant_aci plus u v =
  (theta_aci plus u v, [])


let couple_normalisant_sym_aci plus u v =
  (theta_sym_aci plus u v, [])


