(***************************************************************************

Calcul du couple_normalisant pour AC1N(+,0) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: acun.ml,v 1.2 1998/04/28 13:36:44 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Created on:             06 mai 93

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/acun.ml,v $
Revision:         $Revision: 1.2 $
Last modified on: $Date: 1998/04/28 13:36:44 $

***************************************************************************)


open Acu
open Ac_critical_pairs
open Critical_equations
open Equations
open Norm_theory

open Symbols
open Terms

(*===============================

(\Theta_{ACUN},\Psi_{ACUN}

================================*)

let sigma_1 plus zero n u v =
  Unification.select_ac_only_unification();
  let nil = (nilpotence plus zero n) in
  let sigma =  make_critical_equations 
                    (paires_critiques_ac_etendues (make_basic_rule (u,v)) nil) in
  Unification.select_ac_complete_unification();
  sigma
   
let sigma_sym_1 plus zero n u v =
  Unification.select_ac_only_unification();
  let nil = (nilpotence plus zero n) in
  let sigma =  make_critical_equations 
                    (paires_critiques_ac_etendues (make_basic_rule (u,v)) nil) 
  and sigma' = make_critical_equations 
                    (paires_critiques_ac_etendues (make_basic_rule (v,u)) nil) in
  Unification.select_ac_complete_unification();
  sigma @ sigma'
   
let theta_acun plus zero n u v =
(*
  printf "calcul de theta_AC1N(%s,%s)\n" 
         (string_of_terme u) 
         (string_of_terme v);
*)
    (theta_acu plus zero u v)
  @ (sigma_1 plus zero n u v)

let theta_sym_acun plus zero n u v =
    (theta_sym_acu plus zero u v)
  @ (sigma_sym_1 plus zero n u v)


let couple_normalisant_acun plus zero n u v =
    (theta_acun plus zero n u v,[])

let couple_normalisant_sym_acun plus zero n u v =
    (theta_sym_acun plus zero n u v,[])

