(***************************************************************************

Calcul du couple_normalisant pour AG(+,0,-) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ag.ml,v 1.3 1998/05/19 11:55:43 contejea Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Created on:             04 mai 93


Last modified by: $Author: contejea $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/ag.ml,v $
Revision:         $Revision: 1.3 $
Last modified on: $Date: 1998/05/19 11:55:43 $

***************************************************************************)

open Symbols;;
open Terms;;
open Acu;;
open Symmetrization;;
open Ac_critical_pairs;;
open Critical_equations;;




(*
instancie_par_oppose moins u v x retourne
le couple de termes (u,v) instancie par la substitution {x\-> moins x}
*)

let sigma_1 plus zero moins u v =
  Unification.select_ac_only_unification();
  let x = new_var (variables_du_terme u) in
  let var_x = VAR x in
  let x_moins_x = TERM(plus,[var_x;TERM(moins,[var_x])]) in
  let sigma =
    make_critical_equations 
      ([],
       (paires_critiques_ac_strictes u v x_moins_x (TERM(zero,[])))) in
  
  Unification.select_ac_complete_unification();
  sigma 
    ;;
   
let sigma_sym_1 plus zero moins u v =
  Unification.select_ac_only_unification();
  let x = new_var (variables_de_liste_de_termes [u;v]) in
  let y = next_new_var x in
  let var_x = VAR x 
  and var_y = VAR y in
  let x_moins_x = TERM(plus,[var_x;TERM(moins,[var_x])]) 
  and zero' = TERM(zero,[])
  and x_moins_x_plus_y = TERM(plus,[var_x;TERM(moins,[var_x]);var_y]) in
  let sigma = make_critical_equations 
                 (paires_critiques_ac_larges u v x_moins_x zero')
            @ make_critical_equations 
                 (paires_critiques_ac_larges u v x_moins_x_plus_y var_y)
            @ make_critical_equations ([],(
                 (paires_critiques_ac_strictes v u x_moins_x zero')
               @ (paires_critiques_ac_strictes v u x_moins_x_plus_y var_y))) in
  Unification.select_ac_complete_unification();
  sigma 
;;
   

(*
instancie_par_oppose moins u v x retourne
le couple de termes (u,v) instancie par la substitution {x\-> moins x}
*)

let instancie_par_oppose moins u v x = 
  let rec instancie_terme_par_oppose = function
      VAR k as v -> 
	if x=k
      	then TERM(moins,[v])
        else v
    | TERM(f,l) -> TERM(f,List.map instancie_terme_par_oppose l) in

  (instancie_terme_par_oppose u,instancie_terme_par_oppose v);;


(*
instancie_par_somme plus u v var_sup x retourne
le couple de termes (u,v) instancie par la substitution {x\-> x plus x'}
*)

let instancie_par_somme plus u v x' x = 
  let var_sup = VAR x' in
  let rec instancie_terme_par_somme = function
      VAR k as v -> 
      	if x=k
      	then TERM(plus,[v;var_sup])
      	else v
    | TERM(f,l) -> 
      	if f = plus
      	then head_flatten_term (TERM(f,List.map instancie_terme_par_somme l))
      	else TERM(f,List.map instancie_terme_par_somme l) in
  
  (instancie_terme_par_somme u,instancie_terme_par_somme v)
    ;;

let sigma_2 plus zero moins u v =
  let vars = substitutions_a_interdire moins u 
  and x' = new_var (variables_du_terme u) in
  (List.map (instancie_par_zero zero u v) vars) @
  (List.map (instancie_par_oppose moins u v) vars) @
  (List.map (instancie_par_somme plus u v x') vars)
    ;;

let theta_ag plus zero moins u v =
  (theta_acu plus zero u v) @
  (sigma_1 plus zero moins u v) @
  (sigma_2 plus zero moins u v)
    ;;

let theta_sym_ag plus zero moins u v =
    (theta_sym_acu plus zero u v)
  @ (sigma_sym_1 plus zero moins u v);;


let couple_normalisant_ag plus zero moins u v = 

  let (coef,left) = (finish_symmetrization plus u) in
  let regles = 
    if coef=1 
      then []
      else [(u,v);
            (TERM(moins,[left]), 
             TERM(plus,TERM(moins,[v])::(duplique (coef-1) left)))]
  and equations = theta_ag plus zero moins u v
  in (equations, regles)
;;

let couple_normalisant_sym_ag plus zero moins u v = 
 let equations = theta_sym_ag plus zero moins u v
 in (equations, [])
;;


