(***************************************************************************

Calcul du couple_normalisant pour AU(.,e) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: au.ml,v 1.2 1998/04/28 13:36:46 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Author(s):             Claude March\'e

File name:        au.ml
Created on:              03 nov 93
Last modified on: 03 nov 93

***************************************************************************)


open Symbols
open Terms
open A




(*===============================

(\Theta_{AU},\Psi_{AU}

================================*)


let rec flat_map_union f = function
  ([] : term list) -> ([] : var_id list)
| h::t -> (fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (f h) (flat_map_union f t)

(* 
substitutions_a_interdire * t retourne toutes les variables x telles
que le motif x*? ou ?*x apparait dans t. 
Note: * etant associatif, il est necessairement binaire.
*)

let rec substitutions_a_interdire mult = function
  (VAR _) -> []
| TERM(f,l) -> 
     if (f=mult)
     then substitutions_interdites mult l
     else flat_map_union (function x -> substitutions_a_interdire mult x) l

and substitutions_interdites mult = function
  [(VAR x);(VAR y)] -> if x=y then [x] else [x;y]
| [(VAR x);t] -> (fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) [x] (substitutions_a_interdire mult t)
| [t;(VAR x)] -> (fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) [x] (substitutions_a_interdire mult t)
| [t1;t2] -> (fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (substitutions_a_interdire mult t1)
                   (substitutions_a_interdire mult t2) 
| _ -> failwith "Au.substitutions_interdites"

(*
instancie_par_neutre one u v x retourne
le couple de termes (u,v) instancie par la substitution {x\-> one}
*)

let instancie_par_neutre one u v x = 
let rec instancie_terme_par_neutre = function
    VAR k as v -> if x=k
                  then TERM(one,[])
                  else v
  | TERM(f,l) -> TERM(f,List.map instancie_terme_par_neutre l) in

  (instancie_terme_par_neutre u,instancie_terme_par_neutre v)

let theta_au mult one u v = 
    List.map (instancie_par_neutre one u v) (substitutions_a_interdire mult u)

let theta_sym_au mult one u v = 
    List.map (instancie_par_neutre one u v) 
        ((fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (substitutions_a_interdire mult u)
               (substitutions_a_interdire mult v))

let couple_normalisant_au mult one u v = 
    ((theta_a mult u v) @ (theta_au mult one u v),psi_a mult u v)

let couple_normalisant_sym_au mult one u v = 
    ((theta_sym_a mult u v) @ (theta_sym_au mult one u v),psi_sym_a mult u v)



