(***************************************************************************

Calcul du couple_normalisant pour BR(+,0,*,1) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: br.ml,v 1.2 1998/04/28 13:36:47 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Author(s):              Evelyne Contejean

File name:              br.ml
Created on:             05 fevrier 96
Last modified on:       $Date: 1998/04/28 13:36:47 $
              by        $Author: marche $

***************************************************************************)

open Symbols;;
open Terms;;
open Acu;;
open Acun;;
open Ac0;;
open Ag;;
(*
open Equations;;
open Orderings;;
*)

(*===============================

(\Theta_{BR},\Psi_{BR})

================================*)

   
let sigma_4 plus mult u v =
    let subst_int = substitutions_a_interdire mult u 
    and x = new_var (variables_du_terme u) in 
    List.map (instancie_par_somme plus u v x) subst_int
;;

let sigma_sym_4 plus mult u v =
    let subst_int = (fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (substitutions_a_interdire mult u)
                          (substitutions_a_interdire mult v)
    and x = new_var ((fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (variables_du_terme u) (variables_du_terme v)) in
    List.map (instancie_par_somme plus u v x) subst_int
;;
   
let theta_br plus zero mult un u v =
    (theta_acun plus zero 2 u v)
  @ (theta_acu mult un u v)
  @ (theta_ac0 mult zero u v)
  @ (sigma_4 plus mult u v)
;;

let theta_sym_br plus zero mult un u v =
    (theta_sym_acun plus zero 2 u v)
  @ (theta_sym_acu mult un u v)
  @ (theta_sym_ac0 mult zero u v)
  @ (sigma_sym_4 plus mult u v)
;;


let couple_normalisant_br plus zero mult un u v = 
  (theta_br plus zero mult un u v, [])
;;

let couple_normalisant_sym_br plus zero mult un u v = 
  (theta_sym_br plus zero mult un u v, [])
;;




