(***************************************************************************

Calcul du couple_normalisant pour CR(+,0,-,*,1) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: cr.ml,v 1.2 1998/04/28 13:36:49 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Created on:              05 mai 93

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/cr.ml,v $
Revision:         $Revision: 1.2 $
Last modified on: $Date: 1998/04/28 13:36:49 $

***************************************************************************)

open Symbols;;
open Terms;;
open Acu;;
open Ac0;;
open Ag;;
open Symmetrization;;





(*===============================

(\Theta_{CR},\Psi_{CR})

================================*)

   
let sigma_3 plus moins mult u v =
    let subst_int = substitutions_a_interdire mult u 
    and x = new_var (variables_du_terme u) in
    (List.map (instancie_par_somme plus u v x) subst_int)
    @ (List.map (instancie_par_oppose moins u v) subst_int)
;;

let sigma_sym_3 plus moins mult u v =
    let subst_int = (fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (substitutions_a_interdire mult u)
                          (substitutions_a_interdire mult v)
    and x = new_var ((fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (variables_du_terme u) (variables_du_terme v)) in
    (List.map (instancie_par_somme plus u v x) subst_int)
    @ (List.map (instancie_par_oppose moins u v) subst_int)
;;


let theta_cr plus zero moins mult un u v =
    (theta_ag plus zero moins u v)
  @ (theta_acu mult un u v)
  @ (theta_ac0 mult zero u v)
  @ (sigma_3 plus moins mult u v)
;;

let theta_sym_cr plus zero moins mult un u v =
    (theta_sym_ag plus zero moins u v)
  @ (theta_sym_acu mult un u v)
  @ (theta_sym_ac0 mult zero u v)
  @ (sigma_sym_3 plus moins mult u v)
;;

(*
  psi_cr plus zero moins mult un n s t retourne psi defini par la completion
  normalisee modulo les anneaux commutatifs pour le triplet (n,s,t), qui
  correspond a l'equation s+ ... + s = t
                          \___  ___/
                              \/
			    n fois
*)
let psi_cr plus zero moins mult un n s t = 

    if n = 1 
      then []
      else let x = new_var (variables_du_terme s) in
           let var_x = VAR x in
           let x_fois_s = (if (try (top_symbol_id s) = mult 
      	                       with Invalid_argument _ -> false)
                           then let l = (liste_des_sous_termes s) in
                                TERM(mult,var_x::l)
			   else TERM(mult,[var_x;s]))
	   and x_fois_t = add_left_var mult x t in
           [(TERM(plus,duplique n s),t);
            (TERM(plus,duplique n x_fois_s),x_fois_t);
            (TERM(moins,[s]),TERM(plus,TERM(moins,[t])::(duplique (n-1) s)));
            (TERM(moins,[x_fois_s]),TERM(plus,TERM(moins,[x_fois_t])::
                                              (duplique (n-1) x_fois_s)))]
;;

let psi_sym_cr plus zero moins mult un u v = 
  if (try (top_symbol_id u) = plus
      with Invalid_argument _ -> false) or
     (try (top_symbol_id v) = plus
      with Invalid_argument _ -> false)
  then begin
       let x = new_var ((fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (variables_du_terme u) (variables_du_terme v)) in
       let var_x = VAR x in
       let x_fois_u = (if (try (top_symbol_id u) = mult 
      	                   with Invalid_argument _ -> false)
                       then let l = (liste_des_sous_termes u) in
                            TERM(mult,var_x::l)
	               else TERM(mult,[var_x;u]))
       and x_fois_v = (if (try (top_symbol_id v) = mult 
                           with Invalid_argument _ -> false)
                       then let l' = (liste_des_sous_termes v) in
                            TERM(mult,var_x::l')
	               else TERM(mult,[var_x;v])) in
       [(u,v);(x_fois_u,x_fois_v)]
       end
  else []
;;


let couple_normalisant_cr plus zero moins mult un u v = 
  let (n,s) = (finish_symmetrization plus u) in
  (theta_cr plus zero moins mult un u v,
   psi_cr plus zero moins mult un n s v)
;;

let couple_normalisant_sym_cr plus zero moins mult un u v = 
  (theta_sym_cr plus zero moins mult un u v,
   psi_sym_cr plus zero moins mult un u v)
;;






