(***************************************************************************

Calcul du couple_normalisant pour FP(k,+,0,-,*,1) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: fp.ml,v 1.2 1998/04/28 13:36:50 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Author(s):             Claude March\'e

File name:        fp.ml
Created on:              15 jul 93
Last modified on:  $Date: 1998/04/28 13:36:50 $
              by:  $Author: marche $

***************************************************************************)

open Symbols
open Terms
open Acu
open Ac0
open Br
open Symmetrization
open Ac_critical_pairs
open Critical_equations



(*===============================

(\Theta_{FP_k},\Psi_{FP_k})

================================*)

let sigma_5 caracteristique plus zero u v = 
  Unification.select_ac_only_unification();
  let x = new_var (variables_du_terme u) in
  let var_x = VAR x in
  let sigma = 
  make_critical_equations ([],(
     paires_critiques_ac_strictes u v 
            (TERM(plus,duplique caracteristique var_x)) (TERM(zero,[])))) in
  Unification.select_ac_complete_unification();
  sigma

let sigma_sym_5 caracteristique plus zero u v = 
  Unification.select_ac_only_unification();
  let x = new_var ((fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (variables_du_terme u) (variables_du_terme u)) in
  let var_x = VAR x in
  let zero' = TERM(zero,[])
  and c_fois_x = TERM(plus,duplique caracteristique var_x) in
  let sigma = 
  make_critical_equations ([],(
     paires_critiques_ac_strictes u v c_fois_x zero')) in
  Unification.select_ac_complete_unification();
  sigma
  
let inverse_dans_un_corps_fini p n = 
  let inv = ref 1 in
  for i=1 to (p-2) do
  inv := (!inv * n) mod p
  done;
  !inv

let theta_fp caracteristique plus zero moins mult un u v =
  let (n,s) = (finish_symmetrization plus u) in
  let inv_n = inverse_dans_un_corps_fini caracteristique n in
  let inv_n_v = if (try (top_symbol_id v) = plus
                    with Invalid_argument _ -> false)
		then let l = liste_des_sous_termes v in
		     TERM(plus,(fun f->List.fold_left (fun l x->l@(f x)) []) (duplique inv_n) l)
		else TERM(plus,duplique inv_n v) in

    (theta_acu plus zero s inv_n_v)
  @ (theta_acu mult un s inv_n_v)
  @ (theta_ac0 mult zero s inv_n_v)
  @ (sigma_4 plus mult s inv_n_v)
  @ (sigma_5 caracteristique plus zero s inv_n_v)


let theta_sym_fp caracteristique plus zero moins mult un u v =
  let (n,s) = (finish_symmetrization plus u) in
  let inv_n = inverse_dans_un_corps_fini caracteristique n in
  let inv_n_v = if (try (top_symbol_id v) = plus
                    with Invalid_argument _ -> false)
		then let l = liste_des_sous_termes v in
		     TERM(plus,(fun f->List.fold_left (fun l x->l@(f x)) []) (duplique inv_n) l)
		else TERM(plus,duplique inv_n v) 
  and (m,t) = (finish_symmetrization plus v) in
  let inv_m = inverse_dans_un_corps_fini caracteristique m in
  let inv_m_u = if (try (top_symbol_id u) = plus
                    with Invalid_argument _ -> false)
		then let l' = liste_des_sous_termes u in
		     TERM(plus,(fun f->List.fold_left (fun l x->l@(f x)) []) (duplique inv_m) l')
		else TERM(plus,duplique inv_m u) in
    (theta_sym_acu plus zero u v)
  @ (theta_sym_acu mult un u v)
  @ (theta_sym_ac0 mult zero u v)
  @ (sigma_sym_4 plus mult u v)
  @ (sigma_sym_5 caracteristique plus zero s inv_n_v)
  @ (sigma_sym_5 caracteristique plus zero t inv_m_u)

(*======


======*)

let couple_normalisant_fp  caracteristique plus zero moins mult un u v = 
  (theta_fp caracteristique plus zero moins mult un u v,[])


let couple_normalisant_sym_fp  caracteristique plus zero moins mult un u v = 
  (theta_sym_fp caracteristique plus zero moins mult un u v,[])


