(***************************************************************************

Calcul du couple_normalisant pour G(.,e,I) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: g.ml,v 1.2 1998/04/28 13:36:51 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Created on:             03 nov 93

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/g.ml,v $
Revision:         $Revision: 1.2 $
Last modified on: $Date: 1998/04/28 13:36:51 $

***************************************************************************)

open Symbols
open Terms
open Equations
open Norm_theory
open A
open Au
open Ac_critical_pairs
open Critical_equations



(*===============================

(\Theta_{G},\Psi_{G})

================================*)

let sigma_1 mult m k u v =
  Unification.select_ac_only_unification();
  let (u1,v1)= if (top_symbol_id u)=mult
                 then let x=(new_var (variables_du_terme u)) in
                      (ajoute_variable_a_droite mult x u,
                       ajoute_variable_a_droite mult x v)
                 else (u,v) in
  let r = (make_basic_rule (u1,v1)) in
  let sigma = 
    (make_critical_equations 
        (paires_critiques_ac_etendues r (inverse_a_droite mult m k)))
    @ (make_critical_equations 
        (paires_critiques_ac_etendues r (inverse_a_gauche mult m k))) in
  Unification.select_ac_complete_unification();
  sigma
  
let sigma_sym_1 mult m k u v =
  Unification.select_ac_only_unification();
  let (u1,v1)= if (top_symbol_id u)=mult
                 then let x=new_var ((fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (variables_du_terme u)
                                           (variables_du_terme v)) in
                      (ajoute_variable_a_droite mult x u,
                       ajoute_variable_a_droite mult x v)
                 else (u,v) in
  let r = (make_basic_rule (u1,v1)) 
  and r' = (make_basic_rule (v1,u1))
  and inv_a_droite = inverse_a_droite mult m k
  and inv_a_gauche = inverse_a_gauche mult m k in
  let sigma = 
  (make_critical_equations 
      (paires_critiques_ac_etendues r inv_a_droite))
  @ (make_critical_equations 
      (paires_critiques_ac_etendues r inv_a_gauche))
  @ (make_critical_equations 
      (paires_critiques_ac_etendues r' inv_a_droite))
  @ (make_critical_equations 
      (paires_critiques_ac_etendues r' inv_a_gauche)) in
  Unification.select_ac_complete_unification();
  sigma
  
let theta_g mult m k u v =
    (theta_au mult m u v)
  @ (sigma_1 mult m k u v)


let theta_sym_g mult m k u v =
    (theta_sym_au mult m u v)
  @ (sigma_sym_1 mult m k u v)

let couple_normalisant_g n m k u v = 
 (theta_g n m k u v,psi_a n u v)


let couple_normalisant_sym_g n m k u v = 
 (theta_sym_g n m k u v,psi_sym_a n u v)


