(***************************************************************************

Calcul du couple_normalisant pour Int(k,+,0,-,*,1) : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: int_theory.ml,v 1.2 1998/04/28 13:36:52 marche Exp $

***************************************************************************)

open Acu;;
open Symmetrization;;
open Symbols;;
open Terms;;

(*
open Equations;;
open Orderings;;
*)

(*===============================

(\Theta_{Int},\Psi_{Int})

Int(un_z coef plus zero moins mult un)

================================*)

(*
let sigma_1 plus zero moins u v =
   paires_critiques_ac_larges u v 
        (TERM(plus,[TERM(VAR,0,[]);
                           TERM(moins,[TERM(VAR,0,[])])])) 
        (TERM(zero,[]))
 @ paires_critiques_ac_larges u v 
        (TERM(plus,[TERM(VAR,0,[]);
                           TERM(moins,[TERM(VAR,0,[])]);
                           TERM(VAR,1,[])])) 
        (TERM(VAR,1,[]))
;;
*)
   
let theta_int plus_z coef plus zero moins mult un u v = []
;;

let theta_sym_int plus_z coef plus zero moins mult un u v = []
;;


(*======


(add_coef_var coef  plus zero moins mult un s t) :

si s est de la forme coef(s')*s'' alors 

retourne (coef(x+s')*s'',coef(x)*s''+t

sinon exception Not_found

======*)


let add_coef_var plus_z coef plus zero moins mult un left right =
  
  let new_x = VAR(new_var (variables_du_terme left)) 
  in
  let rec cherche_coef acc = function
      [] -> raise Not_found
    | t::l -> 
        match t with
        
           TERM(f,m) ->
             if f=coef
             then (
                   TERM(mult,
                      (TERM(coef,[TERM(plus_z,new_x::m)]))::acc@l)
                   ,
                   TERM(plus,
                      [TERM(mult,
                          (TERM(coef,[new_x]))::
                           acc@l);
                       right]))
             else cherche_coef (t::acc) l
          | _ ->  cherche_coef (t::acc) l

  in
  match left with
  TERM(f,l) ->
    if f=mult
    then cherche_coef [] l
    else raise Not_found
| _ -> raise Not_found
;;
 






let psi_int plus_z coef plus zero moins mult un n s t = 

    if n = 1 
      then 
       try 
         let u = add_coef_var plus_z coef plus zero moins mult un s t
         in [(s,t);u]
  with Not_found -> []

      else 
   let x = new_var (variables_du_terme s) in
           let var_x = VAR x in
           let x_fois_s = (if (try (top_symbol_id s) = mult 
      	                       with Invalid_argument _ -> false)
                           then let l = (liste_des_sous_termes s) in
                                TERM(mult,var_x::l)
			   else TERM(mult,[var_x;s]))
	   and x_fois_t = add_left_var mult x t in
           [(TERM(plus,duplique n s),t);
            (TERM(plus,duplique n x_fois_s),x_fois_t);
            (TERM(moins,[s]),TERM(plus,TERM(moins,[t])::(duplique (n-1) s)));
            (TERM(moins,[x_fois_s]),TERM(plus,TERM(moins,[x_fois_t])::
                                              (duplique (n-1) x_fois_s)))]
;;

let psi_sym_int coef plus zero moins mult un u v = 
  if (try (top_symbol_id u) = plus
      with Invalid_argument _ -> false) or
     (try (top_symbol_id v) = plus
      with Invalid_argument _ -> false)
  then begin
       let x = new_var ((fun l1 l2->List.fold_right (fun e l->if List.mem e l2 then l else e::l)l1 l2) (variables_du_terme u) (variables_du_terme v)) in
       let var_x = VAR x in
       let x_fois_u = (if (try (top_symbol_id u) = mult 
      	                   with Invalid_argument _ -> false)
                       then let l = (liste_des_sous_termes u) in
                            TERM(mult,var_x::l)
	               else TERM(mult,[var_x;u]))
       and x_fois_v = (if (try (top_symbol_id v) = mult 
                           with Invalid_argument _ -> false)
                       then let l' = (liste_des_sous_termes v) in
                            TERM(mult,var_x::l')
	               else TERM(mult,[var_x;v])) in
       [(u,v);(x_fois_u,x_fois_v)]
       end
  else []
;;

let couple_normalisant_int 
  (* ordre *) plus_z coef plus zero moins mult un u v =  
  let (n,s) = (finish_symmetrization plus u) in  
  let regles = psi_int plus_z coef plus zero moins mult un n s v
  and equations = theta_int plus_z coef plus zero moins mult un u v
  in 
  (equations, regles)
;;


let couple_normalisant_sym_int plus_z coef plus zero moins mult un u v =  

  let regles = psi_sym_int coef plus zero moins mult un u v
  and equations = theta_sym_int plus_z coef plus zero moins mult un u v
  in (equations, regles)
;;






