(***************************************************************************

Sym\'etrisation d'une equation : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: symmetrization.mli,v 1.6 2001/04/20 13:42:33 marche Exp $

***************************************************************************)

(*

Obsolete header:

File name:        symetrization.mli
Created on:              04 mai 93
Last modified by: $Author: marche $
Revision:         $Revision: 1.6 $
Last modified on: $Date: 2001/04/20 13:42:33 $

***************************************************************************)

open Terms;;
open Orderings;;
open Equations;;
open Equations_as_obj;;
open Symbols;;

module type SYMMETRIZATION = 
  sig

    type equation

    exception Non_orientable;;


(*

  symmetrize (>) (u=v) retourne une equation (l=r) telle que
  - l = max_> {u,v}
  - r = min_> {u,v}
  - si head(l) = + est dans une sur-theorie de AG(+,0,-)
    alors tous les sous-termes immediats de l non maximaux 
    sont passes dans r en changeant leur signe.
  - pour les booleens et les corps finis, d'autres operations en plus
     FP(p) :  ns=t  ==>  s = (n^-1 mod p) t
     BR    :  ns=t  ==>  ?


  ON SUPPOSE QUE l'ordre verifie la propriete :

   si s>t  alors s > -t   et s > t+...+t 

*)

val symmetrize :
  term ordering -> equation -> equation;;


val weak_symmetrize :
  term ordering -> equation -> equation;;

  end;;

module Standard_symmetrization :
  (SYMMETRIZATION with type equation = Equation1.t);;

module G_symmetrization :
  (SYMMETRIZATION with type equation = Equation_with_goal.t);;


(*

  finish_symmetrization (+) u retourne :
  - (1,u) si head(u)<>+
  - (n,v) si u = v+..+v  (n fois)
    ** ON SUPPOSE QUE u EST DE LA FORME nv **

*)

val finish_symmetrization : symbol_id -> term -> int * term 
;;

