(***************************************************************************

Calcul du couple_normalisant pour une theorie definie 
par l'utilisateur : corps

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user.ml,v 1.2 1998/04/28 13:36:56 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Author(s):              Evelyne Contejean

File name:        user.ml
Created on:       12 juillet 96
Last modified on: $Date: 1998/04/28 13:36:56 $
              by: $Author: marche $

***************************************************************************)

open Terms
open Substitution
open Equations
open Ac_critical_pairs
open Unification
open Args

open Symbols

(*===============================

(\Theta_{USER},\Psi_{USER}

================================*)


let theta_user r u v = 
    let r' = make_basic_rule (u,v) in
    let pc = paires_critiques_ac_etendues r r'
    and pc' = paires_critiques_ac_etendues r' r in
    (List.map (function (r1,r2,theta) -> 
              (instancie theta r1, instancie theta r2))
         (fst pc)) @ 
    (List.map (function (r1,l2,p,r2,theta) -> 
              (instancie theta r1, instancie theta (replace l2 r2 p)))
       	 (snd pc)) @ 
    (List.map (function (r1,l2,p,r2,theta) -> 
              (instancie theta r1, instancie theta (replace l2 r2 p)))
       	 (snd pc'))  

let couple_normalisant_user r_list u v = 
  if options_courantes.completion_close
    then [],[]
    else 
      begin
      save_unif_type ();
      select_ac_only_unification ();
      let res = ((fun f->List.fold_left (fun l x->l@(f x)) []) (function r -> theta_user r u v) r_list,[]) in
      restore_unif_type ();
      res
      end

let couple_normalisant_sym_user r_list u v = 
  if options_courantes.completion_close
    then [],[]
    else 
      begin
      save_unif_type ();
      select_ac_only_unification ();
      let theta1 = (fun f->List.fold_left (fun l x->l@(f x)) []) (function r -> theta_user r u v) r_list 
      and theta2 = (fun f->List.fold_left (fun l x->l@(f x)) []) (function r -> theta_user r v u) r_list in
      restore_unif_type ();
      (theta1 @ theta2,[])
      end







