(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: eval.ml,v 1.19 2001/04/20 13:42:33 marche Exp $

***************************************************************************)


open Format;;
open Abstract_syntax;;
open Values;;



let rec eval env = function
  | Apply(e1,e2) ->
      let v1 = eval env e1
      and v2 = eval env e2
      in
	begin
	  match v1 with
	      Fun_value(x,env,body) ->
		eval ((x,{value = v2})::env) body
		  
	    | Predef(nom,args) ->
		let (arity,func) = Predef.get_code nom
		in
		  if arity > succ (List.length args)
		  then Predef(nom,args @ [v2])
		  else func (args@[v2])
	    | _ -> raise (Eval_error "impossible application")
	end
  | Var(x) ->
      begin
	try 
	  let d=List.assoc x env
	  in d.value
	with Not_found ->
	  raise (Eval_error ("unknown identifier "^x))
      end
  | Integer(n) -> Int_value(n)
  | String(s) -> String_value(s)
  | Bool(b) -> Bool_value(b)
  | Fun(x,e) -> Fun_value(x,env,e)
  | If(e1,e2,e3) ->
      let c = eval env e1 in
	if c = Bool_value(true) 
	then eval env e2
	else eval env e3
  | Tuple(l) -> Prod_value(List.map (eval env) l)
  | Set(l) -> Set_value(List.map (eval env) l)
