(***************************************************************************

  This module provides a function for cleaning a solved problem, that is
  removing the equations giving the value of an existentially quantified 
  variable.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: eqe.ml,v 1.6 2002/07/11 13:26:28 pguillon Exp $

***************************************************************************)

open Variables
open Gen_terms
open Problems
open Controle

let existential_quantifiers_elimination pb =
  match pb.global_status with 
      Solved ->
	List.filter
	  (function (t,_) -> 
	     match t.Hcons.node with
	       | Var x -> VarSet.mem x pb.vars_for_eqe
	       | _ -> assert false) 
	  pb.solved_part
    | _ -> raise Not_appliable



