(***************************************************************************

  This module provides two versions (standard and lazy) of the function [mark] 
  which adds some constraints on a unification problem in order to solve the 
  clashes between the elementary unification theories.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: mark.mli,v 1.5 2002/07/05 12:52:08 contejea Exp $

***************************************************************************)

open Variables
open Theory
open Problems


val add_a_mark :
  var_id -> 'symbol mark -> 'symbol unif_elem_theory -> 'symbol problem 
    -> 'symbol problem

(* 

   [(mark pb)] applies the {\bf Mark} rule on the unification problem
   [pb] and returns
   \begin{itemize}
   \item either the exception [Not_appliable]
   \item either the exception [No_solution]
   \item or a list of marked unification problems.
   \end{itemize}

*)

val mark : 'symbol problem -> 'symbol problem list

val lazy_mark : 'symbol problem -> 'symbol problem Lazy_list.llist
