(***************************************************************************

  This module provides a function for solving an elementary
  unification problem modulo an associative and commutative
  symbol. This function should only be called on a problem which is
  quasi-solved, that is all the equations are of the form 
  [variable = term] and the {\bf Merge} rule can apply.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: merge_acu.mli,v 1.3 2002/07/01 12:01:36 contejea Exp $

***************************************************************************)

open Variables
open Gen_terms
open Theory
open Problems

val solve : 
  unif_kind -> 'symbol Signatures.signature -> 'symbol HashTerm.t -> 
    var_id VarSet.t -> 'symbol elem_pb -> 
      ('symbol term * 'symbol term) list list
