(***************************************************************************

Theory lexer

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: theory_lexer.mll,v 1.2 2001/04/20 13:42:38 marche Exp $

***************************************************************************)


{
  
  open Theory_parser
  open Theory_syntax
  open Signatures

  exception Invalid_char of string

  let ident s =
    try
      IDENT(!current_signature#symbol_of_string s)
    with 
	Not_found -> 
	  try
	    INT(int_of_string s)
	  with _ -> raise (Theory.Syntax_error ("undefined identifier "^s))
	
}

rule token = parse
    [' ''\t''\n'] 	{ token lexbuf }
  | ','            	{ COMMA }
  | ';'            	{ SEMICOLON }
  | '('            	{ OPENPAR }
  | ')'            	{ CLOSEPAR }
  | "ACU"               { KW_ACU }
  | "ACI"               { KW_ACI }
  | "AG"                { KW_AG }
  | "ACUN"              { KW_ACUN }
  | "BR"                { KW_BR }
  | ['a'-'z''A'-'Z''0'-'9']['a'-'z''A'-'Z''0'-'9''_''\'']*
  | ['^''+''.''&''*''-''/''!''?''@''~''#'] ('_'(['a'-'z''A'-'Z''0'-'9']+))* 
                        { ident(Lexing.lexeme lexbuf) }
  | _                   { raise (Invalid_char (Lexing.lexeme lexbuf)) }
  | eof			{ EOF }


