/***************************************************************************

parser for (equational) theory

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: theory_parser.mly,v 1.3 2002/07/12 13:23:31 pguillon Exp $

***************************************************************************/

%{
  
  open Theory
  open Theory_syntax
  open User_signatures

%}

%token <User_signatures.symbol_id> IDENT
%token <int> INT
%token KW_ACU KW_ACI KW_AG KW_ACUN KW_BR
%token COMMA SEMICOLON OPENPAR CLOSEPAR 
%token EOF

%start theory
%type <User_signatures.symbol_id Theory.TheorySet.t> theory

%%

theory:
    EOF                    
      { Theory.TheorySet.empty }
  | decl 
      { 
        Theory.TheorySet.add $1 (Theory.TheorySet.empty)
      }
  | decl SEMICOLON theory  
      { 
	Theory.TheorySet.add $1 $3 
      }
;

decl:
  acu { $1 }
| aci { $1 }
| ag { $1 }
| acun { $1 }
| br { $1 }
;

acu:
KW_ACU OPENPAR IDENT COMMA IDENT CLOSEPAR 
  { 
    Theory.theory_check !Theory_syntax.current_signature (ACU($3,$5))
  }
;

aci:
KW_ACI OPENPAR IDENT CLOSEPAR 
  { 
    Theory.theory_check !Theory_syntax.current_signature (ACI($3))
  }
;

ag:
KW_AG OPENPAR IDENT COMMA IDENT COMMA IDENT CLOSEPAR 
  { 
    Theory.theory_check !Theory_syntax.current_signature (AG($3,$5,$7))
  }
;

acun:
KW_ACUN OPENPAR IDENT COMMA IDENT COMMA INT CLOSEPAR 
  { 
    Theory.theory_check !Theory_syntax.current_signature (ACUN($3,$5,$7))
  }
;

br:
KW_BR OPENPAR IDENT COMMA IDENT COMMA IDENT COMMA IDENT CLOSEPAR 
  { 
    Theory.theory_check !Theory_syntax.current_signature (BR($3,$5,$7,$9))
  }
;
