(***************************************************************************

Unification modulo some predefined theories

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: unification.mli,v 1.16 2002/07/16 09:29:36 contejea Exp $

***************************************************************************)

open Variables
open Signatures
open Gen_terms
open Theory

(*

  [set_of_unifiers unif_k S E term1 term2] returns a complete set of unifiers
  of [term1] and [term2] modulo the equational theory [E], where [S]
  is the signature over which [term1] and [term2] are built. [E] may
  be any combination of some elementary theories among
  \begin{itemize}
  \item the free theory
  \item C 
  \item AC
  \item ACU
  \item ACI
  \item AG
  \item ACUN
  \item BR
  \end{itemize}
  provided that they are pairwise signature-disjoint.



*)

val verbose : int ref

val set_of_solutions : 
  unif_kind -> 'symbol #signature -> 'symbol HashTerm.t -> (*i Variables.user_variables -> i*)
    ('symbol -> 'symbol unif_elem_theory) -> 'symbol term -> 'symbol term ->
      (unit,'symbol term) VarMap.t list

val plain_set_of_solutions :
  'symbol #signature -> 'symbol HashTerm.t -> 'symbol TheorySet.t -> (*i user_variables -> i*)
    'symbol term -> 'symbol term -> 
      (unit, 'symbol term) VarMap.t list

val display_plain_set_of_solutions :
  'symbol #signature -> 'symbol HashTerm.t -> 'symbol TheorySet.t -> user_variables -> 
    'symbol term -> 'symbol term -> unit


val free_unification : 
  'symbol #signature -> 'symbol HashTerm.t -> (*i user_variables -> i*) 
    'symbol term -> 'symbol term ->
      (unit,'symbol term) Variables.VarMap.t;; 
  
val first_ac_solution : 
  'symbol #signature -> 'symbol HashTerm.t -> 
    ('symbol term * 'symbol term) list -> ('symbol term * 'symbol term) list

val has_an_ac_solution : 
  'symbol #signature -> 'symbol HashTerm.t -> 
    ('symbol term * 'symbol term) list -> bool

val free_solve_constraints : 
  'symbol #signature -> 'symbol HashTerm.t -> 
    ('symbol term * 'symbol term) list -> ('symbol term * 'symbol term) list
