(***************************************************************************

This module defines the strings (or words) over a string signature

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: local_confluence.ml,v 1.4 2002/04/25 10:24:13 monate Exp $

***************************************************************************)

    
exception Non_trivial_critical_pair
 
(* srs MUST be inter-reduced ! *)

let is_localy_confluent srs = 
  let compiled_srs = String_rewriting.compile_srs srs in
   let rec all_critical_pairs rule = 
    List.iter 
      (function r -> 
	 let crit_list = String_unification.superpose rule r in
	   List.iter 
	     (function l',r' -> 
		let l'' = String_rewriting.compiled_normalize compiled_srs l'
		and r'' = String_rewriting.compiled_normalize compiled_srs r' 
		in
		if l'' <> r''
		then raise Non_trivial_critical_pair ) 
	     crit_list
      ) srs
  in
    try
      List.iter (function r -> all_critical_pairs r) srs;
      true
    with 
	Non_trivial_critical_pair -> false
	
