(***************************************************************************

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: parameterized_signatures_lexer.mll,v 1.7 2002/03/29 16:38:32 marche Exp $

***************************************************************************)


{

  open Parameterized_signatures_parser 
  open Parameterized_signatures_syntax
  let current_formula = Buffer.create 17

}

rule token = parse
    [' ''\t''\n''\r'] 	{ token lexbuf }
  | "(*"                { comment lexbuf; token lexbuf }
  | ';'            	{ SEMICOLON }
  | '|'                 { PIPE }
  | '^'                 { POWER }
  | "fp"                { FP }
  | '('                 { LPAR }
  | ')'                 { RPAR }
  | "->"                { ARROW }
  | '{'                 { Buffer.clear current_formula;
			  FORMULA(formula lexbuf) }
  | '}'                 {  raise (Syntax_error "unbalanced symbol \"}\"")}
  | ['a'-'z''A'-'Z']['a'-'z''A'-'Z''0'-'9''_''\'''@''~']*
                        { IDENT(Lexing.lexeme lexbuf) }
  | _                   { raise (Syntax_error ("invalid char '" ^ (Lexing.lexeme lexbuf) ^ "'")) }
  | eof			{ EOF }

and comment = parse
    "*)"                { () }
  | "(*"                { comment lexbuf; comment lexbuf }
  | _                   { comment lexbuf }
  | eof                 { raise (Syntax_error "unterminated comment") }

and formula = parse
  | "}"                 { Buffer.contents current_formula }
  | _                   { Buffer.add_string 
			    current_formula (Lexing.lexeme lexbuf) ; 
			  formula lexbuf }
  | eof                 {  raise (Syntax_error "formulae must end with }") }
