#load "nums.cma";;

#directory "../compat";;
#load "num_utils.cmo";;
#load "inttagset.cmo";;
#load "inttagmap.cmo";;
#load "balanced_trees.cmo";;
#load "ordered_sets.cmo";;
#load "listutils.cmo";;
#load "int_utils.cmo";;

#directory "../integer_solver";;
#load "abstract_constraint.cmo";;
#load "poly_parser.cmo";;
#load "poly_lexer.cmo";;
#load "poly_syntax.cmo";;
#load "presburger.cmo";;

#directory "../words";;
#load "parameterized_words.cmo";;
#load "parameterized_word_syntax.cmo";;
#load "parameterized_signatures_parser.cmo";;
#load "parameterized_signatures_syntax.cmo";;
#load "parameterized_signatures_lexer.cmo";;
#load "user_parameterized_words.cmo";;
#load "user_parameterized_signatures.cmo";;
#load "parameterized_rewriting_syntax.cmo";;
#load "user_parameterized_rewriting.cmo";;
#load "parameterized_similitude.cmo";;
#load "parameterized_rewriting.cmo";;

open User_parameterized_signatures
open User_parameterized_words;;

#use "parameterized_similitude.ml";;


let n = User_parameterized_signatures.parameters_from_string "n";;

let s = User_parameterized_signatures.from_string n "a | {n>=1}" ;;


let u = from_string s " (a a)^{n}  | {n>= 1}" ;;

let v =  from_string s " a^{n+n}  | {n>= 1}" ;;

(*lfact ([{a = "a"; index = []}],[], Comp (Var "n", ">=", Cte Num_utils.one));;

lfact ([{a = "a"; index = []}],
       [{base = [{a = "a"; index = []}];
         operator = No}],
       Comp (Var "n", ">=", Cte Num_utils.one));;

lfact ([{a = "a"; index = []}],
       [{base = [{a = "a"; index = []};{a = "a"; index = []}];
         operator = No}],
       Comp (Var "n", ">=", Cte Num_utils.one));;

lfact ([{a = "a"; index = []}],
       [{base = [{a = "a"; index = []};{a = "a"; index = []}];
         operator = Power (Var "n") }],
       Comp (Var "n", ">=", Cte Num_utils.one));;

let f = neg (isprefix ([{a = "a"; index = []}],
       [{base = [{a = "a"; index = []};{a = "a"; index = []}];
         operator = Power (Var "n") }],
       Comp ( Cte Num_utils.zero , "=", Cte Num_utils.one)))
;;

let f = C.from_abstract_formula f ;;

let _ = C.is_valid f;; 
*)

let f = compute_similitude u v;;


let u = from_string s " a^{n}  | {n>= 1}" ;;

let rew = User_parameterized_rewriting.from_string s  "a^{n} -> | {n>=1};";;

let _ = Parameterized_rewriting.is_reducible 
	    User_parameterized_words.pretty_print 	      
	    s
	    rew
	    u;;
