open Format

let do_parse s = 
    try
    let b = Lexing.from_string s
    in
	(Parameterized_signatures_parser.rules_eof 
	   Parameterized_signatures_lexer.token b)
  with
      Parsing.Parse_error -> 
	raise (Parameterized_signatures_syntax.Syntax_error "remember to enclose expr. and constr. with {}")
    | Failure "lexing: empty token" -> 
	raise (Parameterized_signatures_syntax.Syntax_error 
		  "invalid character")
    | Poly_syntax.Syntax_error s -> 
	raise (Parameterized_signatures_syntax.Syntax_error s)
    | Parameterized_signatures_syntax.Syntax_error s-> 
	raise (Parameterized_signatures_syntax.Syntax_error s)

let from_string (s:Parameterized_signatures.parameterized_signature) c = 
  Parameterized_rewriting.from_abstract_srs s (do_parse c)



