(***************************************************************************

This module defines the class of parameterized signatures for parameterized 
words

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user_parameterized_signatures.mli,v 1.7 2002/04/12 15:33:58 marche Exp $

***************************************************************************)
		 
(*

  This module defines the class of parameterized signatures for parameterized 
  words

  \subsection{The user parameterized signature type}

*)

class type user_parameterized_signature =
  object
    inherit Parameterized_signatures.parameterized_signature
  end


(* Instantiates a parameterized signature into a word signature.*)

val instantiate_signature : 
  user_parameterized_signature -> 
    (string -> Numbers.t)  -> 
      String_signatures.user_word_signature




(* [from_string p s] returns the signature with parameters [p] and
   definition [s]. *) 

val from_string : 
  Parameterized_signatures.parameter_c -> 
    string -> 
      user_parameterized_signature

val parameters_from_string :
  string -> 
    Parameterized_signatures.parameter_c
  
