(***************************************************************************

Terms defined on user signatures

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user_words.ml,v 1.3 2000/05/22 13:07:17 marche Exp $

***************************************************************************)



let do_parse parse_function sigma s =
  try
    Word_syntax.current_signature := sigma;
    let b = Lexing.from_string s
    in
      parse_function Word_lexer.token b
  with
      Parsing.Parse_error -> 
	raise (Word_syntax.Syntax_error "")
    | Failure "lexing: empty token" -> 
	raise (Word_syntax.Syntax_error "invalid character")
;;

let word_of_string = do_parse Word_parser.word_eof;;

let srs_of_string = do_parse Word_parser.rule_set_eof;;

let word_prec_of_string = do_parse Word_parser.precedence_eof;;

