(***************************************************************************

Words and string rewriting systems defined on user signatures

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user_words.mli,v 1.3 2000/05/23 07:40:18 marche Exp $

***************************************************************************)


(*

  [(word_of_string sigma s)] returns the term over the signature
  [sigma], read in the string [s]

*)

val word_of_string : 
  String_signatures.user_word_signature -> string 
    -> String_signatures.symbol_id Words.word
;;

(*

  [(srs_of_string sigma s)] returns the string rewriting system over
  the signature [sigma], read in the string [s]

*)

val srs_of_string : 
  String_signatures.user_word_signature -> string 
    -> String_signatures.symbol_id String_rewriting.srs
;;

(*

  [(word_prec_of_string sigma s)] returns the precedence over
  the signature [sigma], read in the string [s]

*)

val word_prec_of_string : 
  String_signatures.user_word_signature -> string 
    -> String_signatures.symbol_id Orderings_generalities.ordering
;;


