(***************************************************************************

Word lexer

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: word_lexer.mll,v 1.7 2001/04/20 13:42:41 marche Exp $

***************************************************************************)


{

  open Word_parser
  open Word_syntax
  open String_signatures

  let ident s =
    try
      IDENT(!current_signature#symbol_of_string s) 
    with Not_found ->
      try
	INT(int_of_string s)
      with
	  _ -> 
	    raise (Syntax_error ("Undeclared symbol '" ^ s ^ "'"))
  ;;
}

rule token = parse
    [' ''\t''\n'] 	{ token lexbuf }
  | "(*"                { comment lexbuf; token lexbuf }
  | ';'            	{ SEMICOLON }
  | ','            	{ COMMA }
  | "->"            	{ ARROW }
  | '^'                 { POWER }
  | '('                 { LPAR }
  | ')'                 { RPAR }
  | '<'                 { LT }
  | '>'                 { GT }
  | '='                 { EQ }
  | ['a'-'z''A'-'Z''0'-'9']['a'-'z''A'-'Z''0'-'9''_''\'']*
  | ['+''.''&''*''-''/''!''?''@''~''#'] ('_'(['a'-'z''A'-'Z''0'-'9']+))* 
                        { ident(Lexing.lexeme lexbuf) }
  | _                   { raise (Syntax_error ("invalid char '" ^ (Lexing.lexeme lexbuf) ^ "'")) }
  | eof			{ EOF }

and comment = parse
    "*)"                { () }
  | "(*"                { comment lexbuf; comment lexbuf }
  | _                   { comment lexbuf }
  | eof                 { raise (Syntax_error "unterminated comment") }

