(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: words_ordered_chaining.ml,v 1.2 2001/04/20 13:42:41 marche Exp $

***************************************************************************)

(* An implementation of string ordered chaining based on Bachmair and Ganzinger *)

open String_rewriting

type 'a literal = Neg of 'a rewrite_rule  | Pos of 'a rewrite_rule

let subst_clause_apply_rewrite_rule clause sigma  = 
  match clause with 
      Pos(x) -> Pos (Substitution.apply_rewrite_rule x sigma)
    | Neg(x) -> Neg (Substitution.apply_rewrite_rule x sigma)

module ClauseOrd =
struct 
    type 'a t = 'a clause 
    let compare = compare
  end

module ClauseSet = Ordered_sets.MakePoly (ClauseOrd)


exception Did_not_apply
 
let is_maximal_among_clause_set clause_set clause = 
  true


(* TODO: consider AC rules *)

let ordered_chaining order other_clauses c1 c2 = match (c1,c2) with
    (Pos r1,Pos r2) -> 
      let sigma = Unification.unification_no_occur_check r1.rhs r2.lhs in 
      let maximality_condition = true in   
	if maximality_condition then
	  begin 
	    assert (r1.ext=None && r2.ext=None); (* Ok if not AC *)
	    ClauseSet.add 
	      (Pos {r1 with 
		      lhs = Substitution.apply_term r1.lhs sigma;
		     rhs = Substitution.apply_term r2.rhs sigma})  
	      (ClauseSet.fold (fun t u -> 
				 ClauseSet.add 
				   (subst_clause_apply_rewrite_rule t sigma) 
				   u) 
		other_clauses ClauseSet.empty)
	  end
	else
	  raise Did_not_apply
  | _ -> raise Did_not_apply

	  
(* The main function and only one exported *)
let f 
  rewrite_rules_list 
  t1 t2 = 
  let my_order = compare  in  true

