(***************************************************************************

Main program for the cime-interface-to-latex utility

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: cime-interface-to-latex.ml,v 1.4 1998/05/22 14:52:53 marche Exp $

***************************************************************************)


let rec latexize nom = 
  if nom = ""
  then ""
  else
    let c = String.sub nom 0 1
    and r = String.sub nom 1 (pred (String.length nom))
    in
      if c = "_"
      then "\\_"^(latexize r)
      else c^(latexize r)
;;

  

let traiter_fichier nom_fichier =
(**)
  print_string "% this file is automatically generated. DO NOT MODIFY.\n";
  print_string "\\section{Module \\texttt{";
  print_string (String.capitalize (latexize nom_fichier));
  print_string "}}\n\n";
(**)
  let chan = open_in (nom_fichier ^ ".mli")
  in
  let buf = Lexing.from_channel chan
  in 
  Interface_lexer.entry buf;
  close_in chan
;;
  
let usage = "Usage: cime-interface-to-latex <file>"

let _ =
  Arg.parse [
    ] traiter_fichier usage;
  exit 0
