(***************************************************************************

CAMLLEX file for scanning source headers and putting them into a
common format

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: cime_header.mll,v 1.2 1998/04/28 13:33:09 marche Exp $

***************************************************************************)

{

  let new_banner_string = 
    "CiME Project - Dmons research team - LRI - Universit Paris XI\n\n"

  let begin_comment = 
    "(***************************************************************************\n\n"

  let end_comment = 
    "***************************************************************************)\n\n"

  let description_string = 
    ref 
      "(This sentence has been added automatically,\nit should be replaced by a description of the module)\n\n"

  (* "$"^"Id$" is to avoid rcs replacing this Id string when commit ! *)
  let id_string = ref ("$"^"Id$\n\n")
  
}

rule header = parse
    "(*" ['*']* "\n\n" { text lexbuf }
  | [' ''\t']+'\n'     { header lexbuf }
  | _                  { print_string begin_comment;
			 print_string !description_string;
			 print_string new_banner_string;
			 print_string !id_string;
			 print_string end_comment;
			 print_string (Lexing.lexeme lexbuf); 
			 finish lexbuf }
  | eof                { () }

and text = parse
    ([^'\n']+'\n')* '\n' { description_string := Lexing.lexeme lexbuf; 
			   banner lexbuf }
  | [' ''\t']+'\n'       { text lexbuf }
  | _                    { print_string begin_comment;
			   print_string !description_string;
			   print_string new_banner_string;
			   print_string !id_string;
			   print_string end_comment;			   
			   print_string "(*\n\n";
			   print_string "Obsolete header:\n\n";
			   print_string (Lexing.lexeme lexbuf); 
			   finish lexbuf }
  | eof                  { print_string begin_comment; }

and banner = parse
    (* old banner string *)
    "CiME Project - Dmons research team - LRI - Universit Paris XI\n\n"
                          { id lexbuf }
  | "$Id" [^'$']* "$\n\n" { id_string := Lexing.lexeme lexbuf; 
			    sortie lexbuf }
  | _                  { print_string begin_comment;
			 print_string !description_string;
			 print_string new_banner_string;
			 print_string !id_string;
			 print_string end_comment;
			 print_string "(*\n\n";
			 print_string "Obsolete header:\n\n";
			 print_string (Lexing.lexeme lexbuf); 
			 finish lexbuf }
  | eof                { print_string begin_comment;
			 print_string !description_string }

and id = parse
    "$Id" [^'$']* "$\n\n" { id_string := Lexing.lexeme lexbuf; 
			    sortie lexbuf }
  | _                     { print_string begin_comment;
			    print_string !description_string;
			    print_string new_banner_string;
			    print_string !id_string;
			    print_string end_comment;
			    print_string "(*\n\n";
			    print_string "Obsolete header:\n\n";
			    print_string (Lexing.lexeme lexbuf); 
			    finish lexbuf }
  | eof                { print_string begin_comment;
			 print_string !description_string;
			 print_string new_banner_string }

and sortie = parse
    ['*']* "*)\n\n"    { print_string begin_comment;
			 print_string !description_string;
			 print_string new_banner_string;
			 print_string !id_string;
			 print_string end_comment;
			 finish lexbuf }
  | _                  { print_string begin_comment;
			 print_string !description_string;
			 print_string new_banner_string;
			 print_string !id_string;
			 print_string end_comment;
			 print_string "(*\n\n";
			 print_string "Obsolete header:\n\n";
			 print_string (Lexing.lexeme lexbuf); 
			 finish lexbuf }
  | eof                { print_string begin_comment;
			 print_string !description_string;
			 print_string new_banner_string;
			 print_string !id_string }

and finish = parse
    [^'\n']*'\n'       { print_string (Lexing.lexeme lexbuf); finish lexbuf }
  | _                  { print_string (Lexing.lexeme lexbuf); finish lexbuf }
  | eof                { () }

