
(*

  This program has to  be run in the directory 
  "cime/examples/tptp".
*)

let tptp_dir = "/users/demons/demons.old/TPTP/TPTP-v2.4.1/";;

let tptp2cime_dir = "~/cime/utils/tptp2cime/";;

let all_tptp_directories () =
  let current_dir = Sys.getenv "PWD" in
  let tmp = Filename.temp_file "tptp" "dir" in
  let _ = Sys.chdir tptp_dir in
  let _ = Sys.chdir "Problems" in
  let _ = Sys.command ("ls > "^tmp) in
  let c = open_in tmp in
  let all_tptp_dirs = ref ([] : string list) in
    begin
      try 
	while true do
	  all_tptp_dirs := (input_line c) :: !all_tptp_dirs
	done 
      with End_of_file -> ()
    end;
    close_in c;
    Sys.remove tmp;
    Sys.chdir current_dir;
    !all_tptp_dirs;;

let all_tptp_files_of_directory dir =
  let current_dir = Sys.getenv "PWD" in
  let tmp = Filename.temp_file "tptp" "file" in
  let _ = Sys.chdir tptp_dir in
  let _ = Sys.chdir "Problems" in
  let _ = Sys.command ("ls " ^ dir ^ "> "^tmp) in
  let c = open_in tmp in
  let all_tptp_files = ref ([] : string list) in
    begin
      try 
	while true do
	  let f_name = (input_line c) in
	    if not (Filename.check_suffix f_name "rm")
	    then 
	      all_tptp_files := 
	      (Filename.chop_extension f_name) :: !all_tptp_files
	done 
      with End_of_file -> ()
    end;
    close_in c;
    Sys.remove tmp;
    Sys.chdir current_dir;
    !all_tptp_files;;
  
let build_all () =
  List.iter 
    (fun dir -> 
       Format.print_string ("Processing repertory " ^ dir);
       Format.print_newline();
       begin
	 if not (Sys.file_exists dir)
	 then let _ = Sys.command ("mkdir "^dir) in ()
       end;
       List.iter 
	 (fun file -> 
	    let dir_file = Filename.concat dir file in
	    let dir_file_cim2 = dir_file ^ ".cim2" in
	    let _ = Format.print_string ("Processing file " ^ dir_file) in
	    let _ = 
	      if Sys.file_exists dir_file_cim2
	      then Sys.remove dir_file_cim2 in
	    let exit_code =
	      try
		Sys.command (
		  tptp2cime_dir ^ "tptp2cime -tptp-dir " ^ tptp_dir ^
		  " Problems/" ^ dir_file ^ " > /dev/null") 
	      with _ -> 1000 in
		if exit_code = 0
		then 
		  begin
		    let _ = 
		      Sys.command (
			tptp2cime_dir ^ "tptp2cime -tptp-dir " ^ tptp_dir ^
			" Problems/" ^ dir_file ^ " > " ^ dir_file_cim2) 
		    in 
		      Format.print_string " : OK";
		      Format.print_newline()
		  end
		else
		  begin
		    Format.print_string " : not an equational problem";
		    Format.print_newline()
		  end)
	 (all_tptp_files_of_directory dir))
    (all_tptp_directories ())
;;
    
let _ = build_all();;
