(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: cime_format.ml,v 1.13 2002/07/19 15:52:19 contejea Exp $

***************************************************************************)


open Format;;
open Sort;;
open Clauses;;
open Symbols;;
open Terms;;
open Pretty_printing;;
open Norm_theory;;
open Messages;;

exception Unknown_axiom

let retrouve_axiome_connu = function
    (Term(f1,[(Var x1);(Var y1)]),
     Term(f2,[(Var x2);(Var y2)])) ->
      if (f1=f2) & (x1=y2) & (y1=x2) & (x1<>y1)
      then Commutativity f1
      else raise Unknown_axiom
	
  | (Term(f1,[Term(f2,[(Var x1);(Var y1)]);(Var z1)]),
     Term(f3,[(Var x2);Term(f4,[(Var y2);(Var z2)])])) 
  | (Term(f3,[(Var x2);Term(f4,[(Var y2);(Var z2)])]),
     Term(f1,[Term(f2,[(Var x1);(Var y1)]);(Var z1)])) ->
      if (f1=f2) & (f2=f3) & (f3=f4) & 
	(x1=x2) & (y1=y2) & (z1=z2) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Associativity f1
      else raise Unknown_axiom
	
(*
  | (Term(f1,[Term(f2,[]);(Var x1)]),(Var x2)) ->
      if (x1=x2)
      then Left_unit (f1,f2)
      else raise Unknown_axiom
	
  | ((Var x2),Term(f1,[Term(f2,[]);(Var x1)])) ->
      if (x1=x2)
      then Left_unit (f1,f2)
      else raise Unknown_axiom
	
  | (Term(f1,[(Var x1);Term(f2,[])]),(Var x2)) ->
      if (x1=x2)
      then Right_unit (f1,f2)
      else raise Unknown_axiom
	
  | ((Var x2),Term(f1,[(Var x1);Term(f2,[])])) ->
      if (x1=x2)
      then Right_unit (f1,f2)
      else raise Unknown_axiom
	
  | (Term(f1,[(Var x1);(Var y1)]),(Var x2)) ->
      if (x1=y1) & (x1=x2)
      then Idempotency f1
      else raise Unknown_axiom

  | ((Var x2),Term(f1,[(Var x1);(Var y1)])) ->
      if (x1=y1) & (x1=x2)
      then Idempotency f1
      else raise Unknown_axiom
	
  | (Term(f1,(Var x1)::(Var x2)::l),Term(f2,[])) ->
      if (x1=x2) & 
	(List.for_all (function Var y -> (x1=y) | _ -> false) l)
      then Nilpotency (f1,f2,succ(succ(List.length l)))
      else raise Unknown_axiom
	
  | (Term(f2,[]),Term(f1,(Var x1)::(Var x2)::l)) ->
      if (x1=x2) & (List.for_all (function Var y -> (x1=y) | _ -> false) l)
      then Nilpotency (f1,f2,succ(succ(List.length l)))
      else raise Unknown_axiom
	
  | (Term(f1,[Term(f2,[(Var x1)]);(Var x2)]),Term(f3,[])) ->
      if (x1=x2)
      then Left_inverse(f1,f3,f2)
      else raise Unknown_axiom
	
  | (Term(f3,[]),Term(f1,[Term(f2,[(Var x1)]);(Var x2)])) ->
      if (x1=x2)
      then Left_inverse(f1,f3,f2)
      else raise Unknown_axiom
	
  | (Term(f1,[(Var x2);Term(f2,[(Var x1)])]),Term(f3,[])) ->
      if (x1=x2)
      then Right_inverse(f1,f3,f2)
      else raise Unknown_axiom

  | (Term(f3,[]),Term(f1,[(Var x2);Term(f2,[(Var x1)])])) ->
      if (x1=x2)
      then Right_inverse(f1,f3,f2)
      else raise Unknown_axiom

  | (Term(f1,[(Var x1);Term(g1,[(Var y1);(Var z1)])]),
     Term(g2,[Term(f2,[(Var x2);(Var y2)]);Term(f3,[(Var x3);(Var z3)])])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Left_distributivity (g1,f1)
      else raise Unknown_axiom

  | (Term(g2,[Term(f2,[(Var x2);(Var y2)]);Term(f3,[(Var x3);(Var z3)])]),
     Term(f1,[(Var x1);Term(g1,[(Var y1);(Var z1)])])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Left_distributivity (g1,f1)
      else raise Unknown_axiom

  | (Term(f1,[Term(g1,[(Var y1);(Var z1)]);(Var x1)]),
     Term(g2,[Term(f2,[(Var y2);(Var x2)]);Term(f3,[(Var z3);(Var x3)])])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Right_distributivity (g1,f1)
      else raise Unknown_axiom

  | (Term(g2,[Term(f2,[(Var y2);(Var x2)]);Term(f3,[(Var z3);(Var x3)])]),
     Term(f1,[Term(g1,[(Var y1);(Var z1)]);(Var x1)])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Right_distributivity (g1,f1)
      else raise Unknown_axiom
	*)
| _ -> raise Unknown_axiom
;;

let refabrique_equation = function
  Commutativity f -> 
    let x = first_var() 
    and y = next_var() in (Term(f,[x;y]),Term(f,[y;x]))

  | Associativity f -> 
      let x = first_var() 
      and y = next_var() 
      and z = next_var () in
	(Term(f,[Term(f,[x;y]);z]),Term(f,[x;Term(f,[y;z])]))
(*	  
  | Left_unit (f,u) -> 
      let x = first_var () in (Term(f,[Term(u,[]);x]),x)

  | Right_unit (f,u) -> 
      let x = first_var () in (Term(f,[x;Term(u,[])]),x)

  | Left_inverse (f,u,i) -> 
      let x = first_var () in (Term(f,[Term(i,[x]);x]),Term(u,[]))

  | Right_inverse (f,u,i) -> 
      let x = first_var () in (Term(f,[x;Term(i,[x])]),Term(u,[]))

  | Idempotency f -> 
      let x = first_var () in (Term(f,[x;x]),x)

  | Nilpotency (f,u,n) -> 
      let x = first_var () in
      let l = 
	let rec list_create = function 
	    m -> 
	      if m > 0 
	      then x::(list_create (pred m)) 
	      else [] 
	in 
	  list_create n
      in
        (Term(f,l),Term(u,[]))
*)
  | Left_distributivity (f,g) -> 
      let x = first_var () 
      and y = next_var ()
      and z = next_var () in
        (Term(g,[Term(f,[x;y]);z]),Term(f,[Term(g,[x;z]);Term(g,[y;z])]))

  | Right_distributivity (f,g) -> 
      let x = first_var ()
      and y = next_var ()
      and z = next_var () in
        (Term(g,[x;Term(f,[y;z])]),Term(f,[Term(g,[x;y]);Term(g,[x;z])]))
;;

let axiom_to_int = function
    Commutativity _ -> 0
  | Associativity _ -> 1
(*
  | Left_unit _ -> 3
  | Right_unit _ -> 4
  | Left_inverse _ -> 5
  | Right_inverse _ -> 6
  | Idempotency _ -> 7
  | Nilpotency _ -> 8
*)
  | Left_distributivity _ -> 9
  | Right_distributivity _ -> 10
;;

let compare_axioms a1 a2 = 
  let n1 = axiom_to_int a1
  and n2 = axiom_to_int a2 in
  let diff = n1 - n2 in
    if (diff=0)
    then (compare a1 a2) <= 0
    else (diff <= 0)
;;


let sort_axioms la = Sort.list compare_axioms la
;;

let print_axiome_connu = function
    Commutativity f -> message ("C("^(string_of_symbol_id f)^")")
  | Associativity f -> message ("A("^(string_of_symbol_id f)^")")
(*
  | Left_unit (f1,f2) -> 
      message ("LU("^(string_of_symbol_id f1)^","^(string_of_symbol_id f2)^")")
  | Right_unit (f1,f2) -> 
      message ("RU("^(string_of_symbol_id f1)^","^(string_of_symbol_id f2)^")")
  | Idempotency f -> message ("Id("^(string_of_symbol_id f)^")")
  | Nilpotency (f1,f2,n) -> 
      message ("Nil("^(string_of_symbol_id f1)^","^(string_of_symbol_id f2)^","^(string_of_int n)^")")
  | Left_inverse (f1,f2,f3) -> 
      message ("LInv("^(string_of_symbol_id f1)^","^(string_of_symbol_id f2)^","^(string_of_symbol_id f3)^")")
  | Right_inverse (f1,f2,f3) -> 
      message ("RInv("^(string_of_symbol_id f1)^","^(string_of_symbol_id f2)^","^(string_of_symbol_id f3)^")")
*)
  | Left_distributivity (f1,f2) -> 
      message ("LD("^(string_of_symbol_id f1)^","^(string_of_symbol_id f2)^")")
  | Right_distributivity (f1,f2) -> 
      message ("RD("^(string_of_symbol_id f1)^","^(string_of_symbol_id f2)^")")
;;

let print_axiome x = 
  try 
    let x' = retrouve_axiome_connu x in
      print_axiome_connu x'
  with Unknown_axiom ->
    match x with 
	(s,t) -> 
	  print_term s;
          print_string (Printf.sprintf " = ");
          print_term t;
      	  Format.force_newline();
      	  print_flush()
;;

let separe_axiomes_connus_inconnus l = 
  List.fold_right 
    (fun x (c,i) -> 
       try 
	 let x' = retrouve_axiome_connu x in
           (x'::c,i)
       with Unknown_axiom -> (c,x::i))
  l ([],[])
;;

(*
 Attention, a n'effectuer que sur une liste d'axiomes tries.
*)

let rec detecte_symboles_c_ac = function
    [] -> []
  | (Commutativity f)::l -> 
      let _ = redeclare_operateur_c f in
	detecte_symboles_c_ac l
  | (Associativity f as ass)::l -> 
      if (is_c f)
      then 
	begin
	  let _ = redeclare_operateur_ac f in
            detecte_symboles_c_ac l
	end
      else ass::(detecte_symboles_c_ac l)
| l -> l
;;

(*
  a n'appliquer que sur une liste triees d'axiomes connus.
*)
(*
let rec detecte_theorie_deja_AULI ((f,u,i) as fui) = function
  (Left_inverse _ as li)::l -> li::(detecte_theorie_deja_AULI fui l)
| (Right_inverse (g,v,j) as ri)::l -> 
               if (f=g) & (i=j) & (u=v)
               then (declare_theorie (G(f,u,i)); l)
               else ri::(detecte_theorie_deja_AULI fui l)
| l -> declare_theorie (AU(f,u)); (Left_inverse fui)::l
;;

let rec detecte_theorie_deja_AU ((f,u) as fu) = function
  (Right_unit _ as ru)::l -> ru::(detecte_theorie_deja_AU fu l)
| (Left_inverse (g,v,i) as li)::l ->
               if (f=g) & (u=v) 
               then detecte_theorie_deja_AULI (f,u,i) l
               else li::(detecte_theorie_deja_AU fu l)
| l -> declare_theorie (AU fu); l
;;
  

let rec detecte_theorie_deja_ALU ((f,u) as fu) = function
  (Left_unit _ as lu)::l -> lu::(detecte_theorie_deja_ALU fu l)
| (Right_unit (g,v) as ru)::l -> if (f=g) & (u=v)
                                 then detecte_theorie_deja_AU fu l
                                 else ru::(detecte_theorie_deja_ALU fu l)
| l -> declare_theorie (A f); (Left_unit fu)::l
;;

let rec detecte_theorie_deja_A f = function
  (Associativity _ as a)::l -> a::(detecte_theorie_deja_A f l)
| (Left_distributivity _ as ld)::l -> ld::(detecte_theorie_deja_A f l)
| (Right_distributivity _ as rd)::l -> rd::(detecte_theorie_deja_A f l)
| (Left_unit (g,u) as lu)::l -> if (f=g)
                                then detecte_theorie_deja_ALU (f,u) l
                                else lu::(detecte_theorie_deja_A f l)
| l -> declare_theorie (A f); l
;;

let rec detecte_theorie_deja_ACU ((f,u) as fu) = function
  (Left_unit _ as lu)::l -> lu::(detecte_theorie_deja_ACU fu l)
| (Right_unit (h,v) as ru)::l -> ru::(detecte_theorie_deja_ACU fu l)
| (Left_inverse (h,w,i) as li)::l ->
               if (f=h) & (u=w)
               then (declare_theorie (AG(f,u,i)) ; l)
               else li::(detecte_theorie_deja_ACU fu l)
| (Right_inverse (h,w,i) as li)::l ->
               if (f=h) & (u=w)
               then (declare_theorie (AG(f,u,i)) ; l)
               else li::(detecte_theorie_deja_ACU fu l)
| l -> declare_theorie (ACU(f,u)); l
;;


let rec detecte_theorie = function
  (Associativity f)::l -> detecte_theorie_deja_A f l
| (Left_unit ((f,u) as fu) as lu) ::l -> 
                if (is_ac f) 
                then detecte_theorie_deja_ACU fu l
                else lu::(detecte_theorie l)
| (Right_unit ((f,u) as fu) as ru) ::l -> 
                if (is_ac f) 
                then detecte_theorie_deja_ACU fu l
                else ru::(detecte_theorie l)
| (Left_distributivity ((f,g) as fg) as ld)::l -> 
                (try let (u,i) = (groupe_abelien f)
                     and v = (unite g) in
                     declare_theorie (CR(f,u,i,g,v));
		     l
                 with _ -> ld::(detecte_theorie l))
| (Right_distributivity ((f,g) as fg) as rd)::l -> 
                (try let (u,i) = (groupe_abelien f)
                     and v = (unite g) in
                     declare_theorie (CR(f,u,i,g,v));
		     l
                 with _ -> rd::(detecte_theorie l))
| _ -> raise Not_found
;;

let rec detecte_toutes_theories = function
  [] -> []
| l -> (* message "detecte_toutes_theories sur";
       do_list print_axiome_connu l;
       force_newline();force_newline(); *)
       try let l' = detecte_theorie l in
           let l'' = enleve_axiomes_inutiles l' in
           detecte_toutes_theories l''
       with Not_found -> l
;;

let cime_format (a,c) = 
  let (a_connus,a_inconnus) = separe_axiomes_connus_inconnus a in
  let a'_connus = detecte_symboles_c_ac (sort_axioms a_connus) in
(*
  do_list print_axiome_connu a'_connus;
  force_newline();
*)
  message ("%  File automatically generated from "^cime_pb.tptp_dir^ cime_pb.source);
    force_newline();
    message "operators";
    print_all_functions_with_arity ();
    print_all_variables ();
    force_newline();
    let a''_connus = detecte_toutes_theories a'_connus 
    in
      print_all_theories ();
      force_newline();
      begin 
	match cime_pb.unification_theories with 
     	    [] -> ()
	  | _ ->  
	      message "unification theory";
              print_theorie cime_pb.unification_theories
      end;
      message "axioms";
      List.iter 
	(function a -> 
	   let (s,t) = refabrique_equation a in
             print_string "  ";
	     Format.print_flush ();
             print_term s;
	     Format.print_flush ();
             print_string (Printf.sprintf " = ");
	     Format.print_flush ();
             print_term t;
	     Format.print_flush ();
             message ";")
      	a''_connus;
      List.iter 
	(function (s,t) -> 
	   print_string "  ";
	   Format.print_flush ();
           print_term s;
	   Format.print_flush ();
           print_string (Printf.sprintf " = ");
	   Format.print_flush ();
           print_term t;
	   Format.print_flush ();
           message ";")
      	a_inconnus;
      force_newline ();
      message "conjectures";
      List.iter 
	(function (s,t) -> 
	   print_string "  ";
 	   Format.print_flush ();
          print_term s;
           Format.print_flush ();
	   print_string (Printf.sprintf " = ");
           Format.print_flush ();
	   print_term t;
	   Format.print_flush ();
           message ";")
        c;
      force_newline ();
      message "end"
;;
*)

let is_a_distributivity_axiom = function
  | (Term(f1,[(Var x1);Term(g1,[(Var y1);(Var z1)])]),
     Term(g2,[Term(f2,[(Var x2);(Var y2)]);Term(f3,[(Var x3);(Var z3)])])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Some(g1,f1)
      else None

  | (Term(g2,[Term(f2,[(Var x2);(Var y2)]);Term(f3,[(Var x3);(Var z3)])]),
     Term(f1,[(Var x1);Term(g1,[(Var y1);(Var z1)])])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Some(g1,f1)
      else None

  | (Term(f1,[Term(g1,[(Var y1);(Var z1)]);(Var x1)]),
     Term(g2,[Term(f2,[(Var y2);(Var x2)]);Term(f3,[(Var z3);(Var x3)])])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Some(g1,f1)
      else None

  | (Term(g2,[Term(f2,[(Var y2);(Var x2)]);Term(f3,[(Var z3);(Var x3)])]),
     Term(f1,[Term(g1,[(Var y1);(Var z1)]);(Var x1)])) ->
      if (f1=f2) & (f2=f3) & (g1=g2) & 
	(x1=x2) & (x2=x3) & (y1=y2) & (z1=z3) & 
	(x1<>y1) & (x1<>z1) & (y1<>z1)
      then Some(g1,f1)
      else None

  | _,_ -> None

let rec should_be_greater_for_distributivity f g = function
  | [] -> false
  | a::la -> 
      match is_a_distributivity_axiom a with
	| None -> should_be_greater_for_distributivity f g la
	| Some(g1,f1) -> 
	    if f=f1 && g=g1
	    then true
	    else should_be_greater_for_distributivity f g la

let cime2_format (a,c) = 
  let (a_connus,a_inconnus) = separe_axiomes_connus_inconnus a in
  let a'_connus = detecte_symboles_c_ac (sort_axioms a_connus) in
  let new_cst_string =
    List.fold_left
      (fun acc s -> (string_of_symbol_id s)^"_"^acc)
      "" (listof_p_functions (function _ -> true)) in
  let new_cst1 = new_cst_string ^ "_1"
  and new_cst2 = new_cst_string ^"_2" in

  let b = ref 
	    ("let F = signature \""^
	     (all_functions_with_arity ())^
	     (if c = [] then new_cst1 ^ ", " ^ new_cst2 ^ " : 1;" else "") ^
	     "\";\n"^
	     "let X = vars \""^
	     (all_variables ())^
	     "\";\n"^
	     "let Axioms = equations F X \"")
  in
    List.iter 
	(function a -> 
	   let (s,t) = refabrique_equation a in
             b := (!b ^
		  " "^
		  (Terms.string_of_term s)^
		  " = "^
		  (Terms.string_of_term t)^
		  ";\n"))
      a'_connus;
    List.iter 
      (function (s,t) -> 
	 b := !b ^
       (" "^
        (Terms.string_of_term s)^
	" = "^
        (Terms.string_of_term t)^
         ";\n"))
      	a_inconnus;
    b := !b ^ "\";
let s = status F \"";
    begin
	match (listof_p_functions is_free) with
	    f :: l ->
	      b := !b ^ (Printf.sprintf "%s lr_lex" (string_of_symbol_id f));
	      List.iter
		(function g ->
		     b := !b ^
		 (Printf.sprintf "; %s lr_lex" (string_of_symbol_id g))) l;
	      List.iter
		(function g ->
		   b := !b ^ 
		 (Printf.sprintf "; %s mul" (string_of_symbol_id g)))
		(listof_p_functions (function f -> (is_c f) or (is_ac f)))
	  | _ ->       
	      begin
		match (listof_p_functions (function f -> (is_c f) or (is_ac f))) with
		    f :: l ->
		      b := !b ^
		    (Printf.sprintf "%s mul" (string_of_symbol_id f));
		      List.iter
			(function g ->
			    b := !b ^
			 (Printf.sprintf "; %s mul" (string_of_symbol_id g))) l
		  | _ -> ()	      
	      end
      end;
    b := !b ^ "\";\n
let p = precedence F \"";
    let sorted_list_of_function_symbols =
      List.sort
	(fun f g ->
	   let should_gr_f_g = 
	     should_be_greater_for_distributivity f g a_inconnus
	   and should_gr_g_f = 
	     should_be_greater_for_distributivity g f a_inconnus in
	     if should_gr_f_g && (not should_gr_g_f)
	     then -1
	     else 
	       if should_gr_g_f && (not should_gr_f_g)
	       then 1
	       else 
	   let o_f = occurences f in
	   let o_g = occurences g in
	     if o_f = 1 && o_g <> 1 then -1
	     else if o_f <> 1 && o_g = 1 then 1 
	     else 
	       let d = (arity g) - (arity f) in
		 if d <> 0 
		 then d 
		 else let d_o = o_f - o_g in
		   if d_o <> 0 then d_o else compare f g)
	(listof_p_functions (function _ -> true)) in
      begin
	match sorted_list_of_function_symbols with
	    f :: l ->
	       b := !b ^
	    (Printf.sprintf "%s" (string_of_symbol_id f));
	      List.iter
		(function g ->
		      b := !b ^
		 (Printf.sprintf " > %s" (string_of_symbol_id g))) l
	    | _ -> ()
	end;
	 b := !b ^ (if c = [] then " > " ^ new_cst1 ^ " > " ^ new_cst2 else "") ^ "\";
let o = ACRPO s p;
let Conjectures = equations F X \"";
	 if c = []
	 then
	   begin

	       b:=!b ^ new_cst_string ^ "_1 = " ^ new_cst_string ^ "_2"
	   end
	 else
	   List.iter 
	     (function (s,t) -> 
		b := !b ^
		(" "^
		 Terms.string_of_term s^
		 " = "^
		 Terms.string_of_term t ^
		 ";"
		 ))
             c;
       b := !b ^ "\";\n#time on;\nlet is_";
       b := !b ^ (if c = [] then "an_incoherent_theory" else "unsatisfiable");
       b := !b ^ " = prove_conj_by_ordered_completion o Axioms Conjectures;
#quit;\n";
!b
