(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: clauses.ml,v 1.6 2002/07/05 14:57:27 monate Exp $

***************************************************************************)

open Norm_theory;;
open Symbols;;
open Terms;;

type literal =
    P of (term * term)
  | M of (term * term)
;;

type clause =
    REFL
  | SYMM
  | TRANS 
  | AX of (term * term)
  | CONJ of (term * term)
  | SUB of (int * symbol_id)
;;

type cime_pb_type = 
    {
      mutable tptp_dir : string;
      mutable cime_dir : string;
      mutable source : string;
      mutable variables : var_id list;
      mutable function_symbols : (symbol_id * symbol_type * int) list;
      mutable theo : theorie_connue list;
      mutable unification_theories : theorie_connue list;
      mutable axioms : (term * term) list;
      mutable conjectures : (term * term) list
  }
;;

let cime_pb =
  {
    tptp_dir = "";
    cime_dir = "";
    source = "";
    variables = [];
    function_symbols = [];
    theo = [];
    unification_theories = [];
    axioms = [];
    conjectures = []
  };;

let add_operator_to_cime_pb t n fix s = 
  try 
    definir_operateur t n fix s 
  with _ -> ()
;;

let transform_clause = function
    P((Var x, Var y) as e)::[] -> 
      if (x=y) 
      then REFL 
      else AX e
  | M(Var x, Var y)::P(Var u, Var v)::[] 
  | P(Var u, Var v)::M(Var x, Var y)::[] ->
      if ((x=v) & (y=u))
      then SYMM
      else failwith "transform_clause 1"
  | M(Var x, Var y)::M(Var u, Var v)::P(Var z, Var w)::[] 
  | M(Var x, Var y)::P(Var z, Var w)::M(Var u, Var v)::[]
  | P(Var z, Var w)::M(Var x, Var y)::M(Var u, Var v)::[]
    ->
      if  ((x=z) & (y=u) & (v=w)) 
	|| ((x=z) & (y=w) & (v=u))
	|| ((x=z) & (y=v) & (w=u))
	|| ((x=u) & (y=z) & (v=w))
	|| ((x=u) & (y=w) & (v=z))
	|| ((x=u) & (y=v) & (w=z))
	|| ((x=w) & (y=z) & (v=u))
	|| ((x=w) & (y=u) & (v=z))
	|| ((x=w) & (y=v) & (u=z))
	|| ((x=v) & (y=z) & (w=u))
	|| ((x=v) & (y=u) & (w=z))
	|| ((x=v) & (y=w) & (u=z))
	|| ((x=y) & (v=z) & (w=u))
	|| ((x=y) & (v=u) & (w=z))
	|| ((x=y) & (v=w) & (u=z))

      then TRANS
      else failwith "transform_clause 2"
  | M(Var x, Var y)::P(Term(f,l),Term(g,k))::[]
  | P(Term(f,l),Term(g,k))::M(Var x, Var y)::[] ->
      let ar_f = List.length l 
      in
      	if ((f=g) & ((List.length k) = ar_f))
      	then 
	  let pos = ref (-1) 
          and pos' = ref (-1) 
	  in
            begin
              List.iter2
		(fun t1 t2 -> match (t1,t2) with
		     (Var u), (Var v) -> 
		       if (u=v)
		       then pos:= succ !pos
		       else 
			 begin
			   if (x=u) & (y=v)
			   then 
			     begin
			       pos:= succ !pos;
			       pos':= !pos
			     end
			   else failwith "transform_clause 3"
			 end
		   | _, _ -> failwith "transform_clause 4")
		l k;
	      SUB (!pos',f)
	   end
      else failwith "transform_clause 5"
  | M(e)::[] -> CONJ(e)
  | P(e)::[] -> AX(e)
  | _ ->  failwith "transform_clause 6" 
;;

let include_file s = ();;

let add_clause c = ();;


