(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: clauses.mli,v 1.4 2002/05/14 14:15:54 contejea Exp $

***************************************************************************)



open Norm_theory;;
open Symbols;;
open Terms;;

type literal =
    P of (term * term)
  | M of (term * term)
;;

type clause =
    REFL
  | SYMM
  | TRANS 
  | AX of (term * term)
  | CONJ of (term * term)
  | SUB of (int * symbol_id)
;;

type cime_pb_type = 
    {
      mutable tptp_dir : string;
      mutable cime_dir : string;
      mutable source : string;
      mutable variables : var_id list;
      mutable function_symbols : (symbol_id * symbol_type * int) list;
      mutable theo : theorie_connue list;
      mutable unification_theories : theorie_connue list;
      mutable axioms : (term * term) list;
      mutable conjectures : (term * term) list
  }
;;

val cime_pb : cime_pb_type;;

val transform_clause : literal list -> clause;;
val include_file : string -> unit;;
val add_clause : clause -> unit;;
val add_operator_to_cime_pb : symbol_type -> int -> fix_type -> string 
        -> unit;;






