(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: lexer.mll,v 1.4 2002/04/26 09:28:38 marche Exp $

***************************************************************************)

{

open Abs_syntax
open Parser
open Lexing

let incr_num_col n =
  etat_analyse.numero_colonne_avant <- etat_analyse.numero_colonne_apres;
  etat_analyse.numero_colonne_apres <- etat_analyse.numero_colonne_apres+n
;;

let get_last_token lexbuf =
  let lexeme = (Lexing.lexeme lexbuf)
  in 
  incr_num_col (String.length lexeme);
  etat_analyse.dernier_token_lu <- lexeme
;;

let keywords_table = 
  let kt = ((Hashtbl.create 17):(string,token) Hashtbl.t)
  in 
    List.iter  
      (function (s,k) -> Hashtbl.add kt s k)
      [
    	("include",         TOKEN_INCLUDE);
    	("input_clause",	TOKEN_INPUT_CLAUSE);
    	("equal",		EGAL)
      ];
    kt
;;

let file_name s = FILE_NAME s;;

let keyword_or_ident s =   
  try (Hashtbl.find keywords_table s)
  with Not_found -> IDENT s;;

let var s = VRB s;;

}

rule token = parse
    [' ''\t']  		{ incr_num_col 1;
                          token lexbuf }
  | ('%'[^'\n']*)?'\n'	{ etat_analyse.numero_ligne <- etat_analyse.numero_ligne+1;
                          etat_analyse.numero_colonne_avant <- 0;
                          etat_analyse.numero_colonne_apres <- 0;
                          token lexbuf }
  | '\''['a'-'z''A'-'Z''0'-'9''_''-''/''.''+']*'\'' 
                        { get_last_token(lexbuf); 
                          file_name(Lexing.lexeme lexbuf) }
  | ['A'-'Z']['a'-'z''A'-'Z''0'-'9''_''\'''+']* 
                        { get_last_token(lexbuf); 
                          var(Lexing.lexeme lexbuf) }
  | ['a'-'z''0'-'9']['a'-'z''A'-'Z''0'-'9''_''\'''+']*
			{ get_last_token(lexbuf);
			  keyword_or_ident(Lexing.lexeme lexbuf) }
  | '+''('['a'-'z''A'-'Z''0'-'9''_''\'']*')'
			{ get_last_token(lexbuf);
			  keyword_or_ident(Lexing.lexeme lexbuf) }
  | "++"            	{ get_last_token(lexbuf); PLUS }
  | "--"            	{ get_last_token(lexbuf); MOINS }
  | ','            	{ get_last_token(lexbuf); VIRGULE }
  | ';'            	{ get_last_token(lexbuf); POINT_VIRGULE }
  | '.'            	{ get_last_token(lexbuf); POINT }
  | '('            	{ get_last_token(lexbuf); PARGAUCHE }
  | ')'            	{ get_last_token(lexbuf); PARDROITE }
  | '['            	{ get_last_token(lexbuf); CROGAUCHE }
  | ']'            	{ get_last_token(lexbuf); CRODROIT }
  | '\''            	{ get_last_token(lexbuf); QUOTE }
  | eof			{ get_last_token(lexbuf); FIN }



