(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: norm_theory.mli,v 1.4 2002/05/14 14:15:54 contejea Exp $

***************************************************************************)


open Symbols;;

(*=========================================

La th\'eorie canonique modulo laquelle on travaille est m\'emoris\'ee
dans une variable globale.

=========================================*)

type axiome_connu =
    Commutativity of symbol_id
  | Associativity of symbol_id
(*
  | Left_unit of (symbol_id * symbol_id)
  | Right_unit of (symbol_id * symbol_id)
  | Idempotency of symbol_id
  | Nilpotency of (symbol_id * symbol_id * int)
  | Left_inverse of (symbol_id * symbol_id * symbol_id)
  | Right_inverse of (symbol_id * symbol_id * symbol_id)
*)
  | Left_distributivity of (symbol_id * symbol_id)
  | Right_distributivity of (symbol_id * symbol_id)
;;

type theorie_connue =
    No_theory 
  | A of symbol_id 
  | AU of (symbol_id * symbol_id)
  | ACU of (symbol_id * symbol_id)
  | ACI of symbol_id
  | ACUI of (symbol_id * symbol_id)
  | ACUN of (symbol_id * symbol_id * int)
  | G of (symbol_id * symbol_id * symbol_id)
  | AG of (symbol_id * symbol_id * symbol_id)
  | CR of (symbol_id * symbol_id * symbol_id * symbol_id * symbol_id)
(*
| BR of symbol_id * symbol_id * symbol_id * symbol_id 
| FP of int * symbol_id * symbol_id * symbol_id * symbol_id * symbol_id
*)
;;

type description_theorie_canonique =
    {
      mutable theories : theorie_connue list;
      mutable derniere_theorie_ajoutee : theorie_connue
    }
;;

val groupe_abelien : symbol_id -> symbol_id * symbol_id;;

val unite : symbol_id -> symbol_id;;

val declare_theorie : theorie_connue -> unit;;

(*
val enleve_axiomes_inutiles : axiome_connu list -> axiome_connu list;;
*)
val print_all_theories : unit -> unit;;

val print_theorie : theorie_connue list -> unit;;

val string_of_theorie : theorie_connue -> string;;







