(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: pretty_printing.ml,v 1.4 2002/05/14 14:15:54 contejea Exp $

***************************************************************************)


open Lexer;;
open Parser;;
open Symbols;;
open Terms;;

(*===========================================

Affichage d'un terme dans des box imbriquees.

===========================================*)


(*==================================================
Affichage d'un terme aplati dans une box.
Format pour parsing (sous reserves que le parser
                     ignore \n et \t            ).
===================================================*)


let rec pprint_term1 = function
    Term(f,[])   -> print_string (string_of_symbol_id f)
  | Var x        -> print_string (string_of_var_id x)
  | Term(f,s::l) -> 
      if is_infix f
      then 
	begin
          pprint_term2 s;
          Format.print_break 0 0;
          pprint_infix_term f l
        end
      else 
	if is_postfix f 
        then 
	  begin
            print_string "(";
            pprint_term1 s;
            pprint_lterm l;
            print_string (string_of_symbol_id f)
          end
        else 
	  begin
            print_string (string_of_symbol_id f);
            print_string "(";
            pprint_term1 s;
            pprint_lterm l
          end

and pprint_term2 = function
    Term(f,[])	  -> print_string (string_of_symbol_id f)
  | Var x          -> print_string (string_of_var_id x)
  | Term(f,s::l) -> 
      if is_infix f
      then 
	begin
          print_string "(";
          pprint_term2 s;
          Format.print_break 0 0;
          pprint_infix_term f l;
          print_string ")"
        end
      else 
	if is_postfix f 
        then 
	  begin
            print_string "(";
            pprint_term1 s;
            pprint_lterm l;
            print_string (string_of_symbol_id f)
          end
        else 
	  begin
            print_string (string_of_symbol_id f);
            print_string "(";
            pprint_term1 s;
            pprint_lterm l
          end

and pprint_infix_term f = function
    []	-> ()
  | s::l -> 
      begin
        print_symbol_id_with_spaces f;
        Format.print_break 0 0;
        pprint_term2 s;
        pprint_infix_term f l
      end


and print_symbol_id_with_spaces f =
  let t = string_of_symbol_id f in
    match t with
     	"+" | "." | "*" -> print_string t
      | _ -> 
	  begin
            print_string " ";
            print_string t;
	    print_string " ";
            Format.print_break 1 0
          end

and pprint_lterm = function
    []   -> print_string ")"
  | t::l -> begin 
      print_string ",";
      Format.print_break 0 0;
      pprint_term1 t;
      pprint_lterm l
    end
;;


(*===================================================*)

let print_term t = 
  begin
    Format.open_hovbox 0;
    pprint_term1 t;
    Format.print_flush ();
    Format.close_box ()
  end
;;

(*===========================================

Conversion d'une chaine de caracteres en terme

Effectu\'ee par la grammaire dans parser.mly 

============================================*)



let term_of_string s =
  let lexbuf = Lexing.from_string (s ^ ";") in
    Parser.term_line Lexer.token lexbuf
;;


