(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: symbols.mli,v 1.6 2002/07/03 16:28:11 monate Exp $

***************************************************************************)

(*===========================

abstract types for symbols

============================*)

type symbol_id 
type var_id

type symbol_type = 
  VARIABLE | FREE | AC | C 


type fix_type = 
  PREFIX | INFIX | POSTFIX | DEFAULT



val not_a_symbol_id : symbol_id

val first_symbol_var : unit -> var_id

val next_symbol_var : unit -> var_id

(* built-in laws for function symbols *)
val is_ac	: symbol_id -> bool
val is_c	: symbol_id -> bool
val is_free	: symbol_id -> bool

(* extract the list of ac, resp. unary, function symbols. The argument
is the largest possible function symbol *)
val listof_p_functions : (symbol_id -> bool) -> symbol_id list
val listof_ac_functions	: unit -> symbol_id list
val print_listof_functions	: symbol_id list -> unit


val symbol_id_of_string : string -> symbol_id

(*

(var_id_of_string s) retourne le var_id correspondant a la
chaine 's', leve l'exception Not_found s'il n'existe pas

*)

val var_id_of_string : string -> var_id

val string_of_symbol_id : symbol_id -> string

val string_of_var_id : var_id -> string

val arity : symbol_id -> int

val occurences : symbol_id -> int

val is_infix : symbol_id -> bool

val is_postfix : symbol_id -> bool

val definir_operateur : 
  symbol_type -> int -> fix_type -> string -> unit

val redeclare_operateur_c : symbol_id -> unit

val redeclare_operateur_ac : symbol_id -> unit

val plus_grand_numero_de_symbole : unit -> int

(*

(get_symbol_id s) retourne le symbol_id correspondant a la chaine s.

si s non declare : erreur
si s declare mais correspond a une variable : erreur specifique

*)

val get_symbol_id : string -> symbol_id

val print_all_variables : unit -> unit

val print_all_functions_with_arity : unit -> unit

val all_variables : unit -> string

val all_functions_with_arity : unit -> string
