(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: terms.ml,v 1.4 2002/05/14 14:15:54 contejea Exp $

***************************************************************************)


open Symbols;;

type term = 
    Var of var_id 
  | Term of symbol_id * (term list)
;;

let first_var () = Var (first_symbol_var ());;
let next_var () = Var (next_symbol_var ());;


let rec flatten_term_list f = function
  []		    -> []
| (Term(g,l) as t)::m -> if g=f
                       then l @ (flatten_term_list f m)
                       else t::(flatten_term_list f m)
| v::m	            -> v::(flatten_term_list f m);;


let head_flatten_term = function
    Term(f,l) as t-> if is_ac f
      	       	       	then Term(f,(flatten_term_list f l))
			else t
  | v            -> v;;


let rec flatten_term = function
  Term(f,l) -> (head_flatten_term (Term(f,(List.map flatten_term l))))
 | v -> v;;

(*===========================================
Conversion d'un terme en chaine de caracteres
===========================================*)

let rec string_of_term = function
   Term(f,[])   -> string_of_symbol_id f
 | Var x          -> string_of_var_id x
 | Term(f,s::l) -> if is_infix f
                   then (string_of_term2 s) ^ (string_of_infix_term f l)
                   else if is_postfix f
                        then (string_of_lterm (s::l)) ^ (string_of_symbol_id f)
                        else (string_of_symbol_id f) ^ (string_of_lterm (s::l))


and string_of_term2 = function
   Term(f,[])	  -> string_of_symbol_id f
 | Var x          -> string_of_var_id x
 | Term(f,s::l) -> if is_infix f
                   then "("^(string_of_term2 s)^(string_of_infix_term f l)^")"
                   else if is_postfix f
                        then (string_of_lterm (s::l)) ^ (string_of_symbol_id f)
                        else (string_of_symbol_id f) ^ (string_of_lterm (s::l))

and string_of_infix_term f = function
   []	-> ""
 | s::l	-> (string_of_symbol_id_with_spaces f) ^
           (string_of_term2 s) ^ 
           (string_of_infix_term f l)

and string_of_symbol_id_with_spaces f =
   let t = string_of_symbol_id f in
     match t with
     "+" | "." | "*" -> t
    | _ -> " "^t^" "
 
and string_of_lterm = function
  []   -> "()"
| t::l -> 
  let rec str_of_lterm_aux = function
     []   -> ")"
   | t::l -> ","^(string_of_term t)^(str_of_lterm_aux l)
  in  "("^(string_of_term t)^(str_of_lterm_aux l);;

















